use CC::Agent;

  $SERVER = "localhost";

  open(O,"/etc/inetd.conf");
  while ($l = <O>) {
    if ($l =~ /^ *rasd\s/) {
      $inetd = $l;
      last;
    }
  }
  close(O);

  open(O,"/etc/services");
  while ($l = <O>) {
    if ($l =~ /^ *rasd\s/) {
      $service = $l;
      last;
    }
  }
  close(O);
  if (!$inetd) {
     print "Error: No rasd entry in /etc/inetd.conf!\n";
     $err = 1;
  } 
  if (!$service) {
     print "Error: No rasd service in /etc/services\n";
     $err = 1;
  } 
  exit if ($err);
  
  $service =~ /rasd\s+(\d+)\/tcp/;
  $port = $1;
  print "Using port=$port\n";

  if (!($agent = CC::Agent::new("$SERVER:$port", "chris60"))) {
     print "ERROR: Cannot connect to RASd daemon: $CC::Agent::error\n";
  }
  if (!($ans =$agent->get("test"))) {
     print "ERROR: $CC::Agent::error\n";
  }

  if (!($agent = CC::Agent::new("$SERVER:$port", "chris60"))) {
     print "ERROR: Cannot connect to RASd daemon: $CC::Agent::error\n";
  }
  if (!($config =$agent->get("config"))) {
     print "ERROR reading config-file: $CC::Agent::error\n";
  } else {
     print "found config file: size=" . length($config) . "\n";
  }

  if ($ans =~ /running/) {
    print "RASd daemon is working!\n";
    exit;
  } else {
    print "RASd daemon is NOT working, check /etc/inetd, /etc/services and the permissions!\n";
  }
