package TOPOAgent;

#  $Name:  $
#  $Id: TOPOAgent.pm,v 1.15 2001/10/17 22:37:56 ccadieux Exp $
use Agent;
use PDM;
use PDM::Modules;
use Carp;
use vars qw($AUTOLOAD);
use Report;
use strict;
use TO;
use Debug;
use base 'Agent';
use vars qw( %RAID);

sub isSelectable {"Topology (SunOS 2.8 only)"}

sub revision {'$Revision: 1.15 $'}

sub new {
  my($self) = Agent->new();

  bless ($self, 'TOPOAgent');
  return $self;
}
sub DESTROY {}

sub RUN {
  my($agent, $ras_flag) = @_;
  my($mod, @mods, $x, @writes, @reads, $report);
  my($a5, $t3, $sw, $sum, @fc, $l);

  my($cache) = 0;
  my($pdm) = $agent->{pdm};
  $DB::single=1;
  if (!$agent->category_selected() ) {
     Debug->print2("Skipping " . ref($agent)  . ".");
     return;
  }

  return if (!TO->available());

  Timelapse->start(ref($agent));

  my($renv) = System->get_renv();
  $report = {};

  my $logfile = $renv->{logfile};
  my $reboot  = System->lastReboot();
  my $age     = Util->get_file_created(
                   System->get_home() . "/DATA/topo/" . $renv->{hostname});

  if (0) {
   if ($age && $reboot > $age) { 
     Debug->print2("Reboot after last topo, clearing topo/cache.");
#     TO->clearTopo();
   }
  } 
#    elsif (-r $logfile) {
#    my($err, $lines) = $agent->read_log_file($logfile,'NEW');
#    foreach my $l (@$lines) {
#      if ($l =~ /ONLINE/) {  # re-create topology
#         Debug->print2("Found ONLINES, clearing topo/cache.");
#         TO->clearTopo();
#         last;
#      }
#    }
#  }
  
  my($age) = TO->lastTopo();
  my $run = 0;
  my $h = PDM->getCacheHandle("incomplete_topo");
     
  if (!$age || $h->{try}) {  # new or one week old topo
     if (!$age) {
        Debug->print2("Building new topo.");
     } else {
        $h->{try}-- ;
        Debug->print2("Building new topo: topo is incomplete.");
     }
     TO->clearTopo();
     my($report) = TO->readTopo();

     if (!$report) {
        Debug->print2("TOPOAgent: topology is empty!");
        Timelapse->stop(ref($agent));
        return;
     }
     my($id) = {  accessName  => "topo",
           deviceName  => "topo",
           name        => "topo",
           category    => Report::CAT_TOPO,
           ip          => "",
           };

     $pdm->saveReport( Report->new($id, $report , undef) );
  } else {
     Debug->print2("Using existing topo.");
  }
  Timelapse->stop(ref($agent));
}



1;



