package Events;
#  $Name:  $ 
#  $Id: Events.pm,v 1.7 2001/08/08 23:25:18 ccadieux Exp $


use Carp;
use Data::Dumper;
use NWS::Host;
use CIM::Instance;
use Ilist;

#
#  source = 'R': Rasagent, D = 'Device';
#  $ed = Events->eventDetector({ event => $ev, host => 1});

sub sourceDetector {
  my($class, $arg) = @_;
  my($host, $agentHost);

  my($event) = $arg->{event};
  my($renv) = System->get_renv();
  my($agent) = CIM::Instance->new('NWS_Agent', [
                       [Name => "SUNWrasag." . System->hostid() ],
                       [Version => $renv->{version}  || "2.1"],
                       [PollingFrequency => $renv->{frequency}],
                        ]);
                 
  my($detect) = CIM::Instance->new('NWS_EventDetector', [
                [Event => $event  ],
                [Agent => $agent] ]);
  
  my($source) = CIM::Instance->new('NWS_EventSoftwareSource', [
                [Event => $event   ],
                [Source => $agent] ]);

  if ($arg->{host}) {
    $host  = NWS::Host->newSystem($arg->{rep} );
    $agentHost = CIM::Instance->new('NWS_AgentOnHost', [
                [Agent  => $agent      ],
                [Host   => $host->[0] ] ]);
    return Ilist->new([$agent, $detect, $source, @$host, $agentHost]);

  } else {
    return Ilist->new([$agent, $detect, $source]);
  }
}


#  $ed = Events->eventDetector({ event => $ev, soft => "ST4"});

sub softSourceDetector {
  my($class, $arg) = @_;
  my($host, $agentHost);
  my($renv) = System->get_renv();

  my($agent) = CIM::Instance->new('NWS_Agent', [
                       [Name => "SUNWrasag." . System->hostid() ],
                       [Version => $renv->{version} || "2.1"],
                       [PollingFrequency => $renv->{frequency}],
                        ]);

  my($soft) = CIM::Instance->new('NWS_SoftwareElement', [
                       [Name => $arg->{soft} . "." . System->hostid() ]
                        ]);
                 
  my($detect) = CIM::Instance->new('NWS_EventDetector', [
                [Event => $arg->{event}],
                [Agent => $agent] ]);
  
  my($source) = CIM::Instance->new('NWS_EventSoftwareSource', [
                [Event => $arg->{event}],
                [Source => $soft] ]);

  if ($arg->{host}) {
    $host  = NWS::Host->newSystem($arg->{rep});
    $agentHost = CIM::Instance->new('NWS_AgentOnHost', [
                [Agent  => $agent      ],
                [Host   => $host->[0] ] ]);
    return Ilist->new([$agent, $soft, $detect, $source, @$host, $agentHost]);

  } else {
    return Ilist->new([$agent, $soft, $detect, $source]);
  }
}

1;

