package Fibre::ByDisk;

use Util;
use System;
use FibreStat;
use FibreGUI;
use Data::Dumper;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC

#Feb 21 09:27:28 invader scsi: [ID 107833 kern.warning] WARNING: /pci@6,2000/pci@2/SUNW,qlc@4/fp@0,0/ssd@w220000203722c4bd,0 (ssd251):
# invader genunix: [ID 408114 kern.info] /pci@6,2000/pci@2/SUNW,qlc@5/fp@0,0/ssd@w22000020371b6583,0 (ssd93) offline

sub read_mess {
  my($q) = @_;
  print "</center><pre>";
  $D = System->get_home() . "/DATA/OLD_REPORTS";
  opendir(O, $D);

  @reps = readdir(O); closedir(O);
  my(%ENC);
  foreach $r (@reps) {
     if (substr($r,0,3) eq "a5k") {
        $rep = Report->read($r);

        $name = $rep->name();
        $vals = $rep->value();
        foreach $k (keys %$vals) {
          if ($k =~ /\.wwn/) {
            my(@c) = split(/\./, $k);
            if ($c[0] eq "disk_front") {
               $c[0] = "f";
            } elsif ($c[0] eq "disk_rear") {
               $c[0] = "r";
            } else {
               next;
            }
            my($key) = [$name, sprintf("%s%2.2d", $c[0], $c[1])];
            $ENC{substr($vals->{$k},2)} = $key;
          }
        }
     }
  }
#print Dumper(\%ENC);
  
  %M = ();
  foreach $x (keys %$q) {
    if (substr($x,0,5) eq "file_") {
        $file = substr($x,5);
        print "Reading '$file' ...\n";
        open(O, "/var/adm/$file");
        $cnt++;
        while ($l = <O>) {
            if ($l =~ /scsi: .*WARNING:/) {                   # write warning => 0
               $cnt++;
               ($year, $month, $day) = &get_date($l);
               $l =~ /WARNING: (.*)\@w([0-9a-f]+)/;
               $path = $1;
               $ix = rindex($path , "/");
               $path = substr($path, 0, $ix) if ($ix > 0);
               if ($2) {
                 $wwn = substr($2,2);
                 $v1 = $ENC{$wwn};
                 if ($v1) {
                     $M{$path}{$v1->[0]}{$v1->[1]}[0]++;
                 }
               }
            } elsif ($l =~ /\@w([0-9a-f]+).*\(.*\) offline/) {  # offline => 1
               $cnt++;
               $ix = index($l, "]");
               next if ($ix < 0);
               $path = substr($l, $ix+2);
               $ix = index($path, "\@w");
               $path = substr($path, 0, $ix);
               $ix = rindex($path , "/");
               $path = substr($path, 0, $ix) if ($ix > 0);

               $wwn = substr($1,2);
               $v1 = $ENC{$wwn};
               if ($v1) {
                  $M{$path}{$v1->[0]}{$v1->[1]}[1]++;
               }
            }
        }
    }
  }
   $Data::Dumper::Indent = 1;
#  print Dumper(\%M);
  &graph(\%M);
  print "Done.";
  
}

sub mess {
  my($q) = @_;

  print "<body bgcolor=#F0F0F0><center>";
  print "<table border=0 width=80%><tr><td><font color=navy size=+2>Message Patterns</font>
    </table>";
  if ($q->{ACTION} eq "Run") {
     &read_mess($q);
     return;
  }
  opendir(O, "/var/adm/");
  @a = readdir(O);
  print "
  <form><input type=hidden name=GO value=Fibre::ByDisk::mess>
   <table border=1 cellspacing=0 bgcolor=white width=80%>
  <tr bgcolor=#666699><td colspan=5><font color=white><b>Select Message Files</td>
  <tr><th>Select
      <th>File
      <th>Size
      <th>First Access
      <th>Last Access
  ";
  $today = Util->today("YMDH");
  foreach $f (@a) {
    if (substr($f,0,8) eq "messages") {
      $created = Util->get_file_created("/var/adm/$f");
      my(@stats) = stat("/var/adm/$f");
      $size = sprintf("%.1f", $stats[7] / 1000000);
      open(O, "/var/adm/$f");
      $first = <O>; close(O);
      ($year, $month, $day) = &get_date($first);

      $firstD = sprintf("%d-%2.2d-%2.2d", $year, $month,$day);
      print "<tr><td><center><input type=checkbox name=file_$f>
                 <td>&nbsp;$f
                 <td>&nbsp;$size Meg
                 <td>&nbsp;$firstD
                 <td>&nbsp;$created</td>";
    }
  }
  print "</table><b>";
  print "<input type=submit name=ACTION value=Run>
 </form>";
}

sub get_date {
  my($first) = @_;
  my(@b) = split(/\s+/, $first);
  my($month) = $Util::MTH{$b[0]};
  my($day)   = $b[1];
  my($year)  = ($month <= substr($today,5,2)) ? 2001:2000;
  return ($year, $month, $day);
}

sub run {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);

  my($a5, $sw, $t3) = &FibreGUI::findSelected();
  my($debug) = 0;
  my($cache) = 0;
  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allA5) = "<select name=A5>";
  $q->{A5} = "*List" if (!$q->{A5});
  $allA5 .= ($q->{A5} eq "*List") ? "<option selected>*List": "<option>*List";
  
  foreach $d (@$devs) {
     if ($d->{type} eq "a5k") {
       $first = "$d->{name}" if (!$first);
       $allA5 .= ($d->{name} eq $q->{A5})? "<option selected>$d->{name}":"<option>$d->{name}";
     }
  }
  $allA5 .= "</select>";

  if ($q->{A5} eq "*List") {
     $list = join(",", @$a5);
  } elsif ($q->{A5}) {
     $list = $q->{A5};
  }
  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = A5KAgent->FCCounters({ cache => $cache, encs => $list});

  my($BDF) = System->get_home() . "/DATA/tmp/byDiskReset.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     $out = FibreGUI::countersToString({skipzero => 0}, $x);
     open(O, ">$BDF");
     print O $out;
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); $line = <O>; close(O);
     ($date, $reset) = FibreGUI::countersParse($line);
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   @X = ();
   foreach $e ('f','r') {
     for ($x1=0; $x1 <= 10; $x1++) {
        push(@X, sprintf("$e%2.2d", $x1));
        $title = ($e eq "f")? "front":"rear";
        $e0=uc($e);
        $xvalues .= sprintf("$e0%2.2d=$title disk $x1,", $x1);
     }
   }
   push(@X, "s01"); push(@X, "s02");
   $xvalues .= "s01=Ses 1,s02=Ses 2,";

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth - 25;
  var a_height =  window.innerHeight * 0.80;
  window.document.writeln(
   '<applet  $FibreGUI::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>

<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=FibreGUI::test2&option=2&">
<param name=urlY value="/?GO=FibreGUI::test2&option=2&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);
#   $q->{hba} = 0 if (!$q->{hba});
   $hbas = "";
   foreach $line (sort @$x) {
     if (substr($line,0,1) eq "#") {
        @c = split(/=/, $line);
        $c[1] =~ s/\/devices//;
        $HBA[substr($c[0],1)] = $c[1];
        $hbas .= substr($c[0],1) . "=$c[1]|";
        next;
     }
     @b = split(/\t/, $line);
     next if ($q->{hba} ne ""  && $b[0] != $q->{hba}); # first hba only
     @c = split(/\|/, $b[0]);
     next if (substr($c[2],0,1) eq "-");
#     $enc = $c[1] . "-" . substr($c[2],0,4);
     $enc =  $c[0] . "-" .$c[1];
     $enc =~ s/ //g;
     $ENC2[$enc] = $c[1] ." " .  $HBA[$c[0]];
     $disk = $c[2];
     for ($j=0; $j <= 5; $j++) {
       $D{$enc}{$disk}[$j] += $b[$j+1];
     }
   }
   chop($hbas);
   $stack_cnt = 1;
   $gc = 1;

   foreach $enc (sort keys %D) {
     $enc0 = $enc;
     $enc0 = "Enc-" . uc($enc) if (length($enc) == 1);
     $applet .= "<param name=title$stack_cnt value=\"$enc0=$ENC2[$enc]\">";
     $seq_data = $link_data = $sync_data = $word_data = $crc_data = $sig_data = "";
     foreach $disk (@X) {
       @reset1 = split(/\//, $reset->{$enc}{$disk});
       $link_data .= ($D{$enc}{$disk}[0] - $reset1[0]) . ",";   
       $sig_data  .= ($D{$enc}{$disk}[1] - $reset1[1]) . ",";   
       $seq_data  .= ($D{$enc}{$disk}[2] - $reset1[2]) . ",";   
       $crc_data  .= ($D{$enc}{$disk}[3] - $reset1[3]) . ",";   
       $sync_data .= ($D{$enc}{$disk}[4] - $reset1[4]) . ",";   # sync
       $word_data .= ($D{$enc}{$disk}[5] - $reset1[5]) . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     chop($sig_data); chop($crc_data);

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="cyan">
<param name=graph$gc value="$link_data">
<PARAM name=label$gc value="Link-Fail">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="green">
<param name=graph$gc value="$sig_data">
<PARAM name=label$gc value="Sign-Loss">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Inv TXWord">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$crc_data">
<PARAM name=label$gc value="Inv-CRC">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="white">
<param name=graph$gc value="$seq_data">
<PARAM name=label$gc value="Inv-Seq">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   if ($created) {
     $title = "Error Counters since $created by Enclosure/Disk";
   } else {
     $title = "All Error Counters by Enclosure/Disk";
   }
   $sel = Util->makeSelect("hba", "=All|$hbas", $q->{hba});
   print "&nbsp;
    <table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td>
    <table border=0 cellspacing=0 cellpadding=0 width=100% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=FibreGUI::test2>
      <input type=hidden name=option value=2>
    <tr bgcolor=#666699>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>
       <td align=right><font color=white><b>
     Select A5K: $allA5 &nbsp;
     HBA: $sel <input type=submit name=ACTION value=Refresh>&nbsp;</td>
    <tr bgcolor=black>
       <td colspan=2 nowrap><center><table border=0><tr><td><font color=white><b>&nbsp;$title</table></td>
    <tr><td colspan=2><center>$applet</td>
    </table></table></form>";
  
}



#
#  USED BY MESSAGE PATTERNS
#

sub graph {
  my($Q) = @_;

   @X = ();
   foreach $e ('f','r') {
     for ($x1=0; $x1 <= 10; $x1++) {
        push(@X, sprintf("$e%2.2d", $x1));
        $title = ($e eq "f")? "front":"rear";
        $e0=uc($e);
        $xvalues .= sprintf("$e0%2.2d=$title disk $x1,", $x1);
     }
   }

   $cnt= 0;
   foreach $hba (sort keys %$Q) {
       $p = $Q->{$hba};
       foreach $enc (keys %$p) {
         $cnt++;
       }
   }
   $height = $cnt * 100;
#  var a_height =  window.innerHeight * 0.80;

  $sc0 = "<applet  $FibreGUI::APPLET height=200 width=600>";
  $sc =<<EOF;
  <script>
  var a_width =  window.innerWidth - 25;
  var a_height =  $height;
  window.document.writeln(
   '<applet  $FibreGUI::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>
EOF
  $applet =<<EOF;
$sc
<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=FibreGUI::test2&option=2&">
<param name=urlY value="/?GO=FibreGUI::test2&option=2&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);
   my(%H);
   my($hba_cnt) = 0;
   $stack_cnt = 1; $gc = 1;

   foreach $hba (sort keys %$Q) {
       $p = $Q->{$hba};
       print "$hba_cnt = $hba\n";
       foreach $enc (keys %$p) {
          $enc0 = $enc;
          $enc0 = "Enc-" . uc($enc) if (length($enc) == 1);
          $applet .= "<param name=title$stack_cnt value=\"$hba_cnt-$enc0=$enc0 on $hba\">";

          $p1 = $p->{$enc};
          $off_data = ""; $w_data = "";
          foreach $disk (@X) {
             $w_data .= $p1->{$disk}[0] . ",";
             $off_data .= $p1->{$disk}[1] . ",";
          }
          chop($data);
          $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$w_data">
<PARAM name=label$gc value="WriteErrors">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
          $gc++;
          $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$off_data">
<PARAM name=label$gc value="Offline">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
          $gc++;
          $stack_cnt++;
       }
       $hba_cnt++;
   }
       
   $applet .= "</applet>\n";

   print "<table border=0 cellspacing=0 cellpadding=3 width=100%>
    <tr><td bgcolor=#666699><b><font color=white>Errors in /var/adm/messages
    <tr><td>$applet
    </table>";
}

1;
