package Fibre::ByDiskSw;

use Util;
use System;
use FibreStat;
use Data::Dumper;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC


sub run {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);
  my($BDF) = System->get_home() . "/DATA/tmp/byDiskSwReset";

  my($a5, $sw, $t3) = &FibreGUI::findSelected();
  my($list) = join(",", @$a5);
  my(@x);
  my(%I);
  foreach my $data (@$sw) {
     my(@ip) = split(/:/, $data);
     $I{$ip[1]} = $ip[0];
     ($x0, $summ) = FibreStat::sw_luxdisc($q,{ip => $ip[1], cache => 0});
     push(@x, @$x0);     
  }
  if ($q->{ACTION} eq "ClearCounters") {
     $out = FibreGUI::countersToString({skipzero => 0}, \@x);
     open(O, ">$BDF");
     print O $out;
     close(O);
  } elsif ($q->{ACTION} eq "TotalCounters") {
     unlink $BDF;
  }
  my($created) = "";
  if (-r $BDF) {
     open(O, $BDF); $line = <O>; close(O);
     ($date, $reset) = FibreGUI::countersParse($line);
     $created = Util->get_file_created($BDF);
     $created = " (<small>" . substr($created, 5) . "</small>)";
  }

   @X = ();
   for ($x1=1; $x1 <= 16; $x1++) {
        push(@X, sprintf("p%2.2d", $x1));
        $xvalues .= sprintf("%2.2d=port $x1,", $x1);
  }

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth - 25;
  var a_height =  window.innerHeight * 0.80;
  window.document.writeln(
   '<applet  $FibreGUI::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>
<param name=xTitle value="Ports">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=FibreGUI::test2&option=9&">
<param name=urlY value="/?GO=FibreGUI::test2&option=9&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,port,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);
#   $q->{hba} = 0 if (!$q->{hba});
   $hbas = "";
   foreach $line (sort @x) {
     if (substr($line,0,1) eq "#") {
        @c = split(/=/, $line);
        $c[1] =~ s/\/devices//;
        $HBA[substr($c[0],1)] = $c[1];
        $hbas .= substr($c[0],1) . "=$c[1]|";
        next;
     }
     @b = split(/\t/, $line);
     @c = split(/\|/, $b[0]);
     $enc =  $c[1];

     $port = $c[2];
     for ($j=0; $j <= 5; $j++) {
       $D{$enc}{$port}[$j] += $b[$j+1];
     }
   }
   chop($hbas);
   $stack_cnt = 1;
   $gc = 1;

   foreach $enc (sort keys %D) {
     $applet .= "<param name=title$stack_cnt value=\"$I{$enc}=$enc\">";
     $seq_data = $link_data = $sync_data = $word_data = $crc_data = $sig_data = "";
     $enc1 = "-$enc";
     foreach $disk (@X) {
       @reset1 = split(/\//, $reset->{$enc1}{$disk});
       $xx = $D{$enc}{$disk};
       $link_data .= ($D{$enc}{$disk}[0] - $reset1[0]) . ",";   
       $sig_data  .= ($D{$enc}{$disk}[1] - $reset1[1]) . ",";   
       $seq_data  .= ($D{$enc}{$disk}[2] - $reset1[2]) . ",";   
       $crc_data  .= ($D{$enc}{$disk}[3] - $reset1[3]) . ",";   
       $sync_data .= ($D{$enc}{$disk}[4] - $reset1[4]) . ",";   # sync
       $word_data .= ($D{$enc}{$disk}[5] - $reset1[5]) . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     chop($sig_data); chop($crc_data);

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="cyan">
<param name=graph$gc value="$link_data">
<PARAM name=label$gc value="Lnk Fail">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="green">
<param name=graph$gc value="$sig_data">
<PARAM name=label$gc value="Signal">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Invalid-Word">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$crc_data">
<PARAM name=label$gc value="CRC">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   if ($created) {
     $title = "Error Counters since $created by Port";
   } else {
     $title = "All Error Counters by Port";
   }
   print "&nbsp;
    <table border=1 cellspacing=0 cellpadding=0 width=100%><tr><td>
    <table border=0 cellspacing=0 cellpadding=0 width=100% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=FibreGUI::test2>
      <input type=hidden name=option value=9>
    <tr bgcolor=#666699>
       <td nowrap><b><font color=white>&nbsp;<input type=submit name=ACTION value=ClearCounters>$created &nbsp;
          <input type=submit name=ACTION value=TotalCounters></td>
       <td align=right><font color=white><b><input type=submit name=ACTION value=Refresh>&nbsp;</td>
    <tr bgcolor=black>
       <td colspan=2 nowrap><center><table border=0><tr><td><font color=white><b>&nbsp;$title</table></td>
    <tr><td colspan=2><center>$applet</td>
    </table></table></form>";
  
}


1;
