package Fibre::Rules::Rule1;
use TObjects;
use Data::Dumper;

# WRITE
sub description {
  return "iPort CRC error in switch";
}


sub category {
  return "CRC";
}

sub run {
  my($class, $th, $count, $key, $info, $reads, $writes) = @_;

  my($hba, $name, $port, $type) = split(/\|/, $key);
  return(undef,undef) if ($type ne "s");

  $port = substr($port,1) + 0;

 
  $sw_no = $TO::NamesH->{"s:$name"};
  
  $sw = $TO::Switches->[$sw_no];
  
  $info = $sw->{info};

#  print "name = $info->{name}<br>";
 
  $port_info = $sw->{port_info};
  
  $port_type = ($port_info->[$port]{RegisterName} =~ /-ip\d\(/) ? "i" : "d";

#  print "port $port type = $port_type<br>";
  return (undef,undef) if ($port_type ne "i"); 

  $links = $sw->{port};
  $link  = $links->[$port];

  my($ltype, $hno, $pno) = split(/:/, $link);

  if ($ltype ne "h") { # not pointing to a host, error
     return ("Error: iport is not pointing to a host", undef);
  }
  my($level, $cnt, $desc, $mins) = 
              $th->test("counters","rule1","$name.$port" , 1);

  if ( $level eq "E") { # error level threshold fired
    print "$cnt, $desc, $mins<br>";
    print "   <b><font color=red>Rule 1 fired</font></b>\n";
    $host = $TO::Hosts->[$hno];

    $hbas = $host->{port_info};
  
    $hba = $hbas->[$pno];
 
    $o = Dumper($hba);
    Fibre::Rules->log(1, 
           $host->{info}{name} . ":" . $pno,
           "s:$name:$port", 
           "Hba or Iport", $reads, $writes);

    print "   <b>Origin Point</b>: Hba $pno on $host->{info}{name}</b><pre>\n       " . 
          substr($o, 7) . "<br>";

    print "   <b>Destination Point</b>: Iport $port on switch: $name at $info->{ip}\n";
  }

  return (undef, "");
}


1;


