package FibreGUI;

use Data::Dumper;
use Fibre::ByDisk;
use Fibre::ByDiskSw;
use Fibre::ByDiskT3;
use Fibre::T3Data;
use Fibre::History;
use Fibre::Discover;
use Fibre::Rules;
use WebTabs;
use Util;
use System;
use FibreStat;

#lnk fail    sync loss   signal loss   sequence err   invalid word   CRC

$APPLET = "code=\"RasGraph2.class\" codebase=\"/Chart2\" archive=\"rasapplet.jar\" ";
#$APPLET = "code=\"RasGraph2.class\" codebase=\"/Chart2\" ";

$APPLET2 = "code=\"VertexApplet.class\" codebase=\"/Topo\" archive=\"topo.jar\" ";
#$APPLET2 = "code=\"VertexApplet.class\" codebase=\"/Topo\" ";

$TABLIST=['1=List','2=Graph','3=Data','4=Compare HBAs','5=Errors over time','6=RealTime', '7=Discovery'];

$TABLIST=['1=List','2=Graph A5K','9=Graph Sw','12=Graph T3', '10=History','11=Rules', '3=A5K Data','31=T3 Data','8=Discovery','6=RealTime'];
#$TABLIST=['1=List','2=Graph','3=Data'];


#    0          1      2       3     4       5      6 
#"enclo-disk","link","signal","seq","crc", "sync","word"
# key = hba|enc|disk|    disk=f01, f01, r01, r02

#################################################
#  SUBROUTINES
#################################################
# name:type:ip

sub findSelected {
  my($q) = @_;
  my($RF) =  System->get_home() . "/DATA/tmp/reallist";
  my(@A, @S, @T); 

  open(O, $RF);
  while ($l = <O>) {
      chop($l);
      @a = split(/:/, $l);
      if ($a[1] eq "s") {
        push(@S, "$a[0]:$a[2]");
      } elsif ($a[1] eq "a") {
        push(@A, $a[0]);
      } elsif ($a[1] eq "t") {
        push(@T, $a[2]);
      }
  }
  close(O);
  return (\@A, \@S, \@T);
}

sub countersToString {
  my($arg,$a1, $a2, $a3) = @_;
  my($out, $hba);
  my($skipzero) = $arg->{skipzero};
  my($skip) = $arg->{skip};
  my($filter) = $arg->{filter};
  my($lCount) = $arg->{L};

  foreach my $x (sort @$a1, @$a2, @$a3) { # each enc
     next if (substr($x,0,1) eq "#");
     my(@b) = split(/\t/, $x);
     my(@key) = split(/\|/, $b[0]);
     $enc = $key[0] . "-" . $key[1]; $comp = $key[2];
     if ($enc ne $lastenc) {
        chop($out);
        $out .= "|$enc,";
        $lastenc = $enc;
     }
     $o = "";

     &$filter(\@b) if ($filter);

     if (!$skipzero || ($b[1]+$b[2]+$b[3]+$b[4]+$b[5]+$b[6]) || $lCount == -1) {
         $out .= "$comp $b[1]/$b[2]/$b[3]/$b[4]/$b[5]/$b[6],";
     }
  }
  chop($out);
  return $out;
}

#  $last->{$enc}{$comp} = "0/0/0/0/0/0";

sub display {
  my($date,$last, $p) = @_;
  my($p1, $p2, $enc, $comp, $err, @c1, @c2, $c1, $c2);
  $out = "<tr><td width=1% nowrap><small>&nbsp;$date</td>";

  foreach $enc (sort keys %$p) {
     $out .= "<td><small>&nbsp;" ;
     $p1 = $p->{$enc};
     foreach $comp (sort keys %$p1) {
        $c1 = $p1->{$comp};
        $c2 = $last->{$enc}{$comp} || "0";
        if ($c1 ne $c2) {
          @c1 = split(/\//, $c1);
          @c2 = split(/\//, $c2);
          $d0 = $c1[0]-$c2[0];
          $d1 = $c1[1]-$c2[1];
          $d2 = $c1[2]-$c2[2];
          $d3 = $c1[3]-$c2[3];
          $d4 = $c1[4]-$c2[4];
          $d5 = $c1[5]-$c2[5];
          $d0 = "<font color=red>$d0</font>" if ($d0);
          $d1 = "<font color=red>$d1</font>" if ($d1);
          $d2 = "<font color=red>$d2</font>" if ($d2);
          $d3 = "<font color=red>$d3</font>" if ($d3);
          $d4 = "<font color=red>$d4</font>" if ($d4);
          $d5 = "<font color=red>$d5</font>" if ($d5);
          $out .= "<b>" .uc($comp) ."</b>=$d0,$d1,$d2,$d3,$d4,$d5  ";
        }
     }
     $out .= "&nbsp;</td>";
  }
  $out .= "</tr>";
  return $out;
}
            
  
#  all: enc  | enc2  | enc3
#  enc: enc-key, comp , comp2 , comp3 
# comp: comp-key 0/0/0/0/0/0
#  $p->{$enc}{$comp} = "0/0/0/0/0/0";

sub countersParse {
  my($o) = @_;
  my($out, $x, $y, $x0 ,$date);
  chomp($o);
  my(%p , $enc, $comp, $err);
  my(@enc) = split(/\|/, $o);
  $date = $enc[0];
  for ($x0=1; $x0 <= $#enc; $x0++) {
     $x = $enc[$x0];
     my(@b) = split(/,/, $x);
     my($enc) = $b[0];
     for ($y=1; $y <= $#b; $y++) {
       my(@c) = split(/ /, $b[$y]);
       $p{$enc}{$c[0]} = $c[1];
     }
  }
  return ($date, \%p);
}

#################################################

sub test {
  my($q) = @_;
  my(%D);
  print "\n <body bgcolor=white><pre> ";

  ($x, $summ) = FibreStat::a5k_luxdisc($q,{cache => 1});
  foreach $x (sort @$x) {
    print "$x\n";
  }
}

sub topo {
  my($q) = @_;

  print "\n";
  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth  - 25;
  var a_height =  window.innerHeight * 0.80;
  window.document.writeln(
   '<applet  $APPLET2 height=' + a_height + ' width=' + a_width + '>');
  </script>
  <param name=url value="ccadieux.central:7655/?GET=topos">
  </applet>
EOF

  print "<body bgcolor=#E0E0E0>";
  print "&nbsp;
     <table cellpadding=0 border=0 cellspacing=0  cellpadding=0 bgcolor=white>
     <tr bgcolor=#505050><td>
       <table border=0 cellpadding=4><tr><td><font color=white><b> Topology Map</table></td>
     <tr><td>
          <center>$applet</td>
        </table>";


}



sub test2 {
  my($q) = @_;
  my($out) = "<body bgcolor=#E0E0E0><center>\n";

#  foreach $x (keys %$q) {
#    print "$x=$q->{$x}<br>";
#  }

  $tab = WebTabs::create(list  =>  $TABLIST,
                       url  => "/?GO=FibreGUI::test2",
                     width  => "95%",
             selectedColor  => "white",
         selectedTextColor  => "blue",
           backgroundColor  => $main'LIGHT,
        backgroundTextColor => black,
                  selection => $q->{option}
               );
  $out .= $tab;
#  $out .= "<table border=0><tr><td></table>";

  if ($q->{option} == 1) {
    print $out;
    &real_list($q);

  } elsif ($q->{option} == 2) {
    print $out;
    Fibre::ByDisk::run($q);

  } elsif ($q->{option} == 9) {
    print $out;
    Fibre::ByDiskSw::run($q);

  } elsif ($q->{option} == 12) {
    print $out;
    Fibre::ByDiskT3::run($q);

  } elsif ($q->{option} == 10) {
    print $out;
    Fibre::History::run($q);

  } elsif ($q->{option} == 11) {
    print $out;
    Fibre::Rules::run($q);

  } elsif ($q->{option} == 31) {
    print $out;
    Fibre::T3Data::run($q);

  } elsif ($q->{option} == 3) {
    print $out;
    my($cache, $debug);
    if ($q->{clear}) {
      $cache = 2; $debug = 1;
    }

    print "<b>[ <a href=/?GO=FibreGUI::test2&option=3&clear=1>Re-discover</a> ]</b><br>";

#    my($a5,$sw,$t3) = &findSelected();
#    $list = join(",", @$a5);

    $rep = FibreStat::a5k_luxdisc($q,{cache => $cache, report => 1, debug => $debug });  

    print "<table cellpadding=4 width=95% border=0 bgcolor=white><tr><td><pre>";
    
    print "<b>a5k</b>\n$rep\n" if ($rep);
    print "</table>";

  } elsif ($q->{option} == 4) {
    print $out;
     &byHba($q);

  } elsif ($q->{option} == 5) {
    print $out;
     &byTime($q);

  } elsif ($q->{option} == 6) {
     $out .= "</center>";
     &realtime($q, $out);

  } elsif ($q->{option} == 7) {
    print $out;
    Fibre::Discover::run($q);

  } elsif ($q->{option} == 8) {
    print $out;
    Fibre::Discover::discover($q);

  } else {
    print $out;
    print "<table border=0><tr><td></table>";
    print "<table border=0 cellpadding=4 bgcolor=white width=97%><tr><td>
     <b>Select from the tabs above to display an Error Report.<br>
     Reports will show link-errors, signal-errors, sequence-errors, CRC, sync-errors and
     words errors for each enclosure .<br>
    </table>";
  }
}

sub real_list {
  my($q) = @_;
  my($F) =  System->get_home() . "/DATA/tmp/reallist";

  if ($q->{ACTION} eq "Update") {
     open(O,">$F");
     foreach $x (keys %$q) {
       if (substr($x,0,3) eq "ck_") {
          $name = substr($x,3);
          print O "$name\n";
       }
     }
     close(O);
     print "<b>List Updated.</b>";
  }
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  print "<center>
 <form>
 <table border=0 bgcolor=white width=95% cellpadding=4><tr><td>
    Check the devices that you want to display in the Graph and Data Section of this page.
 </table>
  <table border=0><tr><td></table>
  <table border=1 cellspacing=0 bgcolor=white width=95%>
   <input type=hidden name=GO value=FibreGUI::test2>
   <input type=hidden name=option value=1>
  <tr bgcolor=#666699>
      <th width=1%><center><font color=white>Select
      <th><font color=white>Device
      <th><font color=white>Adddress
      <td> </td>
      <th width=1%><center><font color=white>Select
      <th><font color=white>Device
      <th><font color=white>Adddress
  ";
  my(%DEV);
  open(O, $F);
  while ($l = <O>) {
    chop($l);
    @a = split(/:/, $l);
    $DEV{$a[0]} = 1;
  }
  close(O);
  $cnt= 0;
  foreach my $d (@$dev) {
     if ($d->{type} eq "switch" || $d->{type} eq "a5k" || $d->{type} eq "t3") {
        print "<tr>" if ($cnt % 2 == 0);
        $ck = ($DEV{$d->{name}})? "checked":"";
        $type = substr($d->{type},0,1);
        print "<td><center><input type=checkbox name=\"ck_$d->{name}:$type:$d->{ip}\" $ck>
               <td>" . substr($d->{type},0,2) . "-$d->{name}</td>
               <td>&nbsp;$d->{ip}</td>
               ";
        print "<td>" if ($cnt % 2 == 0);
        $cnt++;
     }
  }
  print "<form></table>";
  print "<b><input type=submit name=ACTION value=Update><br>\n";
}
  


sub realtime {
  my($q, $header) = @_;
  my(@MAP)  = (0,'Lnks','Sig','Seq','CRC','Sync','Wds');
  my($RF) =  System->get_home() . "/DATA/tmp/reallist";

  if ($q->{ACTION} eq "List") {
     $q->{option} = 7;
     &test2($q);
     return;
  }
  my($last);
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  my($ip, $found);
  my($F) = System->get_home() . "/DATA/tmp/realtime";

  my($errTypes);
  foreach $x (keys %$q) {
    if (substr($q->{$x},0,3) eq "ck_"){
       $found = 1; last;
    }
  } 
  $q->{refresh} = 10 if (!$q->{refresh});


  if ($q->{ACTION} eq "Stop") {
    $nothing = 1;
  } elsif (($q->{ACTION} =~ /Start/)) {
    print "<head><meta http-equiv=Refresh content=$q->{refresh}></head> \n";
  }
  print $header;
  $refresh = &main'make_select("refresh","5=5 secs|10=10 secs|20=20 secs|30=30 secs",
     $q->{refresh});

  for ($x0=1; $x0 <= $#MAP; $x0++) {
    $x = $MAP[$x0];
    $ck = ($q->{"ck_$x"})? "checked":"";
    $errTypes .= "<input type=checkbox name=ck_$x $ck>:$x&nbsp;";
  }


  $ck = (!$found) ? "checked":"";
  $errTypes .= "<input type=checkbox name=ck_All $ck>:All&nbsp;";
  print "<table border=0 cellspacing=2 cellpadding=0 width=100% bgcolor=white>
   <form><input type=hidden name=GO value=FibreGUI::test2>
         <input type=hidden name=option value=$q->{option}>
   <tr><td>&nbsp;<b><input type=submit name=ACTION value=Clear>
                    <input type=submit name=ACTION value=List>
       <td nowrap><center><b>Refresh: $refresh 
       <td align=right nowrap> <b>Ignore $errTypes 
                  <input type=submit name=ACTION value=Start>
                  <input type=submit name=ACTION value=Stop>
   </table>";

  if (!$q->{ACTION}) {
     print "<h2> Select [Start] to start monitoring<br>\n";
     return ;
  }

  my($ip, $cache);
  my($today) = Util->get_today();

  if ($q->{ACTION} eq "Clear") {
     $cache = 2;
     unlink($F);
     print "Discovering A5Ks ...<br>\n";
  } else {
     $cache = 0
  }


  my(@sw, @sw0, $a5);
  my($encs);

  if ($q->{ACTION} ne "Stop") {
    open(O, $RF);
    while ($l = <O>) {
      chop($l);
      @a = split(/:/, $l);
      if ($a[1] eq "s") {
        $ip = $a[2];
        ($sw0, $summ) = FibreStat::sw_luxdisc($q,{cache => 1, name=>$a[0],ip => $ip});
        push(@sw, @$sw0);
      } elsif ($a[1] eq "a") {
        $encs .= "$a[0],";
      }
    }
    close(O);
    chop($encs) if ($encs);

    print "<pre>encs=$encs ";
    ($a5, $summ) = FibreStat::a5k_luxdisc($q,{cache => $cache, encs => $encs, debug => 1});
    print "</pre>";
  }

  open(O, $F);
  @L = <O>; close(O);
  my($h1, $val, $h2, $val2, $p);
  print "<table border=0><tr><td></table>";
  print "<table border=1 cellspacing=0 cellpadding=0 bgcolor=#F0F0F0 width=100%>";
  $DB::single = 1;
  $last = {};
  if ($#L >= 0) {  # header
    ($date, $last) = &countersParse($L[0]) ;
    print "<tr bgcolor=#666699><th width=1%><font color=white>Date</th>";
    foreach $enc (sort keys %$last) {
      print "<th><font color=white>$enc</th>";
    }
  }
  my(@display);
  for ($x=1; $x <= $#L; $x++) {
    $last0 = $last;
    ($date,$last) = &countersParse($L[$x]);
    push(@display, &display($date, $last0, $last));
  }           


  my($out, $lastenc, $y, $enc, $comp);

#  all: date | enc  | enc2  | enc3
#  enc: enc-key, comp , comp2 , comp3 
# comp: comp-key 0/0/0/0/0/0
# one line per timestamp

  $out = "$today "; $lastenc = "";
  $out = &countersToString({skipzero => 1, filter => \&filter1, L => $#L}, $a5, \@sw);

  
  if ($#L < 0 || ($#L >= 0 && substr($L[$#L],19,-1) ne substr($out,19))) {
    open(O , ">>$F");
    print O $out . "\n";
    close(O);
  }
  if ($#L >=  0) {
     ($date, $new) = &countersParse($out);
     push(@display,&display($today,$last, $new));
  }
  for ($y=$#display; $y >= 0; $y--) {
     print $display[$y];
  }
  print "</table>";
  $running = 0;

  if ($q->{ACTION} =~ "Start") {
     print "<h2>Monitoring Started!";
  } elsif ($q->{ACTION} eq "Stop") {
     print "<h2>Monitoring Stopped!";
  }
  print "</form><br>\n";
  return 0;
}

sub filter1 {
  my($b) = @_;
  $b->[6] = 0 if ($q->{ck_Wds});
}

sub map_a5 {
  my($disk) = @_;
  if (substr($disk,0,1) eq "f") {
    return "front";
  } elsif (substr($disk,0,1) eq "r") {
    return "rear";
  } elsif (substr($disk,0,1) eq "s") {
    return "ses";
  } else {
    return "";
  }
}

sub byTime {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues);

  ($x, $summ) = FibreStat::a5k_luxdisc($q,{cache => 0});
  @X = ();
  for ($y0=0; $y0 <= 24; $y0++) {
       $v =  sprintf("%2.2d:00", $y0);
       push(@TIME, $v);
       if ($y0 < 12) {
         $xvalues .= "$v=$v AM,";
       } else {
         $xvalues .= "$v=$v PM,";
       }
  }
  chop($xvalues);

  $js =<<EOF;
  <script>
  var a_width =  window.innerWidth - 25;
  var a_height =  window.innerHeight * 0.80;
  window.document.writeln(
   '<applet  $APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>
EOF
#  $js = "<applet $APPLET height=600 width=600>";

  $applet =<<EOF;
$js
<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=fontsize value=10>
<param name=Yfontsize value=9>
<param name=minY value=0>
<param name=browser value="sun">
<param name=decimalsY value=1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=FibreGUI::test2&option=4&">
<param name=urlY value="/?GO=FibreGUI::test2&option=4&">
<param name=xurlTarget value="">
<xparam name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, %ENC2);
   $q->{hba} = 0 if (!$q->{hba});
   $hbas = "";
   $q->{hba} = 0 if (!$q->{hba});
   foreach $line (sort @$x) {
     if (substr($line,0,1) eq "#") {
        @c = split(/=/, $line);
        $c[1] =~ s/\/devices//;
        $HBA[substr($c[0],1)] = $c[1];
        $hbas .= substr($c[0],1) . "=$c[1]|";
        next;
     }
     @b = split(/\t+/, $line);
     next if ($b[0] != $q->{hba}); # first hba only
     @c = split(/\|/, $b[0]);
     $enc =  $c[0] . "-" . $c[1] . "-" . map_a5($c[2]);
     $enc =~ s/ //g;
     $ENC2{$enc} = $HBA[$c[0]] ;
     $disk = $c[2];
     foreach $time (@TIME) {
       $r = int(rand(2));
       $r2 = int(rand(3));
       $D{$enc}{$time}[0] += $r;
       $D{$enc}{$time}[1] += $r2;
     }
   }
   chop($hbas);
   $stack_cnt = 1;
   $gc = 1;
   foreach $enc (sort keys %D) {
     $enc0 = $enc;
     $enc0 = "Enc-" . uc($enc) if (length($enc) == 1);
     $applet .= "<param name=title$stack_cnt value=\"$enc0= Port: " . substr($enc,2) . " on hba: $ENC2{$enc}\">";
     $sync_data = $word_data = $crc_data = $sig_data = "";
     foreach $disk (@TIME) {
       $sync_data .= $D{$enc}{$disk}[0] . ",";   # sync
       $word_data .= $D{$enc}{$disk}[1] . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     $applet .=<<EOF;

<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;

<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Invalid-Word">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   $time = substr(Util->today("YMDH"),0,10);
   $title = "Errors by Ports over Time for $time";
   $sel = &main::make_select("hba", $hbas, $q->{hba}, 1);
   print "
    <table border=0 cellspacing=0 cellpadding=2 width=96% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=FibreGUI::test2>
      <input type=hidden name=option value=4>
    <tr bgcolor=#505050>
      <td nowrap><b><font face=helvetica color=white>&nbsp;$title </td>
      <td align=right><font color=white>Select HBA: $sel <input type=submit name=ACTION value=GO>&nbsp;</td>
    <tr><td colspan=2><center>$applet
    </table></form>";
  
}

sub byHba {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues);

  ($x, $summ) = FibreStat::a5k_luxdisc($q,{cache => 0, encs => "a1,b1"});
   @X = ();
   foreach $e ('f','r') {
     for ($x1=0; $x1 <= 10; $x1++) {
        push(@X, sprintf("$e%2.2d", $x1));
        $title = ($e eq "f")? "front":"rear";
        $e0=uc($e);
        $xvalues .= sprintf("$e0%2.2d=$title disk $x1,", $x1);
     }
   }

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth * 0.94;
  var a_height =  window.innerHeight * 0.80;
  window.document.writeln(
   '<applet  $APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>

<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=fontsize value=10>
<param name=Yfontsize value=9>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=browser value="sun">
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=20>
<xparam name=urlX value="/?GO=FibreGUI::test2&option=3&">
<param name=urlY value="/?GO=FibreGUI::test2&option=3&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @ENC, @ENC2);
   foreach $line (sort @$x) {
     if (substr($line,0,1) eq "#") {
        @c = split(/=/, $line);
        $c[1] =~ s/\/devices//;
        push(@ENC, $c[1]);
     } else {
       last;
     }
   }
   foreach $line (sort @$x) {
     if (substr($line,0,1) eq "#") {
        next;
     }
     @b = split(/\t+/, $line);
#     next if ($b[0] != 0); # first hba only
     @c = split(/\|/, $b[0]);
     next if (substr($c[2],0,1) ne "r" && substr($c[2],0,1) ne "f" );
     $hba =  $c[0];
     $enc =  $c[1]; $enc =~ s/ //g;
     $disk = $c[2];
     $D{$enc}{$disk}[$hba] += $b[5] + $b[6];
   }
   $stack_cnt = 1;
   $gc = 1;
   foreach $enc (sort keys %D) {
     $enc0 = $enc;
     $enc0 = "Enc-" . uc($enc) if (length($enc) == 1);
     $applet .= "<param name=title$stack_cnt value=\"$enc0\">";
     $data0 = $data1 = "";
     foreach $disk (@X) {
       $data0 .= $D{$enc}{$disk}[0] . ",";
       $data1 .= $D{$enc}{$disk}[1] . ",";
     }
     chop($data0); chop($data1);
     $applet .=<<EOF;

<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$data0">
<PARAM name=label$gc value="$ENC[0]">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;

<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$data1">
<PARAM name=label$gc value="$ENC[1]">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   $title = "Sync+Words Errors by Enc/Disk/Hba";

   print "<table border=0><tr><td></table>
   <table border=0 cellspacing=0 cellpadding=2 width=96% bgcolor=black>
   <tr bgcolor=505050><td>
     <table border=0><tr><td><b><font face=helvetica color=white><center>$title</table> </td>
   <tr><td><center>$applet
    </table>";
}

sub run {
  my($q) = @_;

  print "\n<body bgcolor=#F0F0F0>";
  

}

1;
