package FibreStat;
use System;
use Util;
use strict;
use Debug;
use Net::Telnet;
use Data::Dumper;

# $report = 1; return a report

#  Usage: ($x, $summ) = 
#    FibreStat::sw_luxdisc({cache => 1/2, report => 1, ip => 'diag190'});

sub sw_luxdisc {
  my($q,$arg) = @_;
  my($l, @b, @ST , @CNT, $cache);
  
  if ($arg->{cache} == 1) {
    $cache = 1;
  } else {
    $cache = 0;
  }
#  $cache = 0; #  temporary

  my($report) = 1 if ($arg->{report});
  
  my($ip) = $arg->{ip};
  my($name) = $arg->{name} || $ip;
  if (!$ip) { 
    print "Error: Must enter ip argument! \n";
    return undef;
  }
  my($sb) = "/opt/ras/bin/sanbox";
  my($debug) = Debug->level();

  my($err,$status) = &run_command("$sb port_status $ip all","","", $cache);
  my($err1,$counts) = &run_command("$sb port_counts $ip all","","", $cache);

  my($in) = ""; my($p) = "8";

  foreach $l (@$status) {
    chomp($l);
    @b = split(/\s+/, $l);
    if ($l =~ /Port:/) {
       $p      = sprintf("%3.3d", $b[1]);
       if ($l =~ /Offline/) {
         $ST[$p]   = "Offline";
       } else {
         $ST[$p]   = "Online";
       }
    }
  }

#Port:           2
#Inframes:       10470092 
#Outframes:      17900116 
#Discards:       14 
#Fbsyframes:     0 
#C2Rjtframes:    0 
#LinkFails:      9 
#SyncLosses:     9 
#Prim Seq Errs:  0 
#InvalidTxWds:   217101 
#CRC Errs:       33 
#DelimiterErrs:  27 
#AddressIdErrs:  0 
#Link Reset In:  0 
#Link Reset Out: 0 
#OLS In:         0 
#OLS Out:        0 
#Total LIP Rcvd: 155 
#LIP F7 F7:      153 
#LIP F8 F7:      0 

  my($STATE_LIST) = "LinkFails,Total_LIP_Rcvd,InvalidTxWds,SyncLosses,CRC_Errs,".
                "Prim_Seq_Errs,AL_Init_Errs,AddressIdErrs,short_frame_err_cnt," .
                "long_frame_err_cnt,loss_of_signal_cnt,sync_loss";
  $in = "";
  foreach $l (@$counts) {
     chomp($l);
     @b = split(/\s*:\s*/, $l);
     next if ($b[0] =~ /-----------/);
     if (substr($l,0,5) eq "Port:") {
        $in = sprintf("%3.3d", $b[1]);
     } elsif ($in) {
        my($k) = $b[0];
        $k =~ s/ /_/g;
        $k =~ s/,/_/g;
        if ($ST[$in] ne "Offline" && index($STATE_LIST, $k) >= 0) {
             $CNT[$in]{$k}   = $b[1]+0;
        }
     }
  }
#  push(@X, "$x|$enc|$disk\t$al2->{link}\t$al2->{signal}\t$al2->{seq}\t$al2->{crc}\t$al2->{sync}\t$al2->{word}");
  my($out, $form, $form2);
  $form  = "%-4.4s %6s %6s %6s %6s %6s %6s\n";
  $form2 = "%-4d %6d %6d %6d %6d %6d %6d\n";
  my($port, $c);
  if ($report) {
      $out .= sprintf($form, "Port", "Link","Signal","Seq","Crc", "Sync","Word");
      $out .= "-" x 110 . "\n";
      for ($port=0; $port <= $#CNT; $port++) {
           $c = $CNT[$port];
           $out .= sprintf($form2, $port, 
               $c->{LinkFails}, 
               $c->{loss_of_signal_cnt}, 
               $c->{Prim_Seq_Errs}, 
               $c->{CRC_Errs},
               $c->{sync_loss},
               $c->{InvalidTxWds});
      }
      return $out;
   } else {
      my(@X) = ();
      for ($port=1; $port <= $#CNT; $port++) {
           $c = $CNT[$port];
           my($port0) = sprintf("%2.2d", $port);
           push(@X,"|$name|p$port0|s\t$c->{LinkFails}\t$c->{loss_of_signal_cnt}\t$c->{Prim_Seq_Errs}\t$c->{CRC_Errs}\t$c->{sync_loss}\t$c->{InvalidTxWds}");
      }
      return (\@X);
   }
}


# save = 1 : use cache for all
# save = 0 : use cache for discovery stuff
# save = 2 : don't use cache at all

sub a5k_luxdisc {
  my($q,$arg) = @_;
  my(%ENC, $disks, $in, $l, $node, %WWN, @HBA, $num, $x, %ALPA);

  my( $cache1, $cache2);
  if ($arg->{cache} == 1) {
     $cache1 = $cache2 = 1;
  } elsif ($arg->{cache} == 2) {
     $cache1 = $cache2 = 0;
  } else {
     $cache1 = 1; $cache2 = 0;
  }
  my($report) = 1 if ($arg->{report});
  my($debug)  = $arg->{debug};
  my($encs)   = $arg->{encs};


  my($lux) = "/usr/sbin/luxadm";
  
  my($err,$probe);
  
#
# Find ENCLOSURES AND PATHS with PROBE
#
  ($err,$probe) = &run_command("$lux probe","","-p", $cache1);
  my($in, $l);
  my($hbalist, $ix, $a5);
  my($MPX);
  my(%E2WWN);

  for ($ix=0; $ix <= $#$probe; $ix++) {
      $l = $probe->[$ix];
      if ($l =~ /Found/) {
        $in = 1;
      } elsif ($in) {
        if ($l =~ / Name:(.+)\s+Node WWN:([^\s]+)/) {
          my($off) = 2;
          my($name) = Util->trim($1); 
          my($wwn) = Util->trim($2); 
          $off = 1 if ($l =~ /Logical Path/);
          $E2WWN{$name} = $wwn;
          if ($name) {
             $ENC{$name} = 1;
          } else {
             $ENC{$wwn} = 1;
          }
          while ($probe->[$ix+$off] =~ /Physical Path:(.*)/) {
             my($hba) = $1;
             if ($hba =~ /\/devices\/scsi_/) { # MPX
               $MPX = 1;
             } else {
               if (index($hbalist, "$hba,") < 0) {
                 push(@HBA, $hba);
                 $hbalist .= "$hba,";
               }
             }
             $ix+=2;
          }
        }
      }
  }

  if (defined($encs)) {
    %ENC = ();
    my(@a) = split(/,/, $encs);
    foreach my $enc (@a) {
        $ENC{$enc}  = 1;
    }
  }
  my(%PORTS, $ib);
  my($done) = 0;
  foreach my $enc (keys %ENC) {
    print "Reading enclosure: $enc<br> \n" if ($debug);
    ($err, $disks) = &run_command("$lux display $enc","","", $cache1);
     $in = "";
     foreach $l (@$disks) {
        if ($l =~ /^SLOT/) {
          $in = "slot";
        } elsif ($l =~ /^FW Rev/) {
          $in = 0;
          $l =~ /FW Revision:([\d\.]+) .* +Node WWN:(.*) +Enclosure/;
          $node = Util->trim($2);
          $WWN{$node}{side}   = 's';
          $WWN{$node}{enc}   = $enc;

        } elsif ($l =~ /^Power Supplies/) {
          $in = "powers";
        } elsif ($l =~ /^Fans/) {
          $in = "fans";
        } elsif ($l =~ /^ESI/) {
          $in = "esi";
        } elsif ($l =~ /^Disk/) {
          $in = "disk";
        } elsif ($l =~ /^Interconnect/) {
          $in = "inter";
        } elsif ($l =~ /^Loop/) {
          $in = "loop";
        } elsif ($l =~ /^Language/) {
          $in = 0;
        } else {
          if ($in eq "slot") {
            if (substr($l,0,1) =~ /\d/) {
              $num =  sprintf("%2.2d", substr($l,0,2) + 0);
              $x = substr($l,7,17);
              $x =~ /([ \w]+)(.*)/;
              $node = substr($l,25,16);
              $WWN{$node}{side} = "f";
              $WWN{$node}{no}   = $num;
              $WWN{$node}{enc}   = $enc;

              $x = substr($l,45,17);
              $x =~ /(\w+)(.*)/;
              $node = substr($l,63,16);

              $WWN{$node}{side} = "r";
              $WWN{$node}{no}   = $num;
              $WWN{$node}{enc}   = $enc;
              if (( Util->rtrim($node) ne "") && $MPX && !$done) {
                $done = 1;
                my($err2, $details) = &run_command("$lux display $node","","", $cache1);
                foreach my $ll (@$details) {
                    if ($ll =~ /^\s+Controller\s+(.*)/) {
                       my($h2) = $1;
                       if (index($hbalist, "$h2,") < 0) {
                          push(@HBA, $h2);
                          $hbalist .= "$h2,";
                       }
                    }
                }
              }       
            }
          } elsif ($in eq "esi") {
            if ($l =~ /^\s+([AB]): (.*)/) {
               $ib = $1; $x = $2; $x =~ s/\.//g;

            } elsif ($l =~ /^\s+([01]) (.*)/) {
               my($port) = $1; my($status) = $2;
               if ($status =~ /O.K./) {
                  $PORTS{"a:$enc:$ib"} = $port;
               }
            }
          }
        }
     }
  }
  open(O, ">" . System->get_home() . "/DATA/GBICS");
  print O Dumper(\%PORTS);
  close(O);

if (0) {
#
# LOGICAL path with SYSDUMP
#
  my($dump, $p, @a, $b , $ports);
  ($err, $dump) = &run_command("$lux sysdump","","", $cache1);
  $in = 0;
  foreach $p (@$dump) {
     next if ($p =~ /^ *$/);
     if ($p =~ /\s*Physical /) {
       $in = 1;
     } elsif ($in) {
       my(@a) = split(/\s+/, $p);
       my($h1) = $a[0];
       my($i2) = rindex($h1, "/");
       $h1 = substr($h1,0, $i2);
       $WWN{$a[1]}{"logical$h1"} = $a[3];
     }
  }

  ($err, $ports) = &run_command("$lux -e port","","", $cache1);
  $in = 0;
  foreach $p (@$ports) {
     next if ($p =~ /^ *$/);
     if ($p =~ /Found path/) {
       $in = 1;
     } elsif ($in) {
       if ($p =~ /  CONNEC/) {
          my(@a) = split(/ +/, $p);
          my(@b) = split(/:/, $a[0]);
          push(@HBA , $b[0]);
       }
     }
  }
}
#
# FOR EACH HBA, GET COUNTERS 
#
  my($map, $err2, $rdls, @c, $hba);
  for ($x=0; $x <= $#HBA; $x++ ) {
     $hba = $HBA[$x];
     print "reading hba $x ($hba) <br>\n" if ($debug);
     my($err,$map) = &run_command("$lux -e dump_map","", $hba, $cache2);
     my($last) = substr($hba,-1);
     my($err2,$rdls) = &run_command("$lux -e rdls",$last, $hba, $cache2);
     $in =0;
     my($fabric) = 0;
     foreach $l (@$map) {
        next if ($l =~ /^ *$/);
        if ($l =~ /^Pos/) {
            $in = 1;
            $fabric = 1 if ($l =~ /Port_ID/);
        } elsif ($in) {
          my($n,$alpa,$id,$hard,$port,$node,$type,$desc);
          if ($fabric) {
            ($n,$alpa,$hard,$port,$node,$type,$desc) = split(/\s+/, $l, 7) ;
          } else {
            ($n,$alpa,$id,$hard,$port,$node,$type,$desc) = split(/\s+/, $l,8) ;
          }
          $alpa = sprintf("%02s", $alpa);
          $ALPA{$x}{$alpa}{port} = $port;
          $ALPA{$x}{$alpa}{node} = $node;
          $ALPA{$x}{$alpa}{type} = $type;
          @c = split(/ /, substr($desc,1));
          $ALPA{$x}{$alpa}{desc} = $c[0];
        }
     }
     $in =0; 
     foreach $l (@$rdls) {
        next if ($l =~ /^ *$/);
        if ($l =~ /^al_pa/) {
           $in = 1;
        } elsif ($l =~ /^NOTE:/) {
           $in = 0;
        } elsif ($in) {
           my($alpa,$lnk,$sync,$signal,$seq,$word,$crc) = split(/\s+/, $l);
           $alpa = sprintf("%02s", $alpa);
           $ALPA{$x}{$alpa}{link}   = $lnk;
           $ALPA{$x}{$alpa}{sync}   = $sync;
           $ALPA{$x}{$alpa}{signal} = $signal;
           $ALPA{$x}{$alpa}{seq}    = $seq;
           $ALPA{$x}{$alpa}{word}   = $word;
           $ALPA{$x}{$alpa}{crc}    = $crc;
        }
     }
     
  }
  my($out, @X, %SUMM, $hba , $form0, $form, $form2, $al, $hba0);
  my(%ses_cnt) = 0;
  if (!$report) {
    for ($x=0; $x <= $#HBA; $x++ ) {
       push(@X, "#$x=$HBA[$x]");
    }
    foreach $x (keys %E2WWN) {
       push(@X, "#E_$x=$E2WWN{$x}");
    }
      
  } 
  for ($x=0; $x <= $#HBA; $x++ ) {
     $hba = $hba0 = $HBA[$x];
     $hba =~ s/\/devices\///;
     if ($report) {
       @X = ();
       $out .= "\nHBA ($x): $hba \n";
       $form0 = "%-5.5s %-10.10s %-10.10s %-4.4s %-16.16s %-12.12s %-6.6s";
       $form  = "$form0 %6s %6s %6s %6s %6s %6s\n";
       $form2 = "$form0 %6d %6d %6d %6d %6d %6d\n";
       $out .= sprintf($form,  "Path",
              "Enclosure","Disk","Alpa","Wwn","Logical","Desc","Link","Signal","Seq","Crc",
              "Sync","Word");
       $out .= "-" x 111 . "\n";
     }
     my($y) = $ALPA{$x};
     my($al2, $wwn, $enc, $disk, $device);
     my($hbadone) = 0;
     foreach $al (keys %$y) {
         $al2 = $y->{$al};
         $wwn  = $al2->{node};
         if ($WWN{$wwn}{enc}) {
             $enc = $WWN{$wwn}{enc};
         } else {
             next if ($hbadone);
             $hbadone = 1;
             $enc = "hba";
         }
         if ( $WWN{$wwn}{side}) {
           $disk = $WWN{$wwn}{side} .  ($WWN{$wwn}{no} || sprintf("%2.2d", $ses_cnt{"$hba-$enc"}++) );
         } else {
           $disk = "-";
         }
         $device = $WWN{$wwn}{"logical$hba0"};

         $device = substr($device,9) if (substr($device,0,10) eq "/dev/rdsk/");
         $device = substr($device,4) if (substr($device,0,5) eq "/dev/");
#        $device = substr($device,0, -2) if ($al2->{desc} =~ /Disk/ && substr($device,-2) eq "s2");

         $device = substr($device, -12) if (length($device) > 12);
         if ($report) {
           my($enc0) = $enc;
           $enc0 = substr($enc0,-10) if (length($enc0) > 10) ;
           push(@X, sprintf($form2, $x, $enc0, $disk, $al, $wwn, $device, $al2->{desc},
                        $al2->{link}, $al2->{signal}, $al2->{seq}, $al2->{crc},$al2->{sync},$al2->{word}));
         } else {
#                    ------ key -------  values
           push(@X, "$x|$enc|$disk|a5k\t$al2->{link}\t$al2->{signal}\t$al2->{seq}\t$al2->{crc}\t$al2->{sync}\t$al2->{word}");
           $SUMM{"$x|$enc|$disk"} = "$al\t$wwn\t$device\t$al2->{desc}";
         }
     }
     if ($report) {
       foreach $l (sort @X) {
         $out .= $l;
       }
     }
  }
  print "Done\n" if ($debug);
  if (!$report) {
    return (\@X, \%SUMM);
  } else {
    return $out;
  }
}

# save = 1 : use cache for all
# save = 0 : use cache for discovery stuff
# save = 2 : don't use cache at all

sub t3_luxdisc {
  my($q,$arg) = @_;
  my(%ENC, $disks, $in, $l, $node, %WWN, @HBA, $num, $x, %ALPA);

  my( $cache1, $cache2);
  if ($arg->{cache} == 1) {
     $cache1 = $cache2 = 1;
  } elsif ($arg->{cache} == 2) {
     $cache1 = $cache2 = 0;
  } else {
     $cache1 = 1; $cache2 = 0;
  }
  my($report) = 1 if ($arg->{report});
  my($debug)  = $arg->{debug};
  my($encs)   = $arg->{encs};
  my($confDevs) = $arg->{devs}; # devices from the configuration file

  my($lux) = "/usr/sbin/luxadm";
  my($err,$probe);
  
#
# Find ENCLOSURES AND PATHS with PROBE
#
  ($err,$probe) = &run_command("$lux probe","","-p", $cache1);
  my($in, $l);
  my($hbalist, $t3, $ix);
  for ($ix=0; $ix <= $#$probe; $ix++) {
      $l = $probe->[$ix];
      if ($l =~ /Found/) {
        $in = 1;
      } elsif ($in) {
        if ($l =~ / Node WWN:(.+)\s+Device Type:Disk/) { # t3 or internal..
          my($wwn) = Util->trim($1); 
          ($err, $disks) = &run_command("$lux display $wwn","","", $cache1);
          my($rep) = "@$disks";
          if ($rep =~ /T300/) {
             $rep =~ /Serial Num:\s+(\d+)/;
             my($name) = $1;
             $ENC{$wwn} = $name;
             $ix += 1;
             while ($probe->[$ix] =~ /Logical Path:(.*)/) {
               my($hba) = Util->trim($probe->[$ix+2]);
               if ($hba !~ /devices\/scsi_/) {
                  my($ii) = rindex($hba, "/");
                  $hba = substr($hba, 0 , $ii);
                  if (index($hbalist, "$hba,") < 0) {
                    push(@HBA, $hba);
                    $hbalist .= "$hba,";
                  }
               } else {
                  foreach my $ll (@$disks) {
                    if ($ll =~ /^\s+Controller\s+(.*)/) {
                       my($h2) = $1 . ":devctl";
                       if (index($hbalist, "$h2,") < 0) {
                          push(@HBA, $h2);
                          $hbalist .= "$h2,";
                       }
                    }
                }
         
               }
               $ix += 3;
             }
          }
        }
     }
  }

  if (defined($encs)) {
    %ENC = ();
    my(@a) = split(/,/, $encs);
    foreach my $enc (@a) {
        $ENC{$enc}  = 1;
    }
  }
  
  foreach my $wwn (keys %ENC) {
    $WWN{$wwn}{enc} = $wwn ; # $ENC{$wwn};
    if ($confDevs) {
       foreach my $d (@$confDevs) {
          if ($d->{type} eq "t3" && 
               lc(substr($d->{wwn},-4)) eq lc(substr($wwn,-4))) {
               $WWN{$wwn}{enc} = $d->{name};
          }
       }
    } 
  }

#
# FOR EACH HBA, GET COUNTERS 
#
  my($map, $err2, $rdls, @c, $hba);
  for ($x=0; $x <= $#HBA; $x++ ) {
     $hba = $HBA[$x];
     print "reading hba $x ($hba) <br>\n" if ($debug);
     my($err,$map) = &run_command("$lux -e dump_map","", $hba, $cache2);
     my($last) = substr($hba,-1);
     my($err2,$rdls) = &run_command("$lux -e rdls",$last, $hba, $cache2);
     $in =0;
     my($fabric) = 0;
     foreach $l (@$map) {
        next if ($l =~ /^ *$/);
        if ($l =~ /^Pos/) {
            $in = 1;
            $fabric = 1 if ($l =~ /Port_ID/);
        } elsif ($in) {
          my($n,$alpa,$id,$hard,$port,$node,$type,$desc);
          if ($fabric) {
            ($n,$alpa,$hard,$port,$node,$type,$desc) = split(/\s+/, $l,7) ;
          } else {
            ($n,$alpa,$id,$hard,$port,$node,$type,$desc) = split(/\s+/, $l,8) ;
          }
          $alpa = sprintf("%02s", $alpa);
          $ALPA{$x}{$alpa}{port} = $port;
          $ALPA{$x}{$alpa}{node} = $node;
          $ALPA{$x}{$alpa}{type} = $type;
          @c = split(/ /, substr($desc,1));
          $ALPA{$x}{$alpa}{desc} = $c[0];
        }
     }
     $in =0; 
     foreach $l (@$rdls) {
        next if ($l =~ /^ *$/);
        if ($l =~ /^al_pa/) {
           $in = 1;
        } elsif ($l =~ /^NOTE:/) {
           $in = 0;
        } elsif ($in) {
           my($alpa,$lnk,$sync,$signal,$seq,$word,$crc) = split(/\s+/, $l);
           $alpa = sprintf("%02s", $alpa);
           $ALPA{$x}{$alpa}{link}   = $lnk;
           $ALPA{$x}{$alpa}{sync}   = $sync;
           $ALPA{$x}{$alpa}{signal} = $signal;
           $ALPA{$x}{$alpa}{seq}    = $seq;
           $ALPA{$x}{$alpa}{word}   = $word;
           $ALPA{$x}{$alpa}{crc}    = $crc;
        }
     }
     
  }
  my($out, @X, %SUMM, $hba , $form0, $form, $form2, $al, $hba0);
  my(%ses_cnt) = 0;
  if (!$report) {
    for ($x=0; $x <= $#HBA; $x++ ) {
       push(@X, "#" . (100+$x) . "=$HBA[$x]");
    }
  } 
  for ($x=0; $x <= $#HBA; $x++ ) {
     $hba = $hba0 = $HBA[$x];
     $hba =~ s/\/devices\///;
     if ($report) {
       @X = ();
       $out .= "\nHBA ($x): $hba \n";
       $form0 = "%-5.5s %-10.10s %-10.10s %-4.4s %-16.16s %-12.12s %-6.6s";
       $form  = "$form0 %6s %6s %6s %6s %6s %6s\n";
       $form2 = "$form0 %6d %6d %6d %6d %6d %6d\n";
       $out .= sprintf($form, "Path",
              "Enclosure","Disk","Alpa","Wwn","Logical","Desc","Link","Signal","Seq","Crc",
              "Sync","Word");
       $out .= "-" x 111 . "\n";
     }
     my($y) = $ALPA{$x};
     my($al2, $wwn, $enc, $disk, $device);
     my($hbadone)= 0;
     foreach $al (keys %$y) {
         $al2 = $y->{$al};
         $wwn  = $al2->{node};
         if ($WWN{$wwn}{enc}) {
             $disk = "ctrl";
             $enc = $WWN{$wwn}{enc};
         } else {
             next if ($hbadone);
             $hbadone = 1;
             $enc = "hba";
             $disk = "-";
         }
         my($path) = 100 + $x;
         if ($report) {
           my($enc0) = $enc;
           $enc0 = substr($enc0,-10) if (length($enc0) > 10) ;
           push(@X, sprintf($form2, $path, $enc0, $disk, $al, $wwn, $device, $al2->{desc},
                        $al2->{link}, $al2->{signal}, $al2->{seq}, $al2->{crc},$al2->{sync},$al2->{word}));
         } else {
#                    ------ key -------  values
           push(@X, "$path|$enc|$disk|t3\t$al2->{link}\t$al2->{signal}\t$al2->{seq}\t$al2->{crc}\t$al2->{sync}\t$al2->{word}");
           $SUMM{"$x|$enc|$disk"} = "$al\t$wwn\t$device\t$al2->{desc}";
         }
     }
     if ($report) {
       foreach $l (sort @X) {
         $out .= $l;
       }
     }
  }
  my($err);

  if ($confDevs) {
      $out .= "\nOutOfBand:\n" . ("-" x 111) . "\n";
      foreach my $d (@$confDevs) {
         if ($d->{type} eq "t3" && $d->{telnet}) {
            @X = () if ($report);
            $err .= &get_telnet($d, \@X, $form2, $report);
            print "<pre>$err</pre>" if ($err);
            if ($report) {
               foreach $l (sort @X) {
                 $out .= $l;
               }
            }
         }
      }
  }
 
  print "Done\n" if ($debug);
  if (!$report) {
    return (\@X, \%SUMM);
  } else {
    return $out;
  }
}

sub get_telnet {
  my($d, $X, $form2, $report) = @_;
  my($unit, $path, $l, $disk, $enc, $sim);
  my($err);
  my($ip) = $d->{ip};
  my(@L, @l);
  my($pass) = $d->{telnet};

  my($t) = new Net::Telnet (
             errmode => "return",
             Timeout   => 30,
             Prompt    => '/<\d+\>/',
             );
  if (!defined($t->open($ip))) {
      return undef;
  }
  $t->login("root", $pass);
  my(%W);
  if (0) {
  @l = $t->cmd("port list");
  foreach my $port (@l) {
     my(@b) = split(/\s+/, $port);
     $W{substr($b[0],0,2)} = $b[5];
  }
  }
  foreach $path ('0','1') {
    foreach $unit ('1','2') {
       @l = $t->cmd(".disk linkstat u${unit}d1-9 path $path");
       foreach $l (@l) {
         if ($l =~ /Failed/) {
            $err .= $l;
         } elsif ($l =~ /^u\dd\d/) {
           my(@a) = split(/\s+/, $l);
           $enc = $d->{name};
           $disk = $a[0];
           if ($report) {
             my($enc0) = $enc;
             $enc0 = substr($enc0,-10) if (length($enc0) > 10);
             my($w) = "-" ; # $W{substr($a[0],0,2)};
             push(@$X, sprintf($form2, "b$path", $enc0, $a[0], "-", $w, "-",
                   "Disk", $a[1], $a[3], $a[4], $a[6], $a[2], $a[5]));
           } else {
             push(@$X, "b$path|$enc|$disk|t\t$a[1]\t$a[3]\t$a[4]\t$a[6]\t$a[2]\t$a[5]");
           }
         }
       }
    }
  }
  foreach $sim ('0','1', '2') {
      @l = $t->cmd(".sim -f num $sim linkstat");
      foreach $l (@l) {
        if ($l =~ /Error/) {
            $err .= "sim$sim: $l";
        } elsif ($l =~ /^\d+\s+\d+/) {
          my(@a) = split(/\s+/, $l);
          $enc = $d->{name};

          if ($report) {
            my($enc0) = $enc;
            $enc0 = substr($enc0,-10) if (length($enc0) > 10) ;
            push(@$X, sprintf($form2, "-", $enc0, "sim$sim", "-", "-", "-",
                  "Sim", $a[0], $a[2], $a[3], $a[5], $a[1], $a[4]));
          } else {
            push(@$X, "|$enc|s$sim|t\t$a[0]\t$a[2]\t$a[3]\t$a[5]\t$a[1]\t$a[4]");
          }
        }
     }
  }
              


  $t->close;
  return $err;
}


sub run_command {
  my($com, $ext, $arg, $save) = @_;
  my(@out, $err, $l, $ix);
  my($file);
  my($TMP) = System->get_home() ."/DATA/tmp";

  $file = "$com$ext";
  $ix = index($file, " ");
  $file = substr($file,$ix+1);
  $file =~ s/ /_/g;

  if ($save && -f "$TMP/luxdisc.$file" ) {
     open(W, "$TMP/luxdisc.$file");
     while ($l = <W>) {
       chop($l);
       push(@out, $l);
     }
     close(W);
     return("", \@out);
  }
  print "Running $com $arg in file ($file) ...\n" if (Debug->level());
  my($com1) = "$com $arg 2>$TMP/luxdisc.err";

  open(O, "$com1|");
  while ($l = <O>) {
    chop($l);
    push(@out, $l);
  }
  close(O);

  open(W, ">$TMP/luxdisc.$file");
  print W join("\n", @out);
  close(W);

  open(ERR, "$TMP/luxdisc.err");
  while ($l = <ERR>) {
    $err .= $l;
  }
  close(ERR);
  Debug->print0("Error: $err on $com") if ($err);
  return($err, \@out);
}

  
1;
