package GUI::A5KUtil;

use Util;
use GUI::SAN;
use System;
use Data::Dumper;
use Agent::A5KAgent;

sub fc_graph {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);

  print "<body bgcolor=#E0E0E0><center>";

  if ($q->{auto} > 0) {
    $q->{auto} = 2 if ($q->{auto} < 2);
    my $url = "/?GO=GUI::A5KUtil::fc_graph";
    foreach my $x (keys %$q) {
      next if ($x eq "GO");
      $url .= "&$x=$q->{$x}";
    }
    print "<meta http-equiv=Refresh content=\"$q->{auto};URL=$url\">";
  }
  my $mach = Util->select_hosts("GUI::A5KUtil::fc_graph");
  my $hostname = System->shortHostname();
  print &main::header("A5K FC Graph (on $hostname)", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();
  my($debug) = 0;
  my($cache) = 0;
  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allA5) = "<select name=A5>";
  $q->{A5} = "*List" if (!$q->{A5});
  $allA5 .= ($q->{A5} eq "*List") ? "<option selected>*List": "<option>*List";
  
  foreach $d (@$devs) {
     if ($d->{type} eq "a5k") {
       $first = "$d->{name}" if (!$first);
       $allA5 .= ($d->{name} eq $q->{A5})? "<option selected>$d->{name}":"<option>$d->{name}";
     }
  }
  $allA5 .= "</select>";

  if ($q->{A5} eq "*List") {
     $list = join(",", @$a5);
  } elsif ($q->{A5}) {
     $list = $q->{A5};
  }
  my($ext) = $list;
  $ext =~ s/,/_/g;

  my($list2);
  $x = A5KAgent->FCCounters({ cache => $cache, encs => $list});
  my(%L);
  my $L = $x->{enc};
  foreach my $x (keys %$L) {
     $list2 .= "$x," if (index($list, $L->{$x}) >=0);
  }

  my($BDF) = System->get_home() . "/DATA/tmp/A5kFCgraph.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   @X = ();
   foreach $e ('front','rear') {
     for ($x1=0; $x1 <= 10; $x1++) {
        push(@X, "$e.$x1");
        $xvalues .= uc(substr($e,0,1)) . sprintf("%2.2d=$e.$x1,", $x1);
     }
   }

  push(@X, "ses0","ses1");
  $xvalues .= "ses0=Ses0,ses1=Ses1,";

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth - 45;
  var a_height =  window.innerHeight -130;
  window.document.writeln(
   '<applet  $FC::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>

<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="javascript:return">
<param name=urlY value="javascript:return">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $hbas = $x->{hba};
   my $encs = $x->{enc};
   my($y);
   my $hba_list;
   $sel = "<select name=hba><option value=\"\">All</option>";

   foreach $y (sort keys %$hbas) {
      $HBA[$y] = $hbas->{$y};
      $xx = $hbas->{$y}; $xx =~ s/\/devices\///;
      $hba_list .= "$xx|";
      $ck = ($q->{hba} ne "" && ($y == $q->{hba})) ? "selected":"";
      $sel .= "<option value=$y $ck>$y=$xx</option>";
      $cnt++;
   }
   $sel .= "</select>";

   my $data = $x->{data};
   my $in ;
   foreach $y (sort keys %$data) {
     @c = split(/\|/, $y);

     next if ($c[2] eq "hba");
     $enc =  $c[0] . "|" . $c[1];

     $disk = $c[2];
#     $disk = "ses" if (substr($disk,0,3) eq "ses");
     $D{$enc}{$disk} = $data->{$y};
     $in = 1;
   }

   $stack_cnt = 1;
   $gc        = 1;

   foreach $enc (sort keys %D) {
     my(@c) = split(/\|/, $enc);
     my($c1, $c2) = split(/\|/, $enc);
     next if (index($list2, $c2) < 0);
     $enc0 = $c[0] . "-" . $encs->{$c[1]};
     next if ($q->{hba} && $q->{hba} != $c[0]);
     $tit = $hbas->{$c[0]} . " /" . $encs->{$c[1]};
     $applet .= "<param name=title$stack_cnt value=\"$enc0=$tit\">";

     $seq_data = $link_data = $sync_data = $word_data = $crc_data = $sig_data = "";

     foreach $disk (@X) {
       my @new = split(/\t/, $D{$enc}{$disk});
       @reset1 = split(/\t/, $reset->{data}{"$enc|$disk|a5k"});

       $link_data .= ($new[0] - $reset1[0]) . ",";   
       $sig_data  .= ($new[1] - $reset1[1]) . ",";   
       $seq_data  .= ($new[2] - $reset1[2]) . ",";   
       $crc_data  .= ($new[3] - $reset1[3]) . ",";   
       $sync_data .= ($new[4] - $reset1[4]) . ",";   # sync
       $word_data .= ($new[5] - $reset1[5]) . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     chop($sig_data); chop($crc_data);

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="cyan">
<param name=graph$gc value="$link_data">
<PARAM name=label$gc value="Link-Fail">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="green">
<param name=graph$gc value="$sig_data">
<PARAM name=label$gc value="Sign-Loss">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Inv TXWord">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$crc_data">
<PARAM name=label$gc value="Inv-CRC">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="white">
<param name=graph$gc value="$seq_data">
<PARAM name=label$gc value="Inv-Seq">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   if ($created) {
     $title = "Error Counters since $created by Enclosure/Disk";
   } else {
     $title = "All Error Counters by Enclosure/Disk";
   }
   if ($gc == 1) {
     $applet = "<table border=0 width=100% bgcolor=white>
   <tr><td><center>&nbsp;<br><b><font color=red>No A5K available!<br>&nbsp;</table>";
   }
  
   
   print "&nbsp;
    <table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>
    <table border=0 cellspacing=0 cellpadding=0 width=100% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=GUI::A5KUtil::fc_graph>
      <input type=hidden name=option value=2>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          Select A5K: $allA5 &nbsp;
          HBA: $sel 
         Auto:<input type=text size=3 name=auto value=$q->{auto}>
         <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td align=right nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>
    <tr bgcolor=black>
       <td colspan=2 nowrap>
         <center><table border=0><tr><td><font color=white><b>&nbsp;$title</table></td>
    <tr><td colspan=2>$applet</td>
    </table></table></form>";
  
}


sub fc_data {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);

  print "<body bgcolor=#E0E0E0><center>";
  if ($q->{auto} > 0) {
    $q->{auto} = 2 if ($q->{auto} < 2);
    my $url = "/?GO=GUI::A5KUtil::fc_data";
    foreach my $x (keys %$q) {
      next if ($x eq "GO");
      $url .= "&$x=$q->{$x}";
    }
    print "<meta http-equiv=Refresh content=\"$q->{auto};URL=$url\">";
  }
  my $mach = Util->select_hosts("GUI::A5KUtil::fc_data");
  my $hostname = System->shortHostname();
  print &main::header("A5K FC Data (on $hostname)", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();
  my($debug) = 0;
  my($cache) = 0;
  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allA5) = "<select name=A5>";
  $q->{A5} = "*List" if (!$q->{A5});
  $allA5 .= ($q->{A5} eq "*List") ? "<option selected>*List": "<option>*List";
  
  foreach $d (@$devs) {
     if ($d->{type} eq "a5k") {
       $first = "$d->{name}" if (!$first);
       $allA5 .= ($d->{name} eq $q->{A5})? "<option selected>$d->{name}":"<option>$d->{name}";
     }
  }
  $allA5 .= "</select>";

  if ($q->{A5} eq "*List") {
     $list = join(",", @$a5);
  } elsif ($q->{A5}) {
     $list = $q->{A5};
  }
  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = A5KAgent->FCCounters({ cache => $cache, encs => $list});

  my(%WWN);
  my($err, $devs) = Util->run_command("/usr/sbin/luxadm sysdump", "test", 100);

  foreach my $l (@$devs) {
    my($phy, $nodewwn, $portwwn, $logical, $name) = split(/\s+/, $l);
    my $i2  = rindex($phy, "/");
    $phy = substr($phy, 0, $i2);
    $logical =~ s/\/dev//;
    $logical =~ s/\/rdsk//;
    $WWN{$name}{$phy} = $logical;
  }


  my($BDF) = System->get_home() . "/DATA/tmp/A5kFCdata.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $hbas = $x->{hba};
   my $encs = $x->{enc};
   my($y);
   my $hba_list;
   my $report;

   $sel = "<select name=hba><option value=\"\">All</option>";

   foreach $y (sort keys %$hbas) {
      $HBA[$y] = $hbas->{$y};
      $xx = $hbas->{$y}; $xx =~ s/\/devices\///;
      $hba_list .= "$xx|";
      $ck = ($q->{hba} ne "" && ($y == $q->{hba})) ? "selected":"";
      $sel .= "<option value=$y $ck>$y=$xx</option>";
      $cnt++;
      $report .= "$y=$xx\n";
   }
   $report .= "\n";
   $sel .= "</select>";
   $report .= "Name         Component  Logical      ".
      "LinkFail   LossSig       Seq       CRC      Sync   InvTxWd \n";
   $report .= "=" x 98 . "\n";

   my $data = $x->{data};

   foreach $y (keys %$data) {
     my(@c) = split(/\|/, $y);
     $y2 = "$c[0]|$c[1]|$d[0].". sprintf("%2.2d", $d[1]) . "|$c[3]";
     $D{$y2} = $data->{$y};
   }
   my(@report);
   foreach $y (keys %$data) {
     my(@c) = split(/\|/, $y);
     my(@d) = split(/\./, $c[2]);
     if ($#d == 1) {
       $disk = $d[0] . "." . sprintf("%2.2d", $d[1]);
     } else {
       $disk = $c[2];
     }
     next if (defined($q->{hba} ) && $q->{hba} != $c[0]);

     my $enclosure =  $encs->{$c[1]};
     my ($fr, $no) = split(/\./, $c[2]);
     my $n1;
     if ($fr eq "ses") {
        $n1 = $enclosure;
     } else {
        $n1 = "$enclosure," . substr($fr,0,1) . ($no+0);
     }
     my $logical = $WWN{$n1}{$hbas->{$c[0]}};

     my @new = split(/\t/, $data->{$y});
     @reset1 = split(/\t/, $reset->{data}{$y}) if ($reset);
     my(@y2) = ();
     my($pf);
     for ($y1=0; $y1 <= 5; $y1++) {
        $dif = $new[$y1] - $reset1[$y1];
        if ($reset && $dif ) {
           push(@y2, "<b>$dif/</b>$new[$y1]");
           $pf .= "%17s";
        } else {
           push(@y2, "$new[$y1]");
           $pf .= "%10s";
        }
     }
     push(@report, sprintf("%-13s%-10s%-12s$pf\n",
                    $c[0] . "-" . $enclosure, $disk, $logical, @y2));

   }
   my($last);
   foreach $l (sort @report) {
     if (substr($l,0,10) ne $last) {
       $report .= "\n" if ($last); 
       $last = substr($l,0,10);
     }
     $report .= $l;
   }

   if ($created) {
     $title = "Error Counters since $created by Enclosure/Disk";
   } else {
     $title = "All Error Counters by Enclosure/Disk";
   }

   print "
    <table border=1 cellspacing=0 cellpadding=4 width=95% bgcolor=white>
    <form>
      <input type=hidden name=GO value=GUI::A5KUtil::fc_data>
      <input type=hidden name=option value=3>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          FC Counters for A5K: $allA5 
          HBA: $sel 
          Auto:<input type=text size=3 name=auto value=$q->{auto}>
          <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>

    <tr> <td colspan=2><b>$title ($list)</b><br><pre> $report</td>

    </table></form>&nbsp;<p>&nbsp;";
}
  

1;
