package GUI::T3Util;

use Util;
use GUI::SAN;
use System;
use Data::Dumper;
use Agent::T3Agent;

sub fc_graph {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset);
  my($mach);
  print "<body bgcolor=#E0E0E0><center>";
#  my $mach = Util->select_hosts("GUI::T3Util::fc_graph");
#  my $hostname = System->shortHostname();
  print &main::header("T3 FC Graph ", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();
  my($debug) = 0;
  my($cache) = 0;
  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allT3) = "<select name=T3>";
  $q->{T3} = "*List" if (!$q->{T3});
  $allT3 .= ($q->{T3} eq "*List") ? "<option selected>*List": "<option>*List";
  
  foreach $d (@$devs) {
     if ($d->{type} eq "t3") {
       $first = "$d->{name}" if (!$first);
       $allT3 .= ($d->{name} eq $q->{T3})? "<option selected>$d->{name}":"<option>$d->{name}";
     }
  }
  $allT3 .= "</select>";

  if ($q->{T3} eq "*List") {
     $list = join(",", @$t3);
  } elsif ($q->{T3}) {
     $list = $q->{T3};
  }
  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = T3Agent->FCCounters({ cache => $cache, encs => $list});

  my($BDF) = System->get_home() . "/DATA/tmp/T3FCgraph.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   @X = ();
   foreach $e ('front','rear') {
     for ($x1=0; $x1 <= 10; $x1++) {
        push(@X, "$e.$x1");
        $xvalues .= uc(substr($e,0,1)) . sprintf("%2.2d=$e.$x1,", $x1);
     }
   }

  push(@X, "ses0","ses1");
  $xvalues .= "ses0=Ses0,ses1=Ses1,";

  $applet =<<EOF;
  <script>
  var a_width =  window.innerWidth - 45;
  var a_height =  window.innerHeight -130;
  window.document.writeln(
   '<applet  $FC::APPLET height=' + a_height + ' width=' + a_width + '>');
  </script>

<param name=xTitle value="Front / Rear disks">
<param name=nostyles value=0>
<param name=printCb value=1>
<PARAM name=backColor value="0,0,0">
<param name=showYvalues value=3>
<param name=browser value="sun">
<param name=fontsize value=11>
<param name=Yfontsize value=10>
<param name=minY value=0>
<param name=decimalsY value=-1>
<xparam name=maxY value=20>
<param name=hideXvalues value=0>
<xparam name=urlColor value="white">
<param name=logY value=2>
<param name=gridCntY value=5>
<param name=vertSpace value=3>
<PARAM NAME=fontColor value="250,250,250">
<PARAM name=Grid value=1>
<param name=graphType value=40>
<param name=urlX value="/?GO=GUI::T3Util::&fc_graph&">
<param name=urlY value="/?GO=GUI::T3Util::&fc_graph&">
<param name=xurlTarget value="">
<param name=statusInfo value="select,disk,enclosure">
<param name=ySuffix value="">
<param name=hlColor value="250,250,100">
<PARAM name=xValues value="$xvalues">
<xparam name=minX value=1>
<xparam name=maxX value=9>
EOF
   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $hbas = $x->{hba};
   my $encs = $x->{enc};
   my($y);
   my $hba_list;
   $sel = "<select name=hba><option value=\"\">All</option>";

   foreach $y (sort keys %$hbas) {
      $HBA[$y] = $hbas->{$y};
      $xx = $hbas->{$y}; $xx =~ s/\/devices\///;
      $hba_list .= "$xx|";
      $ck = ($q->{hba} ne "" && ($y == $q->{hba})) ? "selected":"";
      $sel .= "<option value=$y $ck>$y=$xx</option>";
      $cnt++;
   }
   $sel .= "</select>";

   my $data = $x->{data};
   my $in ;
   foreach $y (sort keys %$data) {
     @c = split(/\|/, $y);

     next if ($c[2] eq "hba");
     $enc =  $c[0] . "|" . $c[1];

     $disk = $c[2];
#     $disk = "ses" if (substr($disk,0,3) eq "ses");
     $D{$enc}{$disk} = $data->{$y};
     $in = 1;
   }

   if (!$in) {
     print "<h2>No device selected!";
     return;
   }
   $stack_cnt = 1;
   $gc        = 1;

   foreach $enc (sort keys %D) {
     my(@c) = split(/\|/, $enc);
     $enc0 = $c[0] . "-" . $encs->{$c[1]};
     next if (defined($q->{hba} ) && $q->{hba} != $c[0]);
     $tit = $hbas->{$c[0]} . " /" . $encs->{$c[1]};
     $applet .= "<param name=title$stack_cnt value=\"$enc0=$tit\">";

     $seq_data = $link_data = $sync_data = $word_data = $crc_data = $sig_data = "";

     foreach $disk (@X) {
       my @new = split(/\t/, $D{$enc}{$disk});
       @reset1 = split(/\t/, $reset->{data}{"$enc|$disk|a5k"});

       $link_data .= ($new[0] - $reset1[0]) . ",";   
       $sig_data  .= ($new[1] - $reset1[1]) . ",";   
       $seq_data  .= ($new[2] - $reset1[2]) . ",";   
       $crc_data  .= ($new[3] - $reset1[3]) . ",";   
       $sync_data .= ($new[4] - $reset1[4]) . ",";   # sync
       $word_data .= ($new[5] - $reset1[5]) . ",";   # word 
     }
     chop($sync_data); chop($word_data);
     chop($sig_data); chop($crc_data);

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="cyan">
<param name=graph$gc value="$link_data">
<PARAM name=label$gc value="Link-Fail">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="green">
<param name=graph$gc value="$sig_data">
<PARAM name=label$gc value="Sign-Loss">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="blue">
<param name=graph$gc value="$sync_data">
<PARAM name=label$gc value="Sync-Loss">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;

     $applet .=<<EOF;
<PARAM name=graphColor$gc value="red">
<param name=graph$gc value="$word_data">
<PARAM name=label$gc value="Inv TXWord">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="yellow">
<param name=graph$gc value="$crc_data">
<PARAM name=label$gc value="Inv-CRC">
<PARAM name=yOffset$gc value="0">
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $applet .=<<EOF;
<PARAM name=graphColor$gc value="white">
<param name=graph$gc value="$seq_data">
<PARAM name=label$gc value="Inv-Seq">
<PARAM name=yOffset$gc value="0">
<param name=active$gc value=0>
<param name=stack$gc value=$stack_cnt>
EOF
     $gc++;
     $stack_cnt++;
   }
   $applet .= "</applet>\n";
   if ($created) {
     $title = "Error Counters since $created by Enclosure/Disk";
   } else {
     $title = "All Error Counters by Enclosure/Disk";
   }
  
   
   print "&nbsp;
    <table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>
    <table border=1 cellspacing=0 cellpadding=0 width=100% bgcolor=black>
    <form method=get>
      <input type=hidden name=GO value=GUI::T3Util::fc_graph>
      <input type=hidden name=option value=12>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          Select T3: $allT3 &nbsp;
          <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>
    <tr bgcolor=black>
       <td colspan=2 nowrap>
         <center><table border=0><tr><td><font color=white><b>&nbsp;$title</table></td>
    <tr><td colspan=2>$applet</td>
    </table></table></form>";
  
}


sub fc_data {
  my($q) = @_;
  my(%D, $applet, $x, $summ, @X, $xvalues, $reset, $oob_data, $oob_err);
  my($err);
  my($mach);
  print "<body bgcolor=#E0E0E0><center>";
  if ($q->{auto} > 0) {
    $q->{auto} = 2 if ($q->{auto} < 2);
    my $url = "/?GO=GUI::T3Util::fc_data";
    foreach my $x (keys %$q) {
      next if ($x eq "GO");
      $url .= "&$x=$q->{$x}";
    }
    print "<meta http-equiv=Refresh content=\"$q->{auto};URL=$url\">";
  }

#  my $mach = Util->select_hosts("GUI::T3Util::fc_data");
#  my $hostname = System->shortHostname();
  print &main::header("T3 FC Data ", "95%", $mach, "fcutil");

  my($a5, $sw, $t3) = GUI::SAN::findSelected();

  my($debug) = 0;
  my($cache) = 0;

  if ($q->{ACTION} eq "ClearCache") {
    $cache = 2 ; $debug = 1;
  }
  my($list);
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read;
  my($first);
  my($allT3) = "<select name=T3><option value=\"\">[Select]";
  
  foreach $d (@$devs) {
    if ($d->{type} eq "t3") {
       $first = "$d->{name}" if (!$first);
       if ($d->{name} eq $q->{T3}) {
         $allT3 .= "<option selected>$d->{name}";
#         ($err, $oob_data, $oob_err) = T3Agent->FCCountersOOB($d);
         print "<font color=red><b>FCCountersOOB: $err</b></font>" if ($err);
       } else {
         $allT3 .= "<option>$d->{name}";
       }
    }
  }
  $allT3 .= "</select>";

  if ($q->{T3}) {
     $list = $q->{T3};
  }
  my($ext) = $list;
  $ext =~ s/,/_/g;

  $x = T3Agent->FCCounters({ cache => $cache, encs => $list});

   my $data = $x->{data};
   if ($oob_data) {
      foreach my $kk (keys %$oob_data) {
         $data->{$kk} = $oob_data->{$kk};
      }
   }

  my($BDF) = System->get_home() . "/DATA/tmp/T3FCdata.$ext";

  if ($q->{ACTION} eq "Set-Baseline") {
     open(O, ">$BDF");
     print O Dumper($x);
     close(O);
  } elsif ($q->{ACTION} eq "Total") {
     unlink $BDF;
  }
  my($created) = "";

  if (-r $BDF) {
     open(O, $BDF); 
     my @a = <O>; close(O);
     eval "@a";
     $reset = $VAR1;
     $created = Util->get_file_created($BDF);
     ($hrs, $mins, $secs) = Util->getFileAge($BDF, "hms");
     $created = " <small>" . substr($created, 5) . " ( ${hrs}h ${mins}m ${secs}s</small>)";
  }

   my($line, @b, @c,  $gc, $enc, $disk, @HBA, @ENC2);

   my $hbas = $x->{hba};
   my $encs = $x->{enc};
   my($y);
   my $hba_list;
   my $report;

   $sel = "<select name=hba><option value=\"\">All</option>";

   foreach $y (sort keys %$hbas) {
      $HBA[$y] = $hbas->{$y};
      $xx = $hbas->{$y}; $xx =~ s/\/devices\///;
      $hba_list .= "$xx|";
      $ck = ($q->{hba} ne "" && ($y == $q->{hba})) ? "selected":"";
      $sel .= "<option value=$y $ck>$y=$xx</option>";
      $cnt++;
      $report .= "$y=$xx\n";
   }
   $report .= "\n<table border=0 cellspacing=0 cellpadding=0>";
   $sel .= "</select>";
   $report .= "<tr><td><pre>Name          Path Component" . 
     "   LinkFail   LossSig  ProtoErr    InvCRC  LossSync   InvTxWd \n";
   $report .= "<tr><td><pre>" . ("=" x 98) . "\n";


   my(@report);
   foreach $y (keys %$data) {
     my(@c) = split(/\|/, $y);
     my(@d) = split(/\./, $c[2]);

     my @new = split(/\t/, $data->{$y});
     @reset1 = split(/\t/, $reset->{data}{$y}) if ($reset);
     my(@y2) = ();
     my($pf);
     for ($y1=0; $y1 <= 5; $y1++) {
        $dif = $new[$y1] - $reset1[$y1];
        if ($reset && $dif ) {
           push(@y2, "<b>$dif/</b>$new[$y1]");
           $pf .= "%17s";
        } else {
           push(@y2, "$new[$y1]");
           $pf .= "%10s";
        }
     }
     my $path = ($c[0] eq "")?  "-": $c[0];
     push(@report, sprintf("%-14s%-5s%-10s$pf\n",$c[1], $path,  $c[2],  @y2));

   }
   my($last);
   my $cnt;
   foreach $l (sort @report) {
     my $bg = ($cnt++ % 2 == 0)? "bgcolor=#F0F0F0":"";
     $report .= "<tr $bg><td><pre>$l";
   }
   $report .= "</table>";

   if ($created) {
     $title = "Error Counters since $created by Enclosure/Disk";
   } else {
     $title = "All Error Counters by Enclosure/Disk";
   }

   $oob_err = "<b><font color=red>Error:$oob_err.</font></b>" if ($oob_err);
   print "
    <table border=1 cellspacing=0 cellpadding=4 width=95% bgcolor=white>
    <form>
      <input type=hidden name=GO value=GUI::T3Util::fc_data>
      <input type=hidden name=option value=31>
    <tr bgcolor=#666699>
       <td nowrap ><font color=white><b>
          FC Counters for T3: $allT3 &nbsp;
           Auto:<input type=text size=3 name=auto value=$q->{auto}>
           <input type=submit name=ACTION value=Refresh>&nbsp;</td>
       <td nowrap><b><font color=white>&nbsp;
          <input type=submit name=ACTION value=Set-Baseline>
          <input type=submit name=ACTION value=Total>
          <input type=submit name=ACTION value=ClearCache>
       </td>

    <tr> <td colspan=2><b>$title ($list)</b><br>$oob_err<pre> $report</td>

    </table></form>&nbsp;";
    if (!$q->{T3}) {
       print "<b>No T3 selected!";
    }
}
  

1;
