package GUIAdmin::SWITCH;
#  $Name:  $ 
#  $Id: SWITCH.pm,v 1.24 2001/09/28 02:56:32 ccadieux Exp $

use PDM;

use strict;
use Debug;
use Carp;
use GUIAdmin;
use base 'GUIAdmin';

sub description {'Switch'}
sub isDevice {1}

sub ipRequired {1}

sub can_add {
  my($host, $ip, $name, $dev, $F, $adding) = @_;
  my($ipno, $python);
  
  if (!($ipno = Util->testIp($ip))) {
      return "Cannot ping this Switch: $ip<br>";
  }
  if (!$F->{$ipno} ) {
      $F->{$ipno} = 1;
      $$adding = 1;
      my($new_dev) = $#$dev  + 1;

      my($wwn) = &find_wwn($ipno);

      $dev->[$new_dev]{_name}    = "device" . $new_dev;
      $dev->[$new_dev]{type}     = 'switch';
      $dev->[$new_dev]{name}     = $name || "S" . $ip;
      $dev->[$new_dev]{ip}       = $ip;
      $dev->[$new_dev]{wwn}      = $wwn;
      $dev->[$new_dev]{ipno}     = $ipno;
      $dev->[$new_dev]{host}     = $host;
      $dev->[$new_dev]{active}   = "Y";
      $F->{$ipno} = 1;

#     LOOK FOR MORE SWITCHES
      my($err,$com) = Util->run_command( System->get_home() . 
                          "/bin/sanbox port_status $ip all", "raidutil.txt", 10);
      foreach my $l (@$com) {
         if ($l =~ /T_Port\s+Linked-to:/) {
            my($l0) = $l;
            $l0 =~ /Port:\s+(\d+)/;
            my($port) = $1;
            $l =~ /Linked-to: ([0-9a-f]+)\s+IP:\s+([0-9\.]+)\s+FC:\s+(\d+)/;
            my($wwn2, $ipno2, $fc2) = ($1,$2,$3);
            if ($wwn2) {
               if (!$F->{$ipno2} ) {
                  $F->{$ipno2} = 1;
                  $$adding = 1;
                  my($new_dev) = $#$dev  + 1;
 
                  my($wwn) = &find_wwn($ipno2);
                  $python .= "\n  - Found T_Port switch: $ipno2,";
                  $dev->[$new_dev]{_name}    = "device" . $new_dev;
                  $dev->[$new_dev]{type}     = 'switch';
                  if ($ipno2 =~ /\d+\.\d+\.\d+\.(\d+)/) {
                     $dev->[$new_dev]{name}     = "csw-" . $1;
                  } else {
                     $dev->[$new_dev]{name}     = "csw-$fc2";
                  }
                  $dev->[$new_dev]{ip}       = $ipno2;
                  $dev->[$new_dev]{wwn}      = $wwn;
                  $dev->[$new_dev]{fc}       = $fc2;
                  $dev->[$new_dev]{port}     = $port;
                  $dev->[$new_dev]{primary}  = $ip;
                  $dev->[$new_dev]{wwn}      = $wwn;
                  $dev->[$new_dev]{ipno}     = $ipno2;
                  $dev->[$new_dev]{host}     = $host;
                  $dev->[$new_dev]{active}   = "Y";
                  $F->{$ipno2} = 1;
                }   
            }
         }  
      }

      return "$python added. \n";
   }
   return "<b><font color=red>Switch Already exist.</font></b><br>\n";
}


sub discover {
  my($q, $post, $util) = @_;
  my(%T, @a, $loc, $ip);
  my(%F, $d, $adding, $found, $new_dev , $l , $name);
  my(@NEW);
  my($ipno);

  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read();
  $new_dev = $#$dev ;
  print "<pre>1 - Find Switches already registered ...\n";
  foreach $d (@$dev) {
     if ($d->{type} eq "switch") {
        $F{$d->{ipno}} = 1;
     }
  }
  print "2 - Finding New Switches from local Host ...\n";
  $adding = 0;

  if (-r "/etc/fcswitch.conf") {
     open(O,"/etc/fcswitch.conf");
     while ($l = <O>) {
         chomp($l);
         next if ($l !~ /^\d+/);
         @a = split(/\s+/, $l);
         print "  - Found new one at $a[0], $a[1] ... ";
         $ip = $a[0]; $name = $a[1];
         print &can_add("", $ip, $name, $dev, \%F, \$adding);
     }
  }
  if (!$adding) {
     print "      -> No new switches found in /etc/fcswitch.conf \n";
  }

  print "3 - Finding Switches on Slave Agents ..\n";
  my($h, $url, $a5, $data);
  foreach $h (@$host) {
    print "  - Querying host $h->{hostname} / $h->{ip} ...\n";
    $url = Util->makeUrl($h->{ip}, "?GET=device&type=switch");
    if (($data = Util::Http->get($url, 10)) ) {
      if (substr($data,0,3) eq "ERR") {
         print "  $data<br>";
         next;
      } else {
         $data = substr($data,3);
         my(@a) = split(/\n/, $data);
         foreach my $ip0 (@a) {
           ($ip, $name)  = split(/\|/, $ip0);
           print "  - Found new switch at $ip.. ";
           print &can_add($h->{hostname}, $ip, $name, $dev, \%F, \$adding);
           $h->{last_push} = "";
         }
      }
    } else {
      print "No response from Slave $h->{ip}<br>";
    }
  }

  if ($adding) {
      PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
  } else {
    print "  *** No new switches were added ***\n";
  }
  print "</pre>";
  return "DONE";

}


sub getDevices {
  my($q, $post, $util) = @_;
  my(@out, $f, $l, $name, $hba, $in , $wwn);

  my($HOME) = System->get_home();
  if (open(RUN, "/etc/fcswitch.conf")) {
     while ($l = <RUN>) {
         chop($l);
         next if ($l !~ /^\d+/);
         my(@a) = split(/\s+/, $l);
         $f .= "$a[0]|$a[1]\n";
     }
     close(RUN);
     return "OK $f";
  } else {
     return "ERR $!";
  }
}

sub addDevice {
  my( $q) = @_;
  my($ho, $o, $err, $ipno, $x, $info);
  my($renv, $dev, $host,$notifs, $sel);

  print "\n";
  require "GUI/Devices.pm";
  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq " Add ") {
    my($active) = "Y";
    while (1) {
     if ($q->{name} eq "") {
        $err = &main::info("Device name is mandatory <br>Record not added!");
        last;
     } elsif (!$q->{ip}) {
        $err = &main::info("You must enter an IP address for this device-type <br>Record not added!");
        last;
     } else {
        ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
        my(%F);
        foreach my $d (@$dev) {
          if ($d->{type} eq "switch") {
             $F{$d->{ipno}} = 1;
          }
        }
        my($adding) = 0;
        print &can_add($q->{host}, $q->{ip}, $q->{name}, $dev, \%F, \$adding);

        GUIAdmin->clearSlave($q->{host}, $host);

        if (!PDM::ConfigFile->write( $renv, $dev, $host,$notifs)) {
           print "Cannot write to ConfigFile<br>";
        } else {
           $info = &main::info("Device added!", "green");
        }

        GUI::Devices::list($q);
        return;
     }
     last;
    }
  }
out:
  my($h) = &main::header("Maintain Devices : Add Switch");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $sel = ($q->{host} eq "")? "selected":"";

  my($phost) = "<select name=host><option value=\"\">[Select]</option>".
              "<option value=\"\" $sel>Local</option>";

  foreach $x (@$host) {
    $sel = ($q->{host} eq $x->{hostname})? "selected":"";
    $phost .= "<option value=" . $x->{hostname} . " $sel>" . $x->{hostname} ."</option>";
  }
  $phost .= "</select>";

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form  method=get>
 <input type=hidden name=GO value="GUIAdmin::SWITCH::addDevice">
<center>
$h
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr><td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Enter Device Information</td>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name :</td>
    <td><input type=text name=name size=15 maxlength=15 value="$q->{name}">

<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td>$phost</td>
<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right> IP Name/Address :</td>
    <td><input type=text name=ip size=40 maxlength=40 value="$q->{ip}">

</table>
</table>
<b>
<input type=submit name=ACTION value=" Add ">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;

}

sub find_wwn {
  my($ip) = @_;

  my($err,$com) = Util->run_command(
         System->get_home() . "/bin/sanbox version $ip", "raidutil.txt", 10);
  my($com2) = "@$com";
  $com2 =~ /WWN:\s+([0-9a-f]+)/;
  my($wwn) = $1;
  return $wwn;
}

sub updDevice {
  my($q) = @_;
  my($ho, $o);
  my($name, $err, $ip, $ipno);
  my($renv, $dev, $host,$notifs, $x, $D, $type, $key, $h1, $h, $sel, $active);

  print "\n";
  require "GUI/Devices.pm";

  if ($q->{ACTION} eq "Back") {
    GUI::Devices::list($q);
    return;

  } elsif ($q->{ACTION} eq "Update") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $D = $dev->[$x];

    $dev->[$x]{host} = $q->{host};
    $dev->[$x]{name} = $q->{name};
    $dev->[$x]{hba}  = $q->{hba};
    GUIAdmin->clearSlave($q->{host}, $host);

    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    $err = &main::info("Device $name updated!", "green");

  } elsif ($q->{ACTION} eq "Delete") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
    $x = $q->{no};
    $type = $dev->[$x]{type};
    $key =  $dev->[$x]{ip};
    GUIAdmin->clearSlave($q->{host}, $host);

    &main::save_event("DD", $type,  $key) if ($key);
    $dev->[$x]{_name} = "";
    $name = $dev->[$x]{name} . "/ " . $dev->[$x]{ip};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);
    &main::log_change("Device $name deleted");
    $q->{ERR} = &main::info("Device $name deleted!");
    GUI::Devices::list($q);
    return;
  }
out:

 $h1 = &main::header("Maintain Devices : Update Switch");

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;
  $h = $dev->[$q->{no}];

  $ip = $h->{ip}; $ipno = $h->{ipno};

  $sel = ($h->{host})? "":"selected";
  $ho = "<select name=host><option value=\"\" $sel>Local</option>";
  foreach $h1 (@$host) {
       $sel = ($h1->{hostname} eq $h->{host}) ? "selected":"";
       $ho .= "<option name=$h1->{hostname} $sel>$h1->{hostname}</option>";
  }
  $ho .= "</select>";

  $active = ($h->{active} eq "Y") ? "On":"Off";
  my($primary);
  $primary = "<br><b>[ Monitored thru $h->{primary} port:$h->{port} on fc:$h->{fc} ]"
              if ($h->{primary});

  $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
<form method=get>
 <input type=hidden name=GO value=GUIAdmin::SWITCH::updDevice>
 <input type=hidden name=no value=$q->{no}>
<center>
$h1
$err
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Device Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Device Type :</td>
    <td>
      <table border=0 cellspacing=0 width=100%> <tr>
        <td><b>&nbsp;$h->{type}</td>
        <td bgcolor=$main'LIGHT align=right>Monitoring:</td>
        <td ><b>&nbsp;$active</td>
      </table>

<tr><td bgcolor=$main'LIGHT width=30% align=right>Device Name :</td>
    <td><input type=text name=name size=20 maxlength=40 value="$h->{name}">$primary

<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right>IP Name/Address :</td>
    <td>&nbsp;$ip</td>
<tr><td bgcolor=$main'LIGHT width=30% nowrap align=right>IP Number :</td>
    <td>&nbsp;$ipno</td>

<tr><td bgcolor=$main'LIGHT align=right>WWN :</td>
    <td><b>$h->{wwn}</td>
<tr><td bgcolor=$main'LIGHT align=right>Primary Host :</td>
    <td><b>$ho</td>

</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
<input type=submit name=ACTION value="Delete">
<input type=submit name=ACTION value="Back">
</form>
EOF

  print $o;
}


1;

