package GUIAdmin::Solution;
#  $Name:  $ 
#  $Id: Solution.pm,v 1.3 2001/10/17 22:37:59 ccadieux Exp $

use PDM;

use strict;
use Debug;
use Carp;
use GUIAdmin;
use base 'GUIAdmin';

sub isDevice {0}

sub ipRequired {0}

sub description {"SE Series"}

sub discover {
  my( $q, $post, $util) = @_;
  my($o, $err);
  print "\n";
  if ($q->{ACTION} =~ /Confirm/) {
       my($data, %F, $adding, $found);
       my($renv, $dev, $hosts,$notifs) = PDM::ConfigFile->read();
       my $new_dev = $#$dev ;
       my $monitor_on = $q->{monitor_on};

       print "<pre>1 - Find Devices already registered ...\n";
       my $cnt=1;
       foreach my $d (@$dev) {
          if ($d->{type} eq "switch" || $d->{type} eq "t3") {
             $F{$d->{wwn} || $d->{ipno}} = $cnt;
          }
          $cnt++;
       }
       if (!$q->{subhost}) {
           $data = &get_hostdata($q, $post, $util);
       } else {
          print "2 - Getting devices from $q->{subhost}..\n";
          my $url = Util->makeUrl($q->{subhost}, 
                         "?GET=GUIAdmin::Solution::hostdata&REM=1&SUB=$q->{SUB}");
          my $rc = Util::Http->get($url, 200);
          if (substr($rc,0,2) ne "OK") {
              print "<font color=red><b>Snmp Error: $rc";
              return;
          } else {
              my @A = split(/\n/, substr($rc,2));
              $data = \@A;
          }
       }
       my $short = Util->shortHostname($q->{subhost} || $renv->{hostname});

       foreach my $line (@$data) {
          my($type, $name, $ip, $wwn) = split(/\|/, $line);
          if ($type eq "ERR") {
            print "  Error: $name<br>\n";
            next;
          }
          if (!$wwn) {
            print "  No wwn for $type:$name:$ip, cannot add!<br>.\n";
            next;
          }
          if (!$F{$wwn}) {
             $F{$wwn} = 1;
             $adding = 1;
             $found++;
             $new_dev++;
             my($ip1,$ip2,$ip3, $ip4) = split(/\./, $ip);
             $dev->[$new_dev]{_name}    = "device" . $new_dev;
             $dev->[$new_dev]{type}     = $type;
             if ($name) {
               $dev->[$new_dev]{name}   = "$short-$name";
             } else {
               $dev->[$new_dev]{name}   = $short ."-" . sprintf("%3.3d", $ip4);
             }
             $dev->[$new_dev]{ip}       = $ip;
             $dev->[$new_dev]{ipno}     = $ip;
             $dev->[$new_dev]{datahost} = $q->{datahost};
             $dev->[$new_dev]{wwn}      = $wwn;
             $dev->[$new_dev]{host}     = $q->{subhost};
             $dev->[$new_dev]{active}   = ($monitor_on ? "Y":"N");
             print " $type:$ip added. \n";
             foreach my $h (@$hosts) {
                  if ($h->{hostname} eq $q->{subhost}) {
                     $h->{solution} = "Y";
                     last;
                  }
             }
          } else {
             print " $type:$ip already exist.\n";
          }
      }
      if ($adding) {
         if (!$q->{subhost}) {
            $renv->{solution} = "Y";
         } else {
            foreach my $h (@$hosts) {
              if ($h->{hostname} eq $q->{subhost}) {
                $h->{solution} = "Y";
              } 
            }
         }
         PDM::ConfigFile->write( $renv, $dev, $hosts,$notifs);
      } else {
         print "  *** No new devices found***\n";
      }
  }
  print "</pre>";

  my($h) = GUIAdmin->header("Discover SE Series", "85%");
  my($ip)    = Util->name2ip(System->hostname() );
  my($ix) = rindex($ip, ".");
  $ip = substr($ip, 0, $ix);
  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read();

  my $hosts = "<select name=subhost><option value=\"\">Local</option>";
  foreach my $d (@$host) {
     $hosts .= "<option>$d->{hostname}</option>";
  }
  $hosts .= "</select>";
  my $info =  Util->readHtdocs("solutions");

  my $dphost = "<select name=datahost><option value=\"*None\">None</option>";

  $dphost .= "<option>$renv->{hostname}</option>";
  foreach my $h (@$host) {
      $dphost .= "<option>$h->{hostname}</option>";
  }
  $dphost .= "</select>";


  my $o =<<EOF;
 <body bgcolor=$main'BGCOLOR><center>
 $h  $err
<table border=0 cellpadding=4 width=85% bgcolor=white><tr><td>
  $info
</table>
  <form method=get>
  <input type=hidden name=GO value=discover>
  <input type=hidden name=PKG value=GUIAdmin::Solution::discover>
  <tr><td bgcolor=white><center>
    <table border=0 cellspacing=1 cellpadding=0 bgcolor=white width=85%>
    <tr><td bgcolor=gray colspan=2><table border=0 cellpadding=1 cellspacing=0><tr><td></table></td>
    <tr><td align=right bgcolor=#CCCCFF><b>Run on Host: </td>
        <td><b>&nbsp;$hosts</td>

    <tr><td align=right bgcolor=#CCCCFF><b>Turn Monitoring On: </td>
        <td><input type=checkbox checked name=monitor_on></td>
    <tr><td align=right bgcolor=#F0F0C0><b>Data Path Host: </td>
        <td><b>$dphost &nbsp; 
    <tr><td bgcolor=gray colspan=2><table border=0 cellpadding=1 cellspacing=0><tr><td></table></td>
    </table>
    <b><center>&nbsp;<br>
    <input type=submit name=ACTION value="Confirm SE Series Discovery"><br>&nbsp;
 </form>
EOF
  print $o;
  return 0;

}


sub get_hostdata {
  my($q, $post, $util) = @_;
  my(%T, @a, $loc, $ip, $out);
  my(%F, $d, $adding, $found, $l );
  my(@NEW);
  my($xx, $sub, $remote);

  $remote   = $q->{REM};
  $sub      = $q->{SUB};

  my(@L);
  open(O, "/etc/hosts");
  while ($l = <O>) {
    chop($l);
    next if (substr($l,0,6) ne "90.0.0");
    my($ip, $name) = split(/\s+/, $l);
    next if (!Util->ping($ip, 1));
    next if (substr($ip,-2) eq ".1"); # skip sp
    my $type = Util->snmpType($ip);
    my $wwn;
    if ($type eq "t3") {
      $wwn =  Util->t3WWN($ip);
      push(@L, "$type|$name|$ip|$wwn");
    } elsif ($type eq "switch") {
      $wwn = Util->switchWWN($ip);
      push(@L, "$type|$name|$ip|$wwn");
    } else {
      push(@L, "ERR|Cannot identify $name/ $ip");
    }

  }
  if ($remote) {
     print "OK" . join("\n", @L);
  } else {
     return \@L;
  }
}
  


1;
