package GUIHealth;
#  $Name:  $ 
#  $Id: GUIHealth.pm,v 1.13 2001/09/28 16:00:25 ccadieux Exp $

 
#             CREATION
####################################################
 
use Health;
use PDM;
use Carp;
use Data::Dumper;
use Catalog;
use Report;
use strict;
use CIM::Instance;
use Message;
use CIM::Key;
use Events;
use Debug;
  
use base 'Health';
 
sub revision {'$Revision: 1.13 $'}
sub new {
  my($hm, $pdm) = @_;

  my($self) = {pdm => $pdm};
  bless ($self, 'GUIHealth');

# Specify each callback
#                            HM  Callback,  Filters
  $pdm->reportRequest($self, 'all_logic' , {INITIAL => 1});
  return $self;
}                     

#####################################################


sub all_logic {
  my($hm ) = @_;
  my($pdm) = $hm->{pdm};
  my($ev,  $x, $h);
  my($l, $s, $rc, $url, $ed);
  my($sd, $pertains, $type, $name, $key);
  CIM->version("1.1");
  $DB::single = 1;


 my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();
 
 my($rep) = {};
 Agent::addIdentification({renv => $renv}, $rep);
 $rep = ReportContent->new($rep);

 #  find out about removed hosts and removed devices frm the GUI

 my($f) = System->get_home() . "/DATA/gui_events";
 if (-f $f) {
    rename $f, "$f.wrk";
 } else {
    return;
 }
 if (-f "$f.wrk") {
    open(O, "$f.wrk");
    while ($l = <O>) {
      chop($l);    
      my(@a) = split(/\t/, $l);
      if ($a[0] eq "DH") {  # AgentDeinstall
          $ev = CIM::Instance->new('NWS_Event', [
                  [ EventType   => 'agent.AgentDeinstallEvent'  ],
                  [ EventId     => $pdm->getEventSequence  ],
                  [ Caption     => "host"],
                  [ Description => "Agent on host $a[1] was deleted from the Config File"],
                   ]);
          $sd = Events->sourceDetector({ event => $ev , host => 1, rep => $rep});
          $pertains = CIM::Instance->new('NWS_EventPertainsToSoftwareElement', [
                  [ Event         => $ev      ],
                  [ Element       => $sd->[0] ],
                  [ DiscoveryType => "D"      ],
                    ]);
          $ed = Message->new( { id        => {},
                            instances => [$ev, @$sd, $pertains ],
                            severity  => Message::SEVERITY_WARNING});
          $pdm->saveMessage($ed);

      } elsif ($a[0] eq "AH") {  # AgentInstall
          $ev = CIM::Instance->new('NWS_Event', [
                  [ EventType   => 'agent.AgentInstallEvent'  ],
                  [ EventId     => $pdm->getEventSequence  ],
                  [ Caption     => "host"],
                  [ Description => "Agent on host $a[1]/$a[2] was Added to the Config File"],
                   ]);
          $sd = Events->sourceDetector({ event => $ev , host => 1, rep => $rep});
          $pertains = CIM::Instance->new('NWS_EventPertainsToSoftwareElement', [
                  [ Event         => $ev      ],
                  [ Element       => $sd->[0] ],
                  [ DiscoveryType => "A"      ],
                    ]);
          $ed = Message->new( { id        => {},
                            instances => [$ev, @$sd, $pertains ],
                            severity  => Message::SEVERITY_NORMAL });
          $pdm->saveMessage($ed);

      } elsif (substr($a[0],0,1) eq "Q") {
          my($name) = $a[2];
          $type = $a[1]; 
          my $wwn    = Catalog->deviceRead("",Catalog::Name, $name, Catalog::Key);

          if ($wwn) {
               my($code) = (substr($a[0],1,1) eq "S")? "Start":"End";
               $ev = CIM::Instance->new('NWS_Event', [
                    [ EventType   => ucfirst($type) . ".Quiesce${code}Event"  ],
                    [ EventId     => $pdm->getEventSequence  ],
                    [ Description => "Quiesce $code on device " . uc($type) . " $wwn / $name"],
                     ]);
               $sd = Events->sourceDetector({ event => $ev });
  
               $key = CIM::Key->new( ['NWS_System',
                     'Name'       => $wwn,
                      CreationClassName => 'NWS_System']);
  
               $pertains = CIM::Instance->new('NWS_EventPertainsToSystem', [
                    [ Event       => $ev  ],
                    [ Element     => $key ],
                      ]);
  
               $ed = Message->new( { id        => {},
                              instances => [$ev, @$sd, $pertains ],
                              severity  => Message::SEVERITY_NORMAL });

               $pdm->saveMessage($ed);
           }

      } elsif ($a[0] eq "DD") {
          my($name) = $a[2];
          $type = $a[1]; 
          my $wwn    = Catalog->deviceRead("",Catalog::Name, $name, Catalog::Key);
          if ($wwn) {
               $ev = CIM::Instance->new('NWS_Event', [
                    [ EventType   => ucfirst($type) . ".RemovalEvent"  ],
                    [ EventId     => $pdm->getEventSequence  ],
                    [ Description => "Monitoring of " . uc($type) . " device ($wwn-$name) ended"],
                     ]);
               $sd = Events->sourceDetector({ event => $ev , host => 1, rep => $rep});
  
               $key = CIM::Key->new( ['NWS_System',
                     'Name'       => $wwn,
                      CreationClassName => 'NWS_System']);
  
               my($monitors) = CIM::Instance->new('NWS_AgentMonitors', [
                  [ Agent       => $sd->[0]  ],
                  [ Element     => $key ],
                    ]);
 
               $pertains = CIM::Instance->new('NWS_EventPertainsToMonitor', [
                    [ Event       => $ev  ],
                    [ Association => $monitors ],
                    [ DiscoveryType => "D"],
                      ]) ;
  
               $ed = Message->new( { id        => {},
                              instances => [$ev, @$sd, $monitors, $pertains ],
                              severity  => Message::SEVERITY_WARNING});
  
               
#               $pdm->deleteLastReport(Report->makeFileKey('t300',$wwn) );  not needed
               $pdm->saveMessage($ed);
          }
      }
    }
    close(O);
    unlink "$f.wrk";
 }

}

1;
