package STools4Health;
#  $Name:  $ 
#  $Id: STools4Health.pm,v 1.5 2001/03/23 00:41:32 ccadieux Exp $


use base 'Health';
use NWS::T3;
use Ilist;
use Message;
use Report;
use Events;
use strict;
use Debug;

sub revision {'$Revision: 1.5 $'}

sub new {
  my($hm, $pdm) = @_;

  my($self) = {pdm => $pdm};
  bless ($self, 'STools4Health');

# Specify each callback
#                            HM  Callback,  Filters
  $pdm->reportRequest($self, 'all_logic' , {category => Report::CAT_ST4});
  return $self;
}

#####################################################

sub all_logic {
  my($hm, $report) = @_;
  my($pdm) = $hm->{pdm};
  my($ev, $ed, $pertains, $x ,$y, $contain, $sd);
  my($orep, $key);
  my($rep)     = $report->content;
  my($ip)      = $report->accessName;
  my($log)     = $report->log();
  CIM->version("1.1");
  $DB::single = 1;

  foreach my $l (@$log) {
    if ($l =~ /diagnosis expert /) {
       my($et) = "";
       if ($l =~ /STARTED:/) {
          $et = "DiagnosticTestStarted";
       } elsif ($l =~ /COMPLETED:/) {
          $et = "DiagnosticTestComplete";
       }
       if ($et) {
         $ev = CIM::Instance->new("NWS_$et", [
                  [ EventType   => "stools4.$et"  ],
                  [ EventId     => $pdm->getEventSequence  ],
                  [ Data        => $l],
                  [ Description => $et],
                         ]);
         $sd = Events->softSourceDetector({ event => $ev , soft => "STools4", host => 1, rep => $rep});

         $pertains = CIM::Instance->new('NWS_EventPertainsToSoftwareElement', [
                  [ Event       => $ev  ],
                  [ Element     => $sd->[1] ],
                    ]);

         $ed = Message->new( { id        => $report->id,
                            instances => [$ev, @$sd, $pertains ],
                            severity  => Message::SEVERITY_NORMAL });

         $pdm->saveMessage($ed);

         
       }

    }
  }
      
}


1;
