package SlaveHealth;
#  $Name:  $ 
#  $Id: SlaveHealth.pm,v 1.12 2001/10/17 22:38:00 ccadieux Exp $

 
#             CREATION
####################################################
 
use Health;
use PDM;
use Carp;
use Data::Dumper;
use Report;
use strict;
use CIM::Instance;
use Message;
use CIM::Instance;
use Events;
use Debug;
  
use base 'Health';
sub revision {'$Revision: 1.12 $'}
 
sub new {
  my($hm, $pdm) = @_;

  my($self) = {pdm => $pdm};
  bless ($self, 'SlaveHealth');

# Specify each callback
#                            HM  Callback,  Filters
  $pdm->reportRequest($self, 'all_logic' , {INITIAL => 1});
  return $self;
}                     

#####################################################


sub all_logic {
  my($hm ) = @_;
  my($pdm) = $hm->{pdm};
  my($ev, $sd, $x, $h, $pertains);
  my($l, $s, $rc, $url, $ed);
#
# POLL ALL SLAVES, GENERATE CommLost Events
# GET EVENTS from slaves and store in PDM.
#
  CIM->version("1.1");
  $DB::single = 1;
  
 my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

 foreach $h (@$hosts) {
   next if ($h->{active} eq "N");
   my($ip) = $h->{ip};
   if ($ip) {
      my($ping)   = Net::Ping->new();
      my($alive);   
      eval {
        $alive = $ping->ping(Util->removePort($ip),10)? "Y":"N";
      };
      $alive = "N" if ($@);
      my($tran) = $hm->getTransition( {   key => $ip,
                                         code => 'alive',
                                        value => $alive,
                             transition_value => "N",
                                       repeat => '5h',
                                 });
      if ($tran =~ /IN/  || $tran =~ /OUT/) {
          my $ipno = $h->{ipno} || $h->{ip};
          my($et, $desc, $sev, $nws);
          if ($tran =~ /IN/) {
            $et   = 'agent.CommunicationLostEvent';
            $nws  = 'NWS_CommunicationLostEvent';
            $desc = "Cannot access $h->{hostname} at $ipno (using udp ping)";
            $sev  =  Message::SEVERITY_DOWN;
          } else {
            $et   = 'agent.CommunicationEstablishedEvent';
            $nws  = 'NWS_CommunicationEstablishedEvent';
            $desc = "Access to $h->{hostname} at $ipno regained";
            $sev  =  Message::SEVERITY_NORMAL;
          }
          
         # CANNOT connect to slave event.
          $ev = CIM::Instance->new($nws, [
                  [ EventType       => $et  ],
                  [ EventId         => $pdm->getEventSequence  ],
                  [ Description     => $desc ]
                   ]);
          $sd = Events->sourceDetector({ event => $ev });
          $pertains = CIM::Instance->new('NWS_EventPertainsToSoftwareElement', [
                  [ Event      => $ev  ],
                  [ Element    => $sd->[0] ],
                    ]);
          $ed = Message->new( { id   => {},
                            instances => [$ev, @$sd, $pertains ], severity  => $sev });
          $pdm->saveMessage($ed);
         
         return;
      }
#      $url = Util->makeUrl($ip, "?GET=slave_data");
      $url = Util->makeUrl($ip, "?GET=FILED&file=SLAVE_DATA");
      $rc = Util::Http->get($url, 20);
      if (length($rc) > 2) {
         my(@l) = split(/\n/, $rc); 
         return if ($#l < 0);
         $s = "";
         Debug->print2("Receiving $#l lines from $h->{hostname}");
         for ($x = 0; $x <= $#l; $x++) {
             if (substr($l[$x],0,2) eq "-E") {
                eval {
                    $ed = Message->fromC($s);
                    $pdm->saveMessage($ed, 1) if ($ed);
                };
                Debug->err(HTTP_ERROR => "failed to transfer from slave $@") if ($@);
                $s = "";
             } else {
               $s .= $l[$x] . "\n";
             }
         }
      } else {
         Debug->print2("No data from slave $h->{hostname}");
      }
   }
 }

}


1;
