package Ilist;
#  $Name:  $ 
#  $Id: Ilist.pm,v 1.4 2001/05/01 23:18:12 ccadieux Exp $

use CIM::Instance;
use CIM::Tree;
use strict;
use CIM::Property;
use CIM::Key;
use CIM::GenInstance;
use Debug;
use CIM;
use NWS::Schema;

#
#  $il = Ilist->new([$ins1, $ins2, $ins3]);

sub new {
   my($class, $i) = @_;
   if (ref($i) eq "ARRAY") {
      bless($i, "Ilist");
      return $i;
   } else {
      croak("Ilist need a ARRAYREF");
   }
}

sub count {
  my($il) = @_;
  return $#$il +1;
}

sub instances {
  my($il) = @_;
  return $il;
}

sub toC {
   my($il, $list) = @_;
   my($i, $o, $o2, $c);
   my(%MAP);
   my($cnt) = -1;
   foreach $i (@$il) {
       next if (!$i);
       ($c, $o) =  toCIns($i, \$cnt, \%MAP);
       $o2 .= $o;
   }
   return $o2;
}

sub clean {
  my($x) = @_;
  my($new);
  if (index($$x, "\n") >= 0) {
     $$x =~ s/\n([\+\-])/\n\\$1/g;
  }
}

sub toCIns {
   my($i, $cntp, $MAP, $hide) = @_;
   my($o,$o2, $ot, $p,  $k, $keys, $x, $v, @save, $rc, $quals, $x1, $cnt);
   my($hideS) = ($hide)? "Hide":"";

    my($it) =  ($i->instanceType eq "A"? "A":"I") ;

    $$cntp = $$cntp + 1;
    $MAP->{$i->key->shortString} = $$cntp;
    my($save_cnt) = $$cntp;
    $o = "+$it\t#$$cntp\t". $i->instanceType . "\t". $i->className .   "\n";
    foreach $p (@{$i->properties}) {
        my($v)  = $p->value;
        my($type) = $p->type;
#        $type .= "array" if  (ref($v) eq "ARRAY");
        $type = "S" if ($type eq "string");
        my($code) = ($p->type eq "reference") ? "R":"P";
        $o .= "+$code\t" . $type . "\t" . $p->name . "\t";
        if ($p->type eq "reference") {
           my($map) =  $MAP->{$p->value->shortString};
           if (defined($map)) {
             $o .= "#$map\n";
           } else {
             my($c, $o3) = &toCIns($p->value->toInstance, $cntp, $MAP, 1);
             $o .= "#$c\n"; $ot .= $o3;
           }
           if (0) {
             @save = (); $rc = 0;
             $o .= &do(0, $p->value, \@save, \$rc);
             foreach $x (sort @save) {
                 $o .= $x;
             }
           }
        } else {
           $o .=  ($p->isKey? "1":"0")  . "\t";
           $quals = $p->qualifiers;
           if ($#$quals >= 0) {
              for ($x=0; $x <= $#$quals; $x+=3) {
#                         type                  name            value
                  $o .= $quals->[$x+2]."\t".$quals->[$x]."\t".$quals->[$x+1] . "\t";
              }
              chop($o);
           }
           $o .= "\n";
           my($vals) = "";
           if ($type =~ /array/) {
              foreach $x1 (@$v) {
                &clean(\$x1);
                $vals .= "+V\t$x1\n-V\n";
              }
           } else {
              &clean(\$v);
              $vals .= "+V\t$v\n-V\n";
           }
           $o .= $vals;
        }
        $o .= "-$code\n";
    }
    $o .= "-$it\t$hideS\n";
    return ($save_cnt, $ot . $o);
}



sub fromC {
  my($class, $s) = @_;
  my(@l) = split(/\n/, $s);
  my($classname, @plist, $val, @val, @ilist, $x, $itype, $y, $icnt, @ikey);
  my($array, $ptype, $pname, @pquals, $pkey);
  my($inV) = 0;
  my($currentval) = "";
  for ($x=0;$x <= $#l; $x++) {
     my(@f) = split(/\t/, $l[$x]);
     if ($f[0] eq "+A" || $f[0] eq "+I") {
        $classname = $f[3]; @plist = ();
        $itype = $f[2]; $icnt = substr($f[1],1);

     } elsif ($f[0] eq "+V") {
        $inV = 1; 
        $currentval = substr($l[$x],3);

     } elsif ($f[0] eq "-V") {
        if ($array) {
            push(@val, $currentval);
        }
        $inV = 0;

     } elsif ($f[0] eq "-P") {
        if ($array) {
            $val = [@val];
        } else {
            $val = $currentval;
        }
        push(@plist, CIM::Property->new([$pname, $val, $ptype, $pkey, [@pquals]] ));
        
     } elsif ($f[0] eq "+P") {
        Debug->err("-V missing at line $x") if ($inV);
        $ptype = $f[1];
        $ptype = "string" if ($ptype eq "S");
        $pname = $f[2];
        $pkey = ($f[3])? 1:0;
        @pquals = ();
        @val = (); 
        $array = ($ptype =~ /array/)? 1:0;
        for ($y=4; $y <= $#f; $y+= 3) {
           last if (!$f[$y]);
           push(@pquals, $f[$y+1], $f[$y+2], $f[$y]);
        }
     } elsif ($f[0] eq "+R") {  # references
        my($name) = $f[2];
        if (substr($f[3],0,1) ne "#") {
           Debug->print2("Invalid reference on line $x: $l[$x]\n");
        } else {
           my($no) = substr($f[3],1);
           if (ref($ilist[$no]) eq "CIM::Instance") {
             $val = $ilist[$no]->key;
             push(@plist, CIM::Property->new([$name, $val, 'reference', 1]));
           } elsif ($ikey[$no]) {
             push(@plist, CIM::Property->new([$name, $ikey[$no], 'reference', 1]));
           } else {
             Debug->print2("Invalid Instance # $no");
           }
        }
     } elsif ($f[0] eq "-R") {
#       nothing
     } elsif ($f[0] eq "-I" || $f[0] eq "-A") {
       if ($f[1] ne "Hide") {
#         push(@ilist, CIM::GenInstance->new($classname, $itype, [@plist]));
          $ilist[$icnt] = CIM::GenInstance->new($classname, $itype, [@plist]);
       } else {
          my($i1) =  CIM::GenInstance->new($classname, $itype, [@plist] );
          $ikey[$icnt] = $i1->key;
       }
     } elsif ($inV) {
       $currentval .= "\n" . $l[$x];
     }
   }
   
   my($il) = \@ilist;
   bless($il, "Ilist");
   return $il;
}



# print $ilist->toXML({indent => 1});

sub toXML {
  my($il,  $args) = @_;
  my($i, $content);
  my($indent) = $args->{indent};
  foreach $i (@$il) {
     if ($indent) {
       $content .= Util->ppXML($i->toXML);
     } else {
       $content .= $i->toXML . "\n";
     }
  }
  return $content;
}

#   $il2 = $il->search({ className => "NWS_DiskDrive" , isa => "NWS_Event",
#                        type => [A,E,P,C,O,I] ,
#   I : means !A
#                      });
sub search {
  my($il, $arg) = @_;
  my(@f, $RC);
  my($E) = NWS::Schema->database(CIM->version() );
  foreach my $i (@$il) {
    next if ($arg->{className} && $i->className ne $arg->{className});
    if ($arg->{isa}) {
       my($e) = $E->{$i->className()};
       my($isa) = $e->[0]{isa};
       Debug->print2("ISA for " . $i->className() . " missing!");
       next if (index($isa, ":$arg->{isa}:") < 0 );

    }
    if ($arg->{type}) {
       next if ($arg->{type} eq "I" && $i->instanceType eq "A");
       next if ($arg->{type} ne $i->instanceType);
    }
    push(@f, $i);
  }
  return Ilist->new(\@f);
}


sub toString {
  my($il,$indent, $html) = @_;
  my($i, $content);
   my($cnt) = 0;
   foreach $i (@$il) {
      next if (!$i);
      my($s);
      $cnt++;
      eval {
        $s = $i->toString($indent,$html); 
        $s =~ s/\n/\n  /g;
      };
      if ($@) {
         Debug->err(ERROR => "Instace $cnt of Ilist: $@");
      }
      $content .= "==>Instance $cnt \n  $s\n";
   }
   $content .= "Done. \n";
   return "==>InstanceList \n" . $content;

}

# Verify that all instances are referred to.
# with complete=1, all references must have an instance to point to.
# returns 'undef' if everything requested is ok.
# print $il->verify(1);

sub verify {
  my($il, $complete) = @_;
  my($x, $i, $p, $r1);
  my(%X);
  my($out);
  for ($x = 0; $x <= $#$il; $x++) {
      $i = $il->[$x];
      $X{$i->key->shortString} =  $i->type;
  }
  for ($x = 0; $x <= $#$il; $x++) {
      $i = $il->[$x];
      if ($i->instanceType eq "A") {
         foreach $p (@{$i->properties()}) {
             if ($p->isReference) {
                $r1 = $p->value->shortString;
                if (!defined($X{$r1})) {
                   if ($complete) {
                     $out .= "I$x:Assoc '" . $i->className() .
                             "': No instance for ref-" . $p->name . " \"$r1\"\n";
                   }
                } else {
                   $X{$r1} .= "-X";
                }
             }
         }
      }
  }
  foreach $x (keys %X) {
     $i = $X{$x};
     if (substr($i,-2) ne "-X" && substr($i,0,1) ne "A") {
        $out .= "Element \"" . $x . "\" is not referred to\n";
     }
  }
  return undef if (!$out);
  return $out;

}

#
#  Transform an Message so that it's easy to travel between instances.
#  $tree = $il->tree;
#  $tree = { $inst1_key => [$inst1, [$to_inst2, $using_ass2], [$to_inst3, $using_ass3] ...],
#            $inst2_key => [$inst2, [$to_inst5, $using_ass5], [$to_inst6, $using_ass6] ...],
#          };
#   CIM::Tree $tree = $il->tree;

sub tree {
  my($il) = @_;
  my(%X, $x, $i, $r2, $r1, $found, $p, $p2);
  my($ins, $tX);

  for ($x = 0; $x <= $#$il; $x++) {
      $i = $il->[$x];
      $X{$i->key->shortString} = [$i];
  }
  
  for ($x = 0; $x <= $#$il; $x++) {
      $i = $il->[$x];
      if ($i->instanceType eq "A") {
         $found = 0;
         foreach $p (@{$i->properties()}) {
            if ($p->isReference) {
               $r1 = $p->value->shortString;
               $tX = $X{$i->key->shortString};
               if ($X{$r1}) {
                  push(@$tX, [$X{$r1}->[0], $i]);  # instance referenced exist.
               } else {
                  push(@$tX, [$p, $i]);            # just put the reference property,
               }
               if ($X{$r1}) {
                 foreach $p2 (@{$i->properties()}) {
                   if ($p2->isReference) {
                     $r2 = $p2->value->shortString;
                     next if (!$X{$r2});
                     if ($r1 ne $r2) {
                       $tX = $X{$r1};
                       push(@$tX, [$X{$r2}->[0], $i]);
                     }
                   }
                 }
               }
            }
         }
       }
   }
   my($tree) = CIM::Tree->new(\%X);
   return $tree;
}




  


1;
