package SCH_Storage;
#  $Name:  $ 
#  $Id: SCH_Storage.pm,v 1.4 2001/09/28 16:00:28 ccadieux Exp $

sub revision {'$Revision: 1.4 $'}

%Schema = (

   CIM_ManagedElement => [{ type => 'C', parent => 0}, [
            [Caption               => S,0],
            [Description           => S,0],
                ]],

   CIM_ManagedSystemElement => [{ type => 'C', parent => CIM_ManagedElement}, [
            [InstallDate           => D,0, NOW],
            [Name                  => S,0],
            [Status                => S,0],
                ]],

   CIM_PhysicalElement => [{ type => 'C', parent => CIM_ManagedSystemElement}, [
            [CreationClassName     => S,K, CLASSNAME],
            [Tag                   => S,K],
            [SerialNumber          => S,0],
            [Manufacturer          => S,0],
            [Model                 => S,0],
            [Version               => S,0],
            [Name                  => S,0],
            [Status                => S,0],
            [OtherIdentifyingInfo  => S,0],
            [PartNumber            => S,0],
                ]],

   CIM_LogicalElement => [{ type => 'C', parent => CIM_ManagedSystemElement}, [
                ]],

   CIM_UnitaryComputerSystem        => [{ type => 'C',parent =>  CIM_LogicalElement}, [
            [CreationClassName     => S,K, CLASSNAME],
            [Name                  => S,K],
            [OtherIdentifyingInfo  => S,0],
                ]],

   CIM_LogicalDevice => [{type => 'C', parent => CIM_LogicalElement}, [
            [SystemCreationClassName => S,0, CLASSNAME],
            [CreationClassName       => S,K, CLASSNAME],
            [SystemName              => S,K],
            [DeviceID                => S,K],
            [StatusInfo              => S,0],
            [OtherIdentifyingInfo    => S,0],
            [TotalPowerOnHours       => I64,0],
            [LastErrorCode           => I32,0],
            [Availability            => I,0],
                ]],

   CIM_Controller => [{type => 'C', parent => CIM_LogicalDevice}, [
            [TimeOfLastReset         => D,0],
                ]],

   CIM_DiskDrive => [{type => 'C', parent => CIM_LogicalDevice}, [
                ]],

   CIM_PhysicalPackage   => [{ type => 'C', parent => 'CIM_PhysicalElement'}, [
            [Removable              => B,0],
            [Replaceable            => B,0],
            [HotSwappable           => B,0],
                ]],

   CIM_PhysicalFrame => [{ type => 'C', parent => 'CIM_PhysicalPackage'}, [
                ]],

   CIM_Card  => [{ type => 'C', parent => 'CIM_PhysicalPackage'}, [
            [OperatingVoltages      => I,0],
                ]],

   CIM_StorageExtent  => [{ type => 'C', parent => CIM_LogicalDevice}, [
            [DataOrganization       => I,0],
            [Access                 => I,0],
            [IsBasedOnUnderlyingRedundancy => B,0,'false'],
                ]],

   CIM_Location => [{type => 'C', parent => 0}, [
            [Name                  => S,K],
            [PhysicalPosition      => S,K],
            [Address               => S,0],
                ]],

   NWS_Location => [{type => 'C', parent => CIM_Location}, [
            [ContractNo            => S,0],
            [CustomerNo            => S,0],
            [ResidentHostId        => S,0],
                ]],

   CIM_SoftwareFeature => [{type => 'C', parent => CIM_ManagedSystemElement}, [
                ]],

   CIM_SoftwareElement => [{type => 'C', parent => CIM_LogicalElement}, [
            [Name                 => S,K, "RASAgent" ],
            [Version              => S,K, "V2" ],
            [SoftwareElementState => S,0, "Executable" ],
            [SoftwareElementId    => S,0, "" ],
            [TargetOperatingSystem=> S,0, OS ],
            [Manufacturer         => S,0, "Sun" ],
            [BuildNumber          => S,0, "1" ],
            [SerialNumber         => S,0, "1" ],
                ]],
        
   NWS_SoftwareElement => [{type => 'C', parent => CIM_SoftwareElement}, [
            [RevisionLevel        => S,0, 2],
            [ResidentHostID       => S,0, HOSTID],
            ]],

   CIM_Realizes => [{type => 'A', parent => 0}, [
            [Antecedent      => R => 'CIM_PhysicalElement'],
            [Dependent       => R => 'CIM_LogicalElement'],
            ]],

   CIM_ComputerSystemPackage => [{type => 'A', parent => 0}, [
            [Antecedent     => R => 'CIM_UnitaryComputerSystem'],
            [Dependent      => R => 'CIM_PhysicalPackage'],
            ]],

   CIM_Container => [{ type => 'A', parent => 0}, [
            [GroupComponent => R => 'CIM_PhysicalPackage'],  # frame
            [PartComponent  => R => 'CIM_PhysicalElement'],  # package
            [LocationWithinContainer => S,0],
            ]],

   CIM_MediaPresent => [{type => 'A', parent => 0}, [
            [Antecedent     => R => 'CIM_LogicalElement'],
            [Dependent      => R => 'CIM_StorageExtent'],
            [FixedMedia     => B,0, 1],
            ]],

   CIM_PhysicalElementLocation  => [{type => 'A', parent => 0}, [
            [Element          => R => 'CIM_PhysicalElement'],
            [PhysicalLocation => R => 'CIM_Location'],
            ]],

   NWS_PhysicalFrameLocation  => [{type => 'A', parent => 0}, [
            [Element          => R => 'CIM_PhysicalFrame'],
            [PhysicalLocation => R => 'CIM_Location'],
            ]],

   CIM_DeviceSoftware    => [{type => 'A', parent => 0}, [
            [Antecedent     => R => 'CIM_SoftwareElement'],
            [Dependent      => R => 'CIM_LogicalDevice'],
             ]],

   CIM_Component => [{type => 'A', parent => 0}, [
            [GroupComponent => R => 'CIM_ManagedSystemElement'],
             [PartComponent => R => 'CIM_ManagedSystemElement'],
                ]],
                         
                         

   NWS_System => [{ type => 'P', parent => 'CIM_UnitaryComputerSystem'},[
            [HostId              => S,0],
            [SysRevision         => S,0],
#T300
            [IP                  => S,0],
            [FruCount            => I,0],
            [FruCtlrCount        => I,0],
            [FruDiskDriveCount   => I,0],
            [FruLoopCount        => I,0],
            [FruPowerCount       => I,0],
            [VolCount            => I,0],
            [SysBootDelay        => I,0],
            [SysBootMode         => S,0],
            [SysCacheMirror      => S,0],
            [SysCacheMode        => S,0],
            [Thresholds          => S,0],        
#A5000
            [Fan0Revision        => S,0],
            [Fan0Status          => S,0],
            [Fan1Revision        => S,0],
            [Fan1Status          => S,0],
            [InterconnectRevision => S,0],
            [InterconnectStatus   => S,0],
             ]],

   NWS_Controller  => [{ type => 'C', parent => 'CIM_Controller'}, [
           [Role                 => S,0],
           [FruErrors            => I,0],
           [PortErrors           => I,0],
           [PortStatus           => S,0],
           [PortSunHost          => S,0],
           [PortType             => S,0],
            ]],

   NWS_DiskDrive => [{ type => 'C', parent => 'CIM_DiskDrive'}, [
            [Port1State           => S,0],
            [Port2State           => S,0],
#T300
            [FruDiskRole          => S,0, "dataDisk"],
            [FruDiskIsExpendable  => B,0],
            [FruDiskIsRebuildable => B,0],
            [FruDiskTemperature   => I,0],
            [FruDiskCapacity      => S,0],
            [FruErrors            => I,0],
#A5000
            [Wwn                => S,0],
             ]],

   NWS_PowerUnit => [{ type => 'C', parent => 'CIM_LogicalDevice'}, [
            [FruBatLife          => I32,0],
            [FruErrors           => I,0], 
            [Fan1State           => S,0], 
            [Fan2State           => S,0], 
#A5000
            [Revision           => S,0],
                ]],

   NWS_LoopCard => [{ type => 'C', parent => CIM_LogicalDevice}, [
            [FruLoopCable1State   => S,0],
            [FruLoopCable2State   => S,0],
            [FruLoopMode          => S,0],
            [FruLoopTemp          => S,0],
            [FruErrors            => I,0], 
#A5000
            [Revision           => S,0],
             ]],

   NWS_StorageVolume => [{type => 'C', parent => CIM_StorageExtent}, [
            [VolWWN               => S,0],
            [VolName              => S,0],
            [VolErrors            => I,0],
            [VolFirmwareErrors    => I,0],
            [VolIndex             => I,0],
            [VolId                => S,0],
            [VolCacheMirror       => S,0],
            [VolCacheMode         => S,0],
            [VolRaidLevel         => S,0],
            [VolStatus            => S,0],
                ]],
);

sub getSchema { return \%Schema }

1;
