package NWS::Schema1;
#  $Name:  $ 
#  $Id: Schema1.pm,v 1.3 2001/02/16 19:32:49 ccadieux Exp $

sub revision {'$Revision: 1.3 $'}


%Schema = (

   NWS_ActionStartEvent => [{ type => 'E', parent => 'NWS_Event'}, [
             [ActionPerformed  => I],
             [Remote           => B],
             [InitiatedBy      => S],
                ]],

   NWS_ActionEndEvent   => [{ type => 'E', parent => 'NWS_Event'}, [
             [ActionPerformed  => E,0],
             [CompletionStatus => E,0],
             [StartEventId     => S],
                ]],

   NWS_ConfigurationStartEvent => [{ type => 'E', parent => 'NWS_ActionStartEvent'}, [
             [ConfigurationType      => I],
             [ConfigurationsSelected => S],
                ]],

   NWS_DiagnosticActivationEvent  => [{ type => 'E', parent => 'NWS_ActionStartEvent'}, [
             [DiagnosticId       => S],
             [Version            => S],
             [IsolationTechnique => S],
                ]],

   NWS_DiagnosticTestSuiteStarted => [{type => 'E', parent => 'NWS_ActionStartEvent'}, [
             [TestSuite          => S],
             [TestSuiteType      => S],
             [Online             => B],
             [Iterations         => I],
                ]],

   NWS_DiagnosticTestStarted => [{type => 'E', parent => 'NWS_ActionStartEvent'}, [
             [Test               => S],
             [TestType           => S],
             [Online             => B],
             [Iterations         => I],
                ]],

   NWS_DiagnosticDeactivationEvent => [{type => 'E', parent => 'NWS_ActionEndEvent'}, [
             [DiagnosticId       => S],
             [Version            => S],
             [Result             => S],
                ]],

   NWS_DiagnosticTestComplete      => [{type => 'E', parent => 'NWS_ActionEndEvent'}, [
             [Test               => S],
             [TestType           => S],
             [Status             => S],
             [FailureCode        => S],
             [ExpectedResult     => S],
             [ActualResult       => S],
             [ConfidenceLevel    => S],
                ]],

   NWS_DiagnosticTestSuiteComplete => [{ type => 'E', parent => 'NWS_ActionEndEvent'}, {
             TestSuite          => [S],
             TestSuiteType      => [S],
             CompletionStatus   => [I],
             FailureCode        => [S],
             ExpectedResult     => [S],
             ActualResult       => [S],
             SessionLog         => [S],
             ConfidenceLevel    => [S],
               }],

   NWS_HeartbeatEvent          => [{type => 'E', parent => 'NWS_Event'}, [
             [Interval       => I],
                ]],

   NWS_ThresholdEvent          => [{type => 'E', parent => 'NWS_Event'}, [
             [Name             => S],
             [Value            => I64],
             [LimitMax         => I64],
             [LimitMin         => I64],
             [Rate             => I64],
                ]],

   NWS_CommunicationLostEvent    => [{type => 'E', parent => 'NWS_Event'}, [
             [Method           => I],
             [Timeout          => I64, 0,0,0, [unit => "secs,hours,days,millisecs","millisecs"]],
                ]],

   NWS_CommunicationEstablishedEvent  => [{type => 'E', parent => 'NWS_Event'}, [
             [Method           => I],
               ]],

   NWS_StateChangeEvent        => [{type => 'E', parent => 'NWS_Event'}, [
             [CurrentStatus    => I],
             [PriorStatus      => I],
                ]],

   NWS_PolicyChangeEvent       => [{type => 'E', parent => 'NWS_Event'}, [
             [OldPolicy        => I],
             [NewPolicy        => I],
               ]],
 
   CIM_AlertIndication  => [{type => 'E',parent =>  0}, [
             [EventTime        => D],
             [FilterName       => S],
             [Description      => S],
             [Severity         => I],
             [ProbableCause    => S],
             [RecommendedAction => S],
                ]],

   NWS_AlertIndication  => [{type => 'E', parent => 'CIM_AlertIndication'}, [
             [Alert            => I],
                ]],

   NWS_Agent                     => [{type => 'E', parent => 0}, [
             [Name             =>  S,K],
             [Version          =>  S,K],
             [IdentificationCode=> S,K],
                ]],

   NWS_AlertPertainsToEvent  => [{type => 'A',parent =>  0}, [
             [Alert      => R => 'NWS_AlertIndication'],
             [Event      => R => 'NWS_Event'],
                ]],

   NWS_EventDetector       => [{type => 'A', parent =>  0}, [
             [Event      => R => 'NWS_Event'],
             [Agent      => R => 'NWS_Agent']
                ]],

   NWS_EventPertainsToElement => [{type => 'A',parent =>  0}, [
             [Event       => R => 'NWS_Event'],
             [Element     => R => 'Element']
                ]],

   NWS_EventPertainsToDependency => [{ type => 'A',parent =>  0}, [
             [Event       => R => 'NWS_Event'],
             [Association => R => 'Association']
                ]],

   NWS_EventPertainsToComponent  => [{type => 'A',parent =>  0}, [
             [Event       => R => 'NWS_Event'],
             [Association => R => 'Association']
                ]],

   NWS_EventPertainsToElement    => [{type => 'A', parent => 0}, [
             [Event        => R => 'NWS_Event'],
             [Association  => R => 'Element']
               ]],

  ComponentAssoc       => [{type => 'A',parent =>  0}, [
             [whole     => R => 'Element'],
             [part      => R => 'Element'],
             [slot     =>  S],
               ]],

  ComponentToEventAssoc => [{type => 'A',parent =>  0}, [
             [whole     => R => 'NWS_Event'],
             [part      => R => 'Element'],
             [slot     =>  S],
               ]],

   Element => [{type => 'C', parent => 0}, [
             [field1   => S],
             [field2   => S],
               ]],

   Disk => [{type => 'C', parent => 'Element'}, [
             [field1   => S],
             [field2   => S],
               ]],

   Purple => [{type => 'P', parent => 'Element'}, [
             [field1   => S],
             [field2   => S],
               ]],
);

          
1;
