package PDM::SAF;
use System;
use Debug;
sub revision {'$Revision: 1.1 $'}
#
# $saf = PDM::SAF->new({ file => "http"});
# $saf->write("data");
# while ($saf->read("data")) {
#     if (<cannot send data>) {
#         $saf->failed($data);
#     }
# }
# $saf->done;
#
$DEL = "123456789123456789123456789123456789123456789";

sub new {
  my($class, $saf) = @_;
  if (!$saf->{file}) {
     Debug->print0("SAF::new requires a file !");
     return undef;
  } 
  $saf->{file} = System->get_home() . "/DATA/SAF_$saf->{file}";
  unlink "$saf->{file}.2";
  $saf->{seek} = 0;
  $saf->{size} = 1000000 if (!$saf->{size});
  bless($saf, "PDM::SAF");
  return $saf;
}


sub write {
  my($saf, $data, $ext) = @_;

  my($f) = $saf->{file} . $ext;
  my($size) = (stat($f))[7];
  if ($size > $saf->{size}) {
     Debug->print0("SAF_$f too big, removing old events");
     my($half) = int($size/2);
     if (open(R1, $f) && open(W1, ">$f.1")) {
       my($curr) = 0;
       while ($l = <R1>) {
          $curr += length($l);
          last if ($l =~ /^$DEL/ && $curr > $half);
       }
       while ($l = <R1>) {
          print W1 $l;
       }
       close(W1); close(R1);
       rename "$saf->{file}.1", $saf->{file};
     } else {
       Debug->err(SAF => "Failed to truncate $f");
       return undef;
     }
  }
  if (open(O, ">>$f")) {
     print O $data;
     print O "\n" if (substr($data,-1) ne "\n");
     print O "123456789" x 10 . "\n";
     close(O);
     return 1;
  } else {
     Debug->err(SAF => "Cannot write to $f");
     return undef;
  }
}

sub read {
  my($saf) = @_;
  $file = $saf->{file};
  open(SAFO, $file);
  my($size) =  (stat($file))[7];
  my($seek) = $saf->{seek};
  if ($seek) {
     if ($seek < $size) {
         seek(SAFO, $seek, 0);
     } else {
         return undef;
     }
  }
  my($data) = "";
  while ($line = <SAFO>) {
      if ($line =~ /^$DEL/) {
         last;
      }
      $data .= $line;
  }
  $saf->{seek} = tell(SAFO);
  close(SAFO);
  return $data;
}

sub failed {
  my($saf, $data) = @_;

  $saf->write($data, ".2");
}

sub done {
  my($saf) = @_;

  if (-f "$saf->{file}.2") {
     rename "$saf->{file}.2", $saf->{file};
  } else {
     unlink $saf->{file};
  }
}
  
1;
