package EmailProvider;
#  $Name:  $ 
#  $Id: EmailProvider.pm,v 1.11 2001/07/27 23:36:52 ccadieux Exp $

use PDM;
use Carp;
use Message;
use Util;
use strict;

use base 'Provider';
sub revision {'$Revision: 1.11 $'}

sub new {
  my($self, $pdm)  = @_;

  my($p) = { pdm => $pdm };

  bless($p,'EmailProvider');
  return $p;
}

sub RUN {
  my($pro) = @_;
  my($notifs, $notif, $p, $ed, $id, $cat, $sev, $admin, $eventType);
  my(%EMAILS) = (); my(%COUNT) = ();
  my($pdm)   = $pro->{pdm};
  my($ed_desc, $email_text);
  my($edocs) = $pdm->getMessages;
  my($hostname) = System->hostname();
  my(%OUT);

  my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

  my($version) = $renv->{version};
  my($mailer) = $renv->{mailer} || "/usr/bin/mail";
  $DB::single = 1;
  if (!-x $mailer) {
    $mailer = "/bin/mail";
    return if (!-x $mailer);
  }
  my($st_found);
  if (System->get_stFound()) {
     $st_found = "*** StorTools is running: " . System->get_stFound() . "\n";
  }

  foreach $notif (@$notifs) {  # Each notification.
     $admin = Util->rtrim($notif->{email});
     $eventType = Util->rtrim($notif->{event});  # discovery|stateChange|..
     next if (!$admin);
     $p = $notif->{priority};
     foreach $ed (@$edocs) {   # Each Message.
       next if ($ed->type() eq Message::TYPE_ALERT); # Skip alerts
       $sev = $ed->severity;
       $cat = $ed->id("category"); # A5/T3 ...
       next if ($ed->id("active") eq "N"); # no email if quiesced
       my($ev)     = $ed->instances()->[0];
       my($agent)  = $ed->instances()->[1];
       my($source) = $agent->propertyByName('IdentificationCode')->value if ($agent);
       my($etype0) = $ev->propertyByName('EventType')->value if ($ev);
       my($etype)  = $etype0;
       my($ix) = index($etype0, '.');
       if ($ix > 0) {
         $etype = substr($etype0, $ix+1);
         $cat   = substr($etype0, 0, $ix);
       }
       next if ($notif->{device} ne "*" && lc($notif->{device}) ne lc($cat) );
       next if ($eventType ne "*" && lc($eventType) ne lc($etype) );
#       next if (!($p eq "*" || ($p eq  "9" && $sev < 2) || $p eq $sev)) ;

       $ed_desc = $ed->eventData("Description");
       my($eid) = $ed->eventData('EventId');
       my($etime) = $ed->eventTime();
       my($data);
       if ($ed_desc =~ /:$/) {
            $data = $ev->propertyByName('Data')->value;
            $data =~ s/ \|\| /\n /g;
       }
       if ($notif->{type} eq "Email") {
           $OUT{$admin} .= 
                "Source   : $source\n".
                "Category : " . ucfirst($cat) . " \n".
                "EventType: $etype \n".
                "EventTime: $etime \n\n".
                "$ed_desc\n";
                $OUT{$admin} .= "\n" . $data;
           $OUT{$admin} .= "\n" . "-" x 70 . "\n";

       } else {  # page
           $email_text = "From: Network Storage Agent\nSubject: Message from '$hostname'\n\n";
           Debug->print1("Paging to $admin");
           Util->run_command("$mailer $admin", "mail", 10, 
                      {data => substr($ed_desc . " " . $data, 0, 250) });
       }
    }
  }

  foreach $admin (keys %OUT) {
     Debug->print1("Emailing to $admin");
     Util->run_command("$mailer $admin", "mail", 10,
            {data => "From: Network Storage Agent\n".
                     "Subject: Message from '$hostname' ($version)\n\n" .
            "You requested the following events be forwarded to you from ".
            "'$hostname'.\n$st_found\n" . $OUT{$admin} });
  }
}

  
1;
