package HttpProvider;
#  $Name:  $ 
#  $Id: HttpProvider.pm,v 1.14 2001/06/13 23:52:41 ccadieux Exp $

use PDM;
use PDM::ConfigFile;
use PDM::SAF;
use Carp;
use Message;
use Util;
use System;
use Util::Http;
use strict;

use base 'Provider';
sub revision {'$Revision: 1.14 $'}

sub description {'Http'}
sub new {
  my($self, $pdm)  = @_;

  my($p) = { pdm => $pdm };

  bless($p,'HttpProvider');
  return $p;
}

# http://shadow:8080/servlet/InsertService

sub UPDATE {
  my($class, $q) = @_;
  my($active, $ip, $proxy, $to, $err, $info);
  my($renv, $dev, $host,$notifs);

  if ($q->{ACTION} eq "Update") {
      ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

    $renv->{'pro.http.active'} = $q->{active}? "Y":"N";
    $renv->{'pro.http.ip'}     = $q->{ip};
    my $url =  $q->{ip};
    $renv->{'pro.http.proxy'}  = $q->{proxy};
    $renv->{'pro.http.timeout'}  = $q->{to};
    my $data = Util::Http->get("$url?health", 20);
    if ($data !~ /OK/) {
       $err = &main::info("ERROR: Cannot access $url: $Util::Http::ERROR ");
    } else {
       $err = &main::info("Configuration updated!", "green");
    }
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);

  }

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  if ($renv->{'pro.http.active'} eq "Y") {
    $active = "checked" ;
  } else {
    $info = "<font color=red><b>Inactive</b>";
  }
  $ip     = $renv->{'pro.http.ip'} || "http://nscc:2000/nscc30/InsertService";
  $proxy  = $renv->{'pro.http.proxy'};
  $to     = $renv->{'pro.http.timeout'} || 90;

 my($o) =<<EOF;
<body bgcolor=$main'BGCOLOR>
$err
<form  method=get>
 <input type=hidden name=GO value=GUI::Providers::display>
 <input type=hidden name=option value=$q->{option}>
<center>
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;Http Provider Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Active:</td>
      <td><input type=checkbox name=active $active> $info

<tr><td bgcolor=$main'LIGHT align=right>IP Address:</td>
      <td><input type=text name=ip value=\"$ip\" size=60>

<tr><td bgcolor=$main'LIGHT align=right>Proxy Address:</td>
      <td><input type=text name=proxy value=\"$proxy\" size=60>

<tr><td bgcolor=$main'LIGHT align=right>Timeout (secs):</td>
      <td><input type=text name=to value=\"$to\" size=5>
</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
</form>
EOF

    return $o;

}


  

sub RUN {
  my($pro, $pdm) = @_;
  my($f, $l, $transmit);
  $DB::single = 1;

  my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

  return if ($renv->{'pro.http.active'} ne "Y");

  my($url) = $renv->{'pro.http.ip'};
  my($to)  = $renv->{'pro.http.timeout'} || 60;
  $url .= "?InsertType=cim/c";

  return if (substr($url, 0, 4) ne "http");

  my($post) = "";
  my(%options, $old);
  my($saf) = PDM::SAF->new({ file => "http", size => 2000000 } );
  my($safcnt, $saferr);
  my($allresp);
  while ( ($old = $saf->read()) ) {
     $options{timeout} = $to;
     if ($renv->{'pro.http.proxy'}) {
        $options{proxy} = $renv->{'pro.http.proxy'};
     }

     my($err, $resp) = Util::Http->post($url, $old, \%options);

     if ($err) {
       if (index($allresp, $resp) < 0) {
         $allresp .= "$resp,";
         Debug->err(CANNOT_HTTP => "Provider: $url: $resp");
       }
       $saf->failed($old);
       $saferr++;
     } else {
       $safcnt++;
     }
  }
  $saf->done;
  if ($saferr + $safcnt) {
    Debug->print2("StoreAndForward: sending " . ($safcnt+0) ." saved events, failed=" . ($saferr+0) );
  }

  my($newerr) = 0;
  $allresp = "";
  foreach my $ed (@{ $pdm->getMessages}) {
     $post = $ed->toC;
     Debug->print2("Http ($url): " . $ed->className . " " . $ed->description );
 
     $options{timeout} = $to;
     if ($renv->{'pro.http.proxy'}) {
        $options{proxy} = $renv->{'pro.http.proxy'};
     }

     my($err, $resp) = Util::Http->post($url, $post, \%options);

     if ($err) {
       if (index($allresp, $resp) < 0) {
         $allresp .= "$resp,";
         Debug->err(CANNOT_HTTP => "Provider-1: $url: $resp");
       }
       $newerr++;
       $saf->write($post);
     }
  }
  Debug->print2("HttpProvider done: $newerr new errors.");

}


  
1;
