package SRSProvider; 
#  $Name:  $ 
#  $Id: SRSProvider.pm,v 1.18 2001/10/17 22:38:01 ccadieux Exp $

use PDM;
use Carp;
use Message;
use Util;
use strict;
use Catalog;
use Util::Http;

use base 'Provider';
sub revision {'$Revision: 1.18 $'}
sub description {"SRS"}

sub new {
  my($self, $pdm)  = @_;

  my($p) = { pdm => $pdm };

  bless($p,'SRSProvider');
  return $p;
}

sub UPDATE {
  my($class, $q) = @_;
  my($active, $ip, $proxy, $to, $err, $name, $nat, $info, $ip2);
  my($renv, $dev, $host,$notifs, $o);

  if ($q->{ACTION} eq "Update") {
    ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

    $renv->{'pro.srs.active'} = $q->{active}? "Y":"N";
    $renv->{'pro.srs.ip'}     = $q->{ip};
    $renv->{'pro.srs.ip2'}     = $q->{ip2};
    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);

    $err = &main::info("Configuration updated!", "green");
  }

  ($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  if ($renv->{'pro.srs.active'} eq "Y") {
    $active = "checked" ;
  } else {
    $info = "<font color=red><b>Inactive</b>";
  }

  $ip     = $renv->{'pro.srs.ip'};
  $ip2     = $renv->{'pro.srs.ip2'};
  $nat    = $renv->{'pro.srs.nat'};

 $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
$err
<form  method=get>
 <input type=hidden name=GO value=GUI::Providers::display>
 <input type=hidden name=option value=$q->{option}>
<center>
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;SRS Provider Information</td>

<tr><td bgcolor=$main'LIGHT align=right>Active:</td>
      <td><input type=checkbox name=active $active> $info

<tr><td bgcolor=$main'LIGHT align=right>IP Address:</td>
      <td><input type=text name=ip value=\"$ip\" size=40>
<tr><td bgcolor=$main'LIGHT align=right>Second IP Address (optional):</td>
      <td><input type=text name=ip2 value=\"$ip2\" size=40>


</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
</form>
EOF
  return $o;

}

sub RUN {
  my($pro) = @_;
  my($notifs, $notif, $p, $ed, $id, $cat, %SP, %MAP);
  my($pdm)   = $pro->{pdm};
  my($ed_desc, $email_text);
  my($edocs) = $pdm->getMessages;
  $DB::single = 1;

  return if ($pdm->getEventCount == 0);

  my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

  return if ($renv->{'pro.srs.active'}  ne "Y");

  $SP{$renv->{hostname}} = ($renv->{solution} eq "Y") ? 1:0;
  foreach my $h (@$hosts) {
     $SP{$h->{hostname}} = ($h->{solution} eq "Y") ? 1:0;
  }

  # my $dtd   = $renv->{'pro.srs.ip'};
  # $dtd = "http://$dtd" if (substr($dtd,0,4) ne "http");
  # $dtd .= "/" if (substr($dtd,-1) ne "/");
  
  my $dtd = "http://localhost/srs_station_message.dtd";

  my $SEQ = PDM->getCacheHandle("srs_seq");

  my $HEAD =<<EOF;
<?xml version="1.0" encoding="US-ASCII" standalone="no"?>
<!DOCTYPE srs_station_message SYSTEM "$dtd">
EOF

  my($topo, $last_topo, $mess);
  my $LD =  System->get_home(). "/DATA/last_srs_topo";

  $topo = &srs_topo($devices, $hosts, $renv, \%SP, \%MAP);
  if (open(O, $LD)) {
     my @a = <O>; close(O);
     $last_topo = join("", @a);
  }
  my $time = System->srs_time();
  my $ip = Util->name2ip($renv->{hostname});

  if ($topo ne $last_topo) {
     $SEQ->{seq}++;
     $mess =<<EOF;
$HEAD
<srs_station_message seq_no="$SEQ->{seq}" timestamp="$time" 
                      sourceIP="$ip" sourceName="RASAGENT">
   $topo
</srs_station_message>
EOF
     my $err = $pro->send($renv, $mess);
     Debug->print2("  - SRSProvider: topology");
     if ($err) {
        Debug->err(SRS => "Cannot send:$err");
     } else {
       open(O, ">$LD");
       print O $topo;
       close(O);
     }
  }
  
  my($ev, $x, $alert, $severity, $al, $agent, $host, $desc);
  my($event_desc, $event_type, $source);
  my($event_id, $event_time);

  $DB::single = 1;
  my($srs) ;
  for ($x=0; $x <= $#$edocs; $x++) {
     $ed   = $edocs->[$x];
     next if ($ed->type() eq Message::TYPE_ALERT); # Skip alerts

     $ev       = $ed->instances(0);
     $event_type = $ev->propertyByName("EventType")->value();
     if ($event_type eq "agent.HeartbeatEvent") {
        $SEQ->{seq}++;
        $srs =<<EOF;
$HEAD
 <srs_station_message seq_no="$SEQ->{seq}" timestamp="$time" 
                      sourceIP="$ip" sourceName="RASAGENT">
    <heartbeat period="1440" />
 </srs_station_message>
EOF
        my $err = $pro->send($renv, $srs);
        if ($err) {
          Debug->err(SRS => "Cannot send:$err");
        } 
        Debug->print2("  - SRSProvider: HeartBeat");
        next;
     }
     
     next if ($ev->propertyByName("Actionable")->value ne "TRUE") ;  # must be actionable

     $alert = $edocs->[$x+1];
     $al = $alert->instances(0);

#           RAS    SRS
#  warning  1      3
#  error    2      4/minor 5/major
#  down     3      5/major 6/critital
#
     $severity   = $al->propertyByName("Severity")->value() + 2 ;    # must have a severity
     next if (!$severity);
     $event_desc = $ev->propertyByName("Description")->value();
     my $event_desc0 = $event_desc;
     my $data;
     if (substr($event_desc,-1) eq ":") {
       $data = $ev->propertyByName("Data")->value();
       if ($data) {
         my @X = split(/\n/, $data);
         $event_desc .= " ($#X lines)";
       }
     }
     $event_desc = Util->escapeValue($event_desc);
     
     $event_id   = $ev->propertyByName("EventId")->value();
     $event_time = $ev->propertyByName("EventTime")->value();
     $event_time = substr($event_time,0,8) . "." .  substr($event_time,8,6) . 
                   substr($event_time, -5,3);
     $agent      = $ed->instances(1);
     $host       = $ed->instances(4);
     # $source     = $ev->propertyByName("SourceIP")->value();
     $cat   = $ed->id("category"); #  or System->model();
     next if (index("agent,stools4,topo,host,mpxio,san", $cat) >= 0);

     my $target  = $ev->propertyByName("Target")->value();
     $target =~ s/\:/-/;
     $source     = $MAP{$target};
     if (!$source) {
        Debug->print2("SRSProvider: Cannot find source for $target");
        next;
     }
        
     my($sys)  = $ed->instances(4);
     $sys = $ed->instances(8) if ($sys->type() eq "H");

     $SEQ->{seq}++;
     $srs =<<EOF;
$HEAD
 <srs_station_message seq_no="$SEQ->{seq}" timestamp="$time" 
                      sourceIP="$ip" sourceName="RASAGENT">
    <alarm source="$source" provider="RASAGENT" module="$target"
           alarm_id="$event_id" timestamp="$time" state="O" severity="$severity"
           type="$event_type">
          $event_desc
    </alarm>
 </srs_station_message>
EOF
     my $err = $pro->send($renv, $srs);
     if ($err) {
       Debug->err(SRS => "Cannot send:$err");
     } 
     Debug->print2("  - SRSProvider: alarm $event_desc0 ");
  }

}

sub send {
   my($pro, $renv, $mess) = @_;

   foreach my $srs_ip ('ip','ip2') {
     my($url) = $renv->{'pro.srs.' . $srs_ip};
     next if (!$url);

     $url = "http://$url" if (substr($url,0,4) ne "http");
     $url .= "/ETMessage/";

     if (Debug->level() >= 3) {
       open(O, ">>/tmp/srs.xml");
       print O "url=$url\n";
       print O $mess;
       print O "\n--------------------------------------------\n";
       close(O);
     }
     my($err, $value) = Util::Http->post($url, $mess, 20);

     if ($err =~ /500/) {  # retry
        sleep(1);
        ($err, $value) = Util::Http->post($url, $mess, 20);
     }
     
     if ($err) {
        $err .= ": $value";
        return $err;
     }
   }
   return undef;
}


sub srs_topo {
  my($devices, $hosts, $renv, $SP, $MAP) = @_;
  my(%H,%G, $port);
  foreach my $d (@$devices) {
     my $ho = $d->{host} || $renv->{hostname};

     if ($d->{type} eq "t3" && !$SP->{$ho}) {
         my($wwn, $port) = Catalog->deviceRead("t3", Catalog::WWN, $d->{wwn}, Catalog::Key);
         $MAP->{"t3-$wwn"} = $d->{ipno};
         if ($wwn)  {
            $G{t3} .=<<EOF;
      <node action="ADD" address="$d->{ipno}" name="t3-$wwn" model="t3" serial="$wwn"/>
EOF
         }
     } elsif (($d->{type} eq "switch" || $d->{type} eq "brocade") && !$SP->{$ho}) {
         my $t = $d->{type};
         my $wwn = $d->{wwn};
         $MAP->{$t."-$wwn"} = $d->{ipno};
         if ($wwn) {
            $G{switch} .=<<EOF;
      <node action="ADD" address="$d->{ipno}" name="$t-$wwn" model="$t" serial="$wwn"/>
EOF
         }

     } else {
         my $wwn = $d->{wwn};
         my $host = $d->{host} || $renv->{hostname};

         if ($d->{type} eq "t3") {
           ($wwn, $port) = Catalog->deviceRead("t3", Catalog::WWN, $d->{wwn}, Catalog::Key);
         }
         &addModule(\%G, $host, $d->{type}, $wwn, $MAP) ;
     }
  }
  &addModule(\%G, $renv->{hostname}, "message", System->hostid(), $MAP);
  if ($renv->{categories} =~ /t3/) {
    &addModule(\%G, $renv->{hostname}, "t3message", System->hostid(), $MAP);
  }

  foreach my $h (@$hosts) {
     &addModule(\%G, $h->{hostname}, "message", $h->{hostid}, $MAP);
     if ($h->{categories} =~ /t3/) {
       &addModule(\%G, $h->{hostname}, "t3message", $h->{hostid}, $MAP);
     }
  } 
    
  my $out =<<EOF;
<topology type="FULL">
  <provider name="RASAGENT" vendor="SUN Microsystems" version="2.1"
            description="Network Storage Agent"/>
EOF
  my %N = (t3 => "SAN_T3", switch => "SAN_Switch");
  foreach my $x (keys %G) {
     if ($x eq "t3" || $x eq "switch") {
        $out .= "    <group name=\"$N{$x}\" type=\"$x\">\n$G{$x}\n    </group>\n";
     }
  }
  foreach my $x (keys %G) {
     if ($x ne "t3" && $x ne "switch") {
        $out .= "$G{$x}      </node>\n";
     }
  }
  $out .= "</topology>\n";
  return $out;
}


sub addModule {
  my($G, $host, $type, $wwn, $MAP) = @_;
  my($d_ip, $d_host);
  $d_host = $host || System->hostname();
  $d_ip = Util->name2ip($d_host);

  $MAP->{"$type-$wwn"} = $d_ip;

  if (!$G->{$d_host}) {

      $G->{$d_host} .=<<EOF;
      <node action="ADD" address="$d_ip" name="$d_host" model="rashost" serial="">
EOF
   }
   my $name= "$type-$wwn";
   $G->{$d_host} .=<<EOF;
        <module name="$name" vendor="SUN" model="$type" 
                   serial="$wwn" version="1.0" description="$type">
        </module>
EOF
}

  
1;
