package UucpProvider;
#  $Name:  $ 
#  $Id: UucpProvider.pm,v 1.3 2001/07/26 19:32:15 ccadieux Exp $

use PDM;
use Date::Format;
use PDM::ConfigFile;
use PDM::SAF;
use Carp;
use Message;
use Util;
use System;
use strict;
use Util::Http;

use base 'Provider';
sub revision {'$Revision: 1.3 $'}

sub description {'RSS'}

sub new {
  my($self, $pdm)  = @_;

  my($p) = { pdm => $pdm };

  bless($p,'UucpProvider');
  return $p;
}


sub UPDATE {
  my($class, $q) = @_;
  my($active, $ip, $proxy, $to, $err, $info);

  my($renv, $dev, $host,$notifs) = PDM::ConfigFile->read;

  if ($q->{ACTION} eq "Update") {

    $renv->{'pro.uucp.active'} = $q->{active}? "Y":"N";

    PDM::ConfigFile->write( $renv, $dev, $host,$notifs);

    $err = &main::info("Configuration updated!", "green");
  }

  if ($renv->{'pro.uucp.active'} eq "Y") {
    $active = "checked" ;
  } else {
    $info = "<font color=red><b>Inactive</b>";
  }

 my $o =<<EOF;
<body bgcolor=$main'BGCOLOR>
$err
<form  method=get>
 <input type=hidden name=GO value=GUI::Providers::display>
 <input type=hidden name=option value=$q->{option}>
<center>
<table border=2 cellspacing=2 width=90% bgcolor=white><tr><td>
<table border=0 cellspacing=2 width=100%>
<tr>
<td colspan=2 bgcolor=#666699><b><font color=white>&nbsp;RSS Provider Information</td>

<tr><td bgcolor=$main'LIGHT width=20% align=right>Provider is Active:</td>
      <td><input type=checkbox name=active $active> $info

</table>
</table>
<b>

<input type=submit name=ACTION value="Update">
</form>
EOF

  return $o;

}


sub RUN {
  my($pro, $pdm) = @_;
  my($f, $l, $transmit);
  $DB::single = 1;
  my $S2S = "/var/remote.support/scripts/sendtosupport";

  my($renv, $devices, $hosts, $notifs) = PDM::ConfigFile->read();

  return if ($renv->{'pro.uucp.active'} ne "Y");
  $DB::single = 1;
  open(O, "/etc/uucp/Permissions");
  my @l = <O>; close(O);
  my $l = "@l";
  $l =~ /MYNAME=(.*) MACHINE=/;
  my $machine = $1;

  if (!$machine) {
     Debug->err(UUCP => "Cannot find Machine name in Permissions file");
     return;
  }

  if (!-x $S2S) {
    Debug->err(UUCP => "Cannot execute $S2S");
    return;
  }

  return if ($pdm->getEventCount() == 0);

  my($uucp) = "/usr/spool/uucppublic/rasagent" ;  # prefix

  my $uucpE = "$uucp.events";
  my $uucpB = "$uucp.beep";
  my $uucpN = "$uucp.nobeep";

  my($beeps , $beep_count , $nobeeps , $nobeep_count, $events, $event_count);

  foreach my $ed (@{ $pdm->getMessages}) {
     next if ($ed->type() eq Message::TYPE_ALERT);
     $events .= $ed->toC();
     $event_count++;
     Debug->print2("UUcp: " . $ed->className . " " . $ed->description );

     my $ev = $ed->instances()->[0];

     if ($ev->propertyByName("Actionable")->value() eq "TRUE") { # beep
       $beeps .= &short_format($ed);
       $beep_count++;
     } else {
       $nobeeps .= &short_format($ed);
       $nobeep_count++;
     }
  }
  
  if ($event_count > 0) {
    if (!open(WE, ">$uucpE")) {
       Debug->err(UUCP => "Cannot open $uucpE: $!");
       return;
    }
    print WE &getHeader($event_count);
    print WE $events;
    close(WE);
    chmod 0666, $uucpE;

    system("$S2S " . &short($uucpE) . " notify $machine nobeep");
  }
  if ($beep_count > 0) {
    if (!open(WE, ">$uucpB")) {
       Debug->err(UUCP => "Cannot open $uucpB: $!");
       return;
    }
    print WE &getHeader($beep_count);
    print WE $beeps;
    close(WE);
    chmod 0666, $uucpB;

    system("$S2S " . &short($uucpB) . " notify $machine beep");
  }

  if ($nobeep_count > 0) {
    if (!open(WE, ">$uucpN")) {
       Debug->err(UUCP => "Cannot open $uucpN: $!");
       return;
    }
    print WE &getHeader($nobeep_count);
    print WE $nobeeps;
    close(WE);
    chmod 0666, $uucpN;

    system("$S2S " . &short($uucpN) . " notify $machine nobeep");
  }

  Debug->print2("RSS done.");

# sendtosupport <filename> notify dsp1 beep
# sendtosupport <filename> notify dsp1 nobeep
# sendtosupport <filename> misc   dsp1 nobeep
# sendtosupport <filename> errfile   dsp1 nobeep  maybe to send rassagent log...

}

sub short {
  my($f) = @_;
  my $ix = rindex($f, "/");
  return substr($f,$ix+1);
}

sub short_format {
  my($ed) = @_;

  my $cat = $ed->id("category");
  my $ev      = $ed->instances()->[0];
  my $etype   = $ev->propertyByName('EventType')->value if ($ev);
  my $etime   = $ed->eventTime();
  my $ed_desc = $ed->eventData("Description");
  my $agent   = $ed->instances()->[1];
  my $source  = $agent->propertyByName('IdentificationCode')->value if ($agent);

  my($data);
  if ($ed_desc =~ /:$/) {
      $data = $ev->propertyByName('Data')->value;
      $data =~ s/ \|\| /\n /g;
  }

  my $out = "Category : " . ucfirst($cat) . " \n".
            "Source   : $source \n".
            "EventType: $etype \n".
            "EventTime: $etime \n\n$ed_desc\n";
  $out .= "\n$data\n" if ($data);
  $out .= "-" x 70 . "\n";

  return $out;
}



sub getHeader {
  my($cnt) = @_;

  my $today2 = ctime(time);
  my $today  = substr($today2,4,12);

  my $head =<<EOF;
RSS ERROR NOTIFICATION
Error Classification: RANDOM_ERRORS
Number of Occurrances: $cnt

   SYSTEM ERROR REPORT   Prepared on $today

Date $today2

EOF

  return $head;
}
  

  
1;
