package Util;
#  $Name:  $ 
#  $Id: Util.pm,v 1.54 2001/10/17 22:37:55 ccadieux Exp $

use Time::Timezone;
use System;
use PDM;
use Debug;
use Socket;
use strict;

#
#  $util->new({data => $DATA,  renv => $renv });
#
# Usage: Util->get_today
#        Util->today
#        Util->include
#        Util->MTH
#        Util->rtrim
#        Util->ltrim
#        Util->rsubstr
#
use vars qw ($DATE_SIZE %MTH %MTH2 %SERIAL_MAP $Xmin_value $COPY_ERR $MASTER %LOG_EVENT $CK_TIME $WWNINFO);

$DATE_SIZE = 17;

%MTH  = (Jan => 1, Feb => 2, Mar => 3, Apr => 4, May => 5, Jun => 6,
         Jul => 7, Aug => 8, Sep => 9, Oct =>10, Nov =>11, Dec =>12);

%MTH2  = (1 => 'Jan', 2 => 'Feb', 3 => 'Mar', 4 => 'Apr', 5 => 'May', 6 => 'Jun' ,
         7 => 'Jul', 8 => 'Aug', 9 => 'Sep', 10 => 'Oct', 11 => 'Nov', 12 => 'Dec');

%SERIAL_MAP = ();

sub deserialize {
  my($class, $file, $use_cache) = @_;
  if ($use_cache) {
    return $SERIAL_MAP{$file} if ($SERIAL_MAP{$file});
  }

  my($file0) = System->get_home() . "/DATA/$file";
  my($VAR1);
  if (open(O, $file0)) {
    my(@a) = <O>;
    close(O);
    eval "@a";
    $SERIAL_MAP{$file} = $VAR1;
    return $VAR1;

  } else {
     return undef;
  }
}

sub readHtdocs {
  my($class, $f)  = @_;
  my $D = System->get_home() . "/htdocs/$f.html";
  my @l;
  if (open(O,$D) ) {
    @l = <O>; close(O);
    return "@l";
  } else {
    return "Error: $f: $!";
  }
}



# getFileAge(file, "hm");

sub getFileAge {
  my($class, $file, $format ) = @_;
  my($old_time , $age, $age_mins, $age_secs, $mins);

  my(@stats) = stat($file);
  $old_time = $stats[9];
  $age = time - $old_time; # seconds

  if (!$format || ($format eq "m") ) {
    return int($age/60);

  } elsif ($format eq "s") {
    return $age;

  } elsif ($format eq "h") {
    return int($age/60/60);

  } elsif ($format eq "ms") {
    return (int($age / 60) , $age % 60);

  } elsif ($format eq "hm") {
    $mins = int($age / 60);
    return (int($mins / 60), $mins % 60);

  } elsif ($format eq "hms") {
    $mins = int($age / 60);
    return (int($mins / 60), $mins % 60, $age % 60);
  }
}

sub stor_conflicts {
  my($class) = @_;
  my $STOR_PROCS =",stexpert,a3500fctest,a5ktest,fcdisktest,t3test,a5ksestest," .
    "ifptest,qlctest,socaltest,switchtest,disktest,fctapetest,";

  my $l;
  my($renv)     = System->get_renv();
  my @ras = `/usr/bin/ps -ef`;
  foreach my $x0 (@ras) {
     my $x = Util->ltrim($x0);
     my @a = split(/\s+/, $x);
     my $pname  = $a[7];
     my $ix  = index($pname, " ") ;
     $pname = substr($pname, 0, $ix) if ($ix >= 0);
     $ix = rindex($pname, "/");
     $pname = substr($pname, $ix+1) if ($ix >= 0);

     if (index($STOR_PROCS, ",$pname,") >= 0) {
        return "found StorTools program running: $pname";
     }
  }


  my ($time1,$ltime1) = &last_message($renv->{st4logfile} . "/sunvts.info");
  my ($time2,$ltime2) = &last_message($renv->{st4logfile} . "/stexpert.log"); 

  if ($time1 && $time1 <= $renv->{frequency}) {
      return "last message on $ltime1";

  } elsif ($time2 && $time2 <= $renv->{frequency}) {
      return "last message on $ltime2";
  }
}
  

sub last_message {
  my($D) = @_;
  my $l;
  return undef if (!-r $D);

  if (open(O, $D)) {
    seek(O, -4000, 2);
    my $ltime;
    while ($l = <O>) {
       if ($l =~ /^(\d\d\/\d\d\/\d\d \d\d:\d\d:\d\d)/) { # 06/14/01 13:43:28
         $ltime = $1;
       }
    }
    close(O);
    return undef if (!$ltime);
    my $today = Util->get_today(); # YYYY-MM-DD HH:MM:SS
    if (substr($ltime,0,2) eq substr($today,5,2) &&
        substr($ltime,3,2) eq substr($today,8,2) ) {  # same day
        my $st_min = substr($ltime,9,2) * 60 + substr($ltime,12,2);
        my $min    = substr($today,11,2) * 60 + substr($today,14,2);
        return ($min - $st_min, $ltime);
    }
  }
  return undef;
}


sub escapeValue {
  my($class, $data) = @_;

  $data =~ s/&/&amp;/sg;
  $data =~ s/</&lt;/sg;
  $data =~ s/>/&gt;/sg;
  $data =~ s/"/&quot;/sg;

  return($data);
}



sub shortHostname {
  my($class, $host) = @_;

  if ($host !~ /^\d+\.\d+/) {
     my $ii = index($host, ".");
     $host = substr($host, 0, $ii) if ($ii > 0);
  }
  return $host;
}

sub getInfo {
  my($class, $file, $section) = @_;

  open(O, System->get_home() . "/System/$file");
  my($in, $out, $l);
  while ($l = <O>) {
      if ($l =~ /\[$section\]/) {
         $in = 1;
      } elsif ($in) {
         last if ($l =~ /^\[/);
         $out .= $l if ($l ne "\n");
      }
  }
  close(O);
  return $out;
}

#
# get all WWNs from 'Found Fibre Channel device(s):
# from a remote host
# comma separated list
#
sub getFCWWNs { 
  my($class, $host) = @_;
  if ($host eq System->hostname()) {
     return get_lux_wwn();
  } else {
     my $url =  Util->makeUrl($host, "?GET=Util::lux_wwn&HTTP=1");
     my $data = Util::Http->get($url, 110);
     return $data;
  }
}

sub get_lux_wwn {
  my($q) = @_;
  my($in, $list);
  my($err, $o) = Util->run_command("/usr/sbin/luxadm probe","text",100);
  foreach my $l (@$o) {
    if ($l =~ /Found Fibre Channel/) {
       $in = 1;
    } elsif ($in) {
       if ($l =~ /Node WWN:(\w+)/) {
         $list .= "$1,";
       }
    }
  }
  if ($q->{HTTP}) {
     print $list;
  } else {
     return $list;
  }
}


sub removePort {
  my($class, $ip) = @_;

  my($x) = index($ip, ":");
  if ($x > 0) {
    return substr($ip, 0, $x);
  } else {
    return $ip;
  }
}

#
# find details about a wwn from OLD_REPORTS


sub wwnInfo {
  my($class, $wwn) = @_;
  my($report, $details, $l, $VAR1);

  my($grepf) = System->get_home() . "/DATA/tmp/WWNINFO";
  my($dir)   = System->get_home() . "/DATA/OLD_REPORTS";

  if (!$WWNINFO) {
     chdir(System->get_home() . "/DATA/OLD_REPORTS/");
     open(O, "/usr/bin/grep -i wwn *:*|");
     open(W, ">$grepf");
     while ($l = <O>) {
       print W $l;
     }
     close(O);
     close(W);
     $WWNINFO= 1;
  }
  open(O, $grepf);
  my(@a);
  while ($l = <O>) {
     if ($l =~ /$wwn/i) {
       @a = split(/:/, $l);
       next if (index(",host,st4,t3message,san,topo,message,mpxio,", ",$a[0],") >= 0);
       $report = "$a[0]:$a[1]";
       my $ix = index($l, "=>");
       my $st = length($report);
       if ($ix > $st) {
         $details = Util->ltrim(substr($l, $st+1, $ix - $st - 1));
         $details =~ s/\.portWWN//;
         $details =~ s/\.volWWN//;
       }
       last;
     }
  }
  close(O);
  if ($report) {
     if (open(O, "$dir/$report")) {
       my @b = <O>; close(O);
       eval "@b";
       if ($VAR1) {
         return ($VAR1->category(), $VAR1->name(), $details);
       }
     } else {
         return ($a[0], $a[1], $details);
     }
  }
  return ();
}

#
#  return 1 if the device is yours to monitor

sub isMineToMonitor {
  my($class, $dev) = @_;

  my($renv)     = System->get_renv();
  my($master)   = Util->findMaster;

  my($hostname) = $master? $renv->{hostname} : "";

  return ($dev->{host} eq $hostname);
}

#
# readFile in htdocs
sub readInfo {
  my($class, $f) = @_;
  my(@l);
  if (open(O,System->get_home() . "/htdocs/$f.html") ) {
    @l = <O>; close(O);
    return "@l";
  } else {
    return "Error: $f: $!";
  }
}




#########################################################################
#    RUN COMMAND
#    timeout:30 secs by default
#    output: (Err, text)
#########################################################################

sub killCommand {
  my($class, $command, $timeo) = @_;

  my(@procs) = `/usr/bin/ps -ef`;   # kill hanging processes.
  my(@kills, $pid) ;

  foreach my $proc (sort @procs) {
     my(@b) = split(/\s+/, $proc);
     if ($proc =~ /$command/ && $b[3] eq "$$") { # found and we are parent
         $pid = $b[2];
         last;
     }
  }
  if ($pid) {
     push(@kills, $pid);
     my($list) = ",$pid,"; # keep track of children 

     foreach my $proc (sort @procs) {
       my(@b) = split(/\s+/, $proc);
       if (index($list, ",$b[3],") >= 0) { 
          if (index($list, ",$b[2],") < 0) {
            $list .= "$b[2],";
            push(@kills, $b[2]) ;
          }
        }
     }
  }

  if ($#kills >= 0) {
     Debug->print2("Killing $command processes '@kills' after $timeo secs time-out ");
     kill 9, @kills;
     sleep(20);
  }
}

sub run_bg {
  my($util, $command, $to) = @_;
  my($pid, $command0);
  my($to2) = $to;

  my($sp)  = index($command," ");
  $command0 = ($sp > 0)? substr($command,0,$sp) : $command;
  
  if (($pid = fork()) == 0) { # child
     unlink "/tmp/run_bg_$$";
     exec "$command > /tmp/run_gb_$$ 2>&1";
     exit 0;
  } elsif ($pid > 0) {
     while ($to > 0) {
         sleep 2;
         last if (!-f "/proc/$pid/psinfo");
         $to -= 2;
     }
     if ($to == 0) {
        Util->killCommand($command0, $to2);
     }
  }
}

# ($err, $ret, $err2) = Util->run_command("/bin/ls 111", "as", 20);

sub run_command {
  my($util, $command, $file, $timeo, $arg) = @_;
  my(@out, $command0, $stderr);

  my $data = $arg->{data};
  $timeo = 40 if (!$timeo);
  my($f, $l);
  my($sp)  = index($command," ");
  $command0 = ($sp > 0)? substr($command,0,$sp) : $command;

  if (System->get_testMode) {
    $f = System->get_home() . "/Test/$file";
  } else {
    return ("Cannot run $command", []) if (!-x $command0);
    if ($command !~ /2\>&/) {
       $command .= " 2>/tmp/run_command.$$";
    }
    if ($data) {
      $f = "|$command";
    } else {
      $f = "$command|";
    }
  }
  Debug->print3("run_command: $f");
  Debug->snapshot("run_command: $f, timeout=$timeo");
  my($err);
  eval {
    local $SIG{ALRM} = sub { die "alarm\n" };
    alarm $timeo;
    if (open(RUN, $f)) {
       if ($data) {
         print RUN $data;
         close(RUN);

       } else {
         while ($l = <RUN>) {
           chop($l);
           push(@out, $l);
         }
         close(RUN);
       }
    } else {
       $err = "Cannot open $f: $!";
    }
  };
  alarm 0;
  if (open(O1, "/tmp/run_command.$$")) {
    while ($l = <O1>) {
      $stderr .= $l;
    }
    close(O1);
    unlink "/tmp/run_command.$$";
  }
  if ($@) {
    if ($@ eq "alarm\n") {
       Util->killCommand($command0, $timeo);
       return ("Timeout",[]);
    } else {
       return ($@,       []);
    }
  } elsif ($err)  {
    return ($err,        []);
  } else {
    Debug->snapshot1("@out");
    return (undef, \@out, $stderr);
  }
}

# formerly killProcess

sub findProcesses {
  my($class, $pid) = @_;

  my(@procs) = `/usr/bin/ps -ef`;   # kill hanging processes.

  my $list = ",$pid,";
  my $parent;
  my (@P);
  my $again = 0;

  while ($again < 2) {
    foreach my $proc (sort @procs) {
       my(@b) = split(/\s+/, $proc);
       if ($b[2] == $pid) {
         $parent = $b[2];

       } elsif (index($list, ",$b[3],") >= 0) {
         if (index($list, ",$b[2],") < 0) {
           push(@P, $b[2]);
           $list .= "$b[2],";
         }
       }
    }
    $again++;
  } 

  return ($parent, \@P);
}



sub file2object {
  my($class, $file) = @_;

  open(O, $file);
  my(@l) = <O>; close(O);
  my($obj) = eval substr("@l", 8);
  return $obj;
}

sub makeUrl {
  my($class, $ip, $url) = @_;

  if ($ip =~ /:/) {
     return "http://$ip/$url";
  } else {
     my $p = System->get_rasport();
     if (!$p) {
        Debug->err(TEXT => "rasport not defined");
        $p = "7654";
     }
     return "http://$ip:$p/$url";
  }
}


sub nnl {
  my($class, $s) = @_;
  $s =~ s/\n/ || /g; 
  return $s;
}

sub new {
  my($class , $f) = @_;
  
  $f->{today} = &today;
  bless($f, $class);
  return $f;
}

sub MTH {
  my($this, $m) = @_;
  return $MTH{$m} || $m;
}

sub MTH2NAME {
  my($this, $m) = @_;
  return $MTH2{$m+0} || $m;
}

sub include {
  my($this, $opts, $val) = @_;

  if (index($opts, $val) >= 0) {
    return 1;
  } else {
    return 0;
  }
}

sub today {
  my($class, $format) = @_;
  my($this, @now, $today);

  @now = localtime; $now[4]++; $now[5] += 1900;
  if ($format eq "YMDH") {
    $today = sprintf("%4.4d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",
                   $now[5], $now[4], $now[3], $now[2], $now[1], $now[0]);
  } else {
    $today = sprintf("%2.2d-%2.2d %2.2d:%2.2d:%2.2d",
                   $now[4], $now[3], $now[2], $now[1], $now[0]);
  }
  $today;
}


sub read_and_truncate {
 my($util, $file) = @_;
 my($l, $out);

  if (open(O2,$file)) {
     while ($l = <O2>) {
        $out .= $l;
     }
     close(O2);
     unlink($file);
  }
  $out;
}

sub get_sum {
 my($util) = @_;
 my($s1, $s2, $l);
 chdir System->get_home();
 open(O,"/usr/bin/sum bin/http lib/*pm lib/Agent/*|");

 while ($l = <O>) {
   chop($l);
   my @a = split(/\s+/, $l);
   $s1 += $a[0];
   $s2 += $a[1];
 }
 close(O);
 return "$s1-$s2\n";
}

sub ping {
  my($class, $ip, $to) = @_;

  $to = 6 if (!$to);
  my $ping = `/usr/sbin/ping $ip $to`;
  if ($ping =~ /is alive/) {
     return 1;
  }
  return undef;
}




sub testIp {
  my($util, $name, $timeout) = @_;
  my($i);
  $timeout = 6 if (!$timeout);
  $i = gethostbyname($name);
  if ($i) {
    open(O1, "/usr/sbin/ping $name $timeout|");
    my($ans) = <O1>; close(O1);
    if ($ans =~ /is alive/) {
      return inet_ntoa($i);
    } else {
      return undef;
    }
  } else {
    return undef;
  }
}

sub name2ip {
 my($util, $name, $timeout) = @_;
 my($out, $p, $i);

 my $ix = index($name, ":");
 $name = substr($name, 0, $ix) if ($ix > 0);

 return $name if ($name =~ /^\d+\.\d+\.\d+\./) ;
 $i = gethostbyname($name);
 if ($i) {
   return inet_ntoa($i);
 } else {
   return undef;
 }

}

sub get_date {
  my($this, $time) = @_;

  my(@date) = localtime($time);
  $date[4]++; $date[5] += 1900;

  sprintf("%2.2d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",
    $date[5], $date[4],$date[3], $date[2], $date[1], $date[0]);
}

# YYYY-MM-DD HH:MM:SS
sub get_today {
  my($this) = @_;

  my(@date) = localtime(time);
  $date[4]++; $date[5] += 1900;

  sprintf("%2.2d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",
    $date[5], $date[4],$date[3], $date[2], $date[1], $date[0]);
}

sub get_file_created {
  my($this, $file) = @_;
  return undef if (!-f $file);
  my(@stats) = stat($file);
  my(@date) = localtime($stats[9]);

  $date[4]++; $date[5]+= 1900;        
  sprintf("%2.2d-%2.2d-%2.2d %2.2d:%2.2d:%2.2d",
    $date[5], $date[4],$date[3], $date[2], $date[1], $date[0]);
}


  
#    'C' code :
#
#    if ($isdst > 0) { 
#      sprintf($currZone, "%d|", altzone);
#      sprintf(tmpStr, "%s", tzname[1]);
#    } else {
#      sprintf(currZone, "%d|", timezone);
#      sprintf(tmpStr, "%s", tzname[0]);
#    }
#    if (strlen(currZone) + strlen(tmpStr) > 30)
#      sprintf(currZone, "0|GMT");
#    else {
#      ctr = 0;
#      while (tmpStr[ctr] != NULL) {
#        if (tmpStr[ctr] == '&')
#          strcat(currZone, "&amp;");
#        else if (tmpStr[ctr] == '<')
#          strcat(currZone, "&lt;");
#        else if (tmpStr[ctr] == '>')
#          strcat(currZone, "&gt;");
#        else if (tmpStr[ctr] == '"')
#          strcat(currZone, "&quot;");
#        else if (tmpStr[ctr] == '\'')
#          strcat(currZone, "&#039;");
#        else
#          strncat(currZone, &tmpStr[ctr], 1);
#        ctr = ctr + 1;
#     }
#   }



sub ltrim {
  my($this, $s) = @_;

  $s =~ /^(\s*)/;
  if ($1) {
    substr($s,length($1));
  } else {
    $s;
  }
}

sub rtrim {
  my($this, $s) = @_;

  $s =~ /(\s*)$/;
  if ($1) {
    substr($s,0,0 - length($1));
  } else {
    $s;
  }
}

sub trim {
  my($this, $s) = @_;

  return ($this->rtrim($this->ltrim($s)));
}


sub rsubstr {
  my($util, $l, $off, $len) = @_;
  my($a, $b, $la);

  $a  = substr($l, $off, $len);
  $b  = substr($l, $off);
  $la = length($a);

  if ($off >= length($l) ) {
    return "";
  } elsif (length($b) < $la) {
    return $b;
  } elsif ($la > 0) {
    return rtrim($a);
  } else {
     return "";
  }
}

##############################################
#          SCHEDULED DOWN TIME
##############################################

sub sdt {
  my($self, $device ) = @_;
  my($f1, $val,$err, $in_range);

  foreach $f1 (keys %$device) {
     if (substr(uc($f1),0,3) eq "SDT") {
        $val = $device->{$f1};
        if ($val) {
           ($err, $in_range) = &sdt_format($val);
           if ($err) {
              Debug->err('SDT_ERROR', $err);
           } else {
              return $val if ($in_range);
           }
        }
     }
  }
}

sub sdt_format {
  my($f) = @_;
  my($d, $dashes, $days);
  my($d1, $d2, $h1, $h2, $m1, $m2, @now, $today, $f1, $y1, $y2);
  my($today_year, $today_dow, $today_time, $dow1, $dow2, $range1, $range2);
  my($today_dom, $mth1, $mth2, $today_month);

  @now = localtime; $now[4]++;
  $today_month = $now[4];
  $today_dow = $now[6];
  $today_dom = $now[3];
  $today_time = sprintf("%2.2d:%2.2d", $now[2], $now[1]);
  $today_year = $now[5] - 100;

  $days = ",sun,mon,tue,wed,thu,fri,sat,";
  $f    = lc($f);
  $f    =~ s/ +/ /g;
  $d    = substr($f, 0,3);
  $f1   = $f;
  $f1   =~ s/\-/$dashes++/eg;

# sdt1=Sun 23:30 - Mon 02:30            # day range, every week

  if ($dashes == 1) {
    $f =~ /(...) (\d+):(\d+) *- *(...) (\d+):(\d+)/;
    $d1 = $1; $h1 = $2; $m1 = $3;
    $d2 = $4; $h2 = $5; $m2 = $6;
    $dow1 = index($days,  ",$d1,");
    $dow2 = index($days,  ",$d2,");
    if ($dow1 < 0 || $dow2 < 0) {
       return ("Invalid DayOfWeek format", 0);
    }
    if (!$h1 || !$h2 || !$m1 || !$m2) {
       return ("Invalid Hours/Mins", 0);
    }
    if ($h1 > 23 || $h2 > 23 || $m1 > 59 || $m2 > 59) {
       return ("Invalid Hours/Mins", 0);
    }
    my($r1) = int($dow1/4);
    $range1 = sprintf("%d %2.2d:%2.2d", $r1, $h1, $m1);
    my($r2) = int($dow2/4);
    $r2 += 7 if ($r2 < $r1);
    $range2 = sprintf("%d %2.2d:%2.2d", $r2 , $h2, $m2);

    $today  = "$today_dow $today_time";

    if ($today ge $range1 && $today le $range2) {
      return (0, 1);
    } else {
      return (0, 0);
    }

# std2=DD-YY 8:30 - DD-YY 10:30         # day range, every month

  } elsif ($dashes == 3) {
    $f =~ /(\d+)-(\d+) (\d+):(\d+) *- *(\d+)-(\d+) (\d+):(\d+)/;
    $d1 = $1; $y1 = $2; $h1 = $3; $m1 = $4;
    $d2 = $5; $y2 = $6; $h2 = $7; $m2 = $8;

    if (!$h1 || !$h2 || !$m1 || !$m2 || !$d1 || !$y1 || !$d2 || !$y2) {
       return ("Invalid format", 0);
    }
    if ($h1 > 23 || $h2 > 23 || $m1 > 59 || $m2 > 59) {
       return ("Invalid Hours/Mins", 0);
    }
    $y1 -= 2000 if ($y1 >= 2000);
    $y2 -= 2000 if ($y2 >= 2000);

    if ($d1 > 31 || $d2 > 31 || $y1 > 5 || $y2 > 5) {
       return ("Invalid Day/Year, Format is DD-YY HH:MM", 0);
    }
    $range1 = sprintf("%2.2d-%2.2d %2.2d:%2.2d",$y1, $d1, $h1, $m1);
    $d2 += 31 if ($d2 < $d1);
    $range2 = sprintf("%2.2d-%2.2d %2.2d:%2.2d",$y2, $d2, $h2, $m2);
    $today = sprintf("%2.2d-%2.2d %s",$today_year, $today_dom, $today_time) ;

    if ($today ge $range1 && $today le $range2) {
      return (0, 1);
    } else {
      return (0, 0);
    }


#  sdt3=MM-DD-YY 8:30 - MM-DD-YY 10:30  # date range, specific date

  } elsif ($dashes == 5) {
    $f =~ /(\d+)-(\d+)-(\d+) (\d+):(\d+) *- *(\d+)-(\d+)-(\d+) (\d+):(\d+)/
;
    $mth1 = $1; $d1 = $2; $y1 = $3; $h1 = $4; $m1 = $5;
    $mth2 = $6; $d2 = $7; $y2 = $8; $h2 = $9; $m2 = $10;

    if (!$h1 || !$h2 || !$m1 || !$m2 || !$d1 || !$y1 || !$d2 || !$y2 ||!$mth1) {
       return ("Invalid format", 0);
    }
    if ($h1 > 23 || $h2 > 23 || $m1 > 59 || $m2 > 59) {
       return ("Invalid Hours/Mins", 0);
    }
    $y1 -= 2000 if ($y1 >= 2000);
    $y2 -= 2000 if ($y2 >= 2000);

    if ($d1 > 31 || $d2 > 31 || $y1 > 5 || $y2 > 5 || $mth1 > 12 || $mth2 > 12) {
       return ("Invalid Month/Day/Year, Format is MM-DD-YY HH:MM", 0);
    }
    $range1 = sprintf("%2.2d-%2.2d-%2.2d %2.2d:%2.2d",$y1, $mth1, $d1, $h1, $m1);
    $range2 = sprintf("%2.2d-%2.2d-%2.2d %2.2d:%2.2d",$y2, $mth2, $d2, $h2, $m2);
    $today = sprintf("%2.2d-%2.2d-%2.2d %s",
                $today_year, $today_month, $today_dom, $today_time);

    if ($today ge $range1 && $today le $range2) {
      return (0, 1);
    } else {
      return (0, 0);
    }

  } else {
    return "Invalid Format in : $f";
  }
}

##############################################
#          LAST RUN QUERY
##############################################

# returns yesterday if it's been one day since last_run, else return '';


sub clear_dir {
 my($util, $dir) = @_;

 opendir(O, $dir);
 my(@a) = readdir(O); closedir(O);
 my($cnt) = 0;
 foreach my $file (@a) {
    next if (substr($file,0,1) eq ".");
    unlink "$dir/$file";
    $cnt++;
 }
 return $cnt;
}

#
# returns a date every beginning of a new day, undef otherwise
# uses a separate file for each key (FILE)

sub is_24hours {
 my($util, $file) = @_;

 my($today) = Util->today;

 my($lastrun);
 $lastrun  = $util->file2string($file, {silent=>1});

 if (!$lastrun) {   # if new, save today to start
    $util->string2file($today, $file);
    return undef;

 } elsif (substr($lastrun,3,2) ne substr($today,3,2)) {
                                #compare days, if old enough, reset last_run
   $util->string2file($today, $file);
   return (substr($lastrun,0,6) . "00:00:00");
 }
}

#
# returns TRUE every $freq minutes, FALSE on the first time.
#
$Xmin_value = 0;

sub set_Xmins {
 my($util, $file, $freq) = @_;
 my($now) = time;
 $util->string2file($now, $file);
}


sub is_Xmins {
 my($util, $file, $freq) = @_;

 my($now) = time;

 my($lastrun);
 $lastrun  = $util->file2string($file, {silent=>1});
 $Xmin_value = 0;
 if (!$lastrun) {   # if new, save today to start
    $util->string2file($now, $file);
    return undef;

 } else {
   $Xmin_value = ($now - $lastrun) / 60;
#   $freq = $util->{renv}{frequency};
   if ( ($now - $lastrun) - ($freq * 60) >= -5 ) {
      $util->string2file($now, $file);
      return ($now - $lastrun);
   }
 }
 return undef;
}

$COPY_ERR = "";
# options: {bigger => 1}  # requires that old be bigger than new
#                         # to copy
sub copy {
  my($util, $old, $new, $options) = @_;
  my($l);
  if ($options->{bigger}) {
     my($osize) = (stat($old))[7];
     my($nsize) = (stat($new))[7];
     if ($osize < $nsize) {
        $COPY_ERR = "Error: '$old:$osize' is smaller that '$new:$nsize'";
        return undef;
     }
  }
  if (open(O,$old) && open(W, ">$new")) {
    while ($l = <O>) {
      print W $l;
    }
    close(O); close(W);
    return 1;
  } else {
    $COPY_ERR = "Error copying $old -> $new: $!";
    return undef;
  }
}

sub as_array {
  my($agent, $s) = @_;

  my(@a) = split(/\n/, $s);
  return \@a;
}

sub readf {
  my($agent, $f, $off) = @_;
  my($o, $l);
  if (open(O, $f)) {
     while ($l = <O>) {
       $o .= $off . $l;
     }
     return $o;
  } else {
     return undef;
  }
}

sub writef {
  my($agent, $f, $data) = @_;
  
  if (open(O,">$f")) {
    print O $data;
    close(O);
    return undef;
  } else {
    return $!;
  }
}

$MASTER = undef;

sub findMaster {
  my($class) = @_;
  if (defined($MASTER) ) {
     return $MASTER;
  }
  $MASTER = $class->read_system_field("MASTER") || 0;
  return $MASTER;
}

# value=\"ras:agent\@$h->{hostname}:$port/?GO=$from\"

sub select_hosts {
  my($class, $from) = @_;
  my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read();
  my($master) = Util->findMaster;
  my($port) = System->get_rasport();
  my($out) ;
  if ($master)  { # you are a slave
    return "<b>[ <a href=http://$master:$port/?GO=$from>Back to Master</a> ]";
  } else {
    $out .= "<table border=1 cellspacing=0 cellpadding=0><tr><td><b><input type=hidden name=GO value=Util::select_hosts1>
    <select name=hosts><option value=\"[GO=$from]\">[Select Slave Host]";

    foreach my $h (@$hosts) {
       my $hno = $h->{ipno} || $h->{hostname};
       $out .= "<option value=\"$hno:$port/?GO=$from\">$h->{hostname}</option>";
    }
    $out .= "</select><b><input type=submit name=ACTION value=GO></table>";
    return $out;
  }
 
}

sub select_hosts1 {
  my($q) = @_;
  if (substr($q->{hosts},0,1) ne "[") {
     print "<meta http-equiv=Refresh content=\"0;URL=http://$q->{hosts}\">";
  } else {
     my($ix) = index($q->{hosts}, "GO=");
     my($sub) = substr($q->{hosts}, $ix+3, -1);
     if (defined(&$sub)) {
        &$sub;
     }
  }
}
  


sub read_system_field {
  my($class, $file) = @_;
  my($l);
  if (open(O,System->get_home() . "/DATA/$file")) {
    $l = <O>;
    close(O);
    chop($l) if (substr($l,-1) eq "\n");
    return $l;
  } else {
    return undef;
  }
}

sub file2string {
  my($util, $file, $arg) = @_;
  my($l);
  if (open(O, System->get_home() . "/DATA/$file")) {
     $l = <O>;
     close(O);
     return $l;
  } else {
     if (!$arg->{silent}) {
        Debug->err(CANNOT_READ => "$file: $!");
     }
     return undef;
  }
}

sub string2file {
   my($util, $s, $file) = @_;

   if (open(O,">" . System->get_home() . "/DATA/$file")) {
      print O $s;
      close O;
      return 1;
   } else {
      return undef;
   }
}

sub readTail {
  my($util, $file, $size) = @_;
  my($time, $x);
  $size = (stat($file))[7];
  my(@x, @a, $l);
  if (open(O, $file) ) {
        seek(O,-40000, 2);
        $l = <O>;
        while ($l = <O>) {
           my(@b) = split(/\t/, $l);
           $time = $b[0];
           $time =~ /(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/;
           $time = "$2/$3/$1 $4:$5:$6";
           my $type = sprintf("%-30.30s", $b[1]);
           push(@a, "$time  $type  $b[2]");
        }
        close(O);
        for ($x=$#a; $x >= 0; $x--) {
          print $a[$x];
        }
   } else {
        print "Cannot read $file: $!<br>";
   }
}

#########################################################################
#    HTTP GET
#########################################################################

sub encode {
  my($class, $s) = @_;

  $s =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  $s;
}


sub decode {
  my($class, $s) = @_;
  $s =~ s/\+/ /g;
  $s =~ s/%([0-9|A-Fa-f]{2})/pack('C',hex($1))/eg;
  $s;
}



################################################
#  SLAVE SERIALIZE / DESERIALIZE 
#  
################################################
# message:   C:A5000\t messages (tabs instead of new lines) \n

sub mess_serialize {
  my($util, $type, $mess) = @_;
  my($l, $x, $out);

  if (ref($mess) eq "ARRAY") {
     return "" if ($#$mess < 0);
     for ($x =0; $x <= $#$mess; $x++) {
        $l = $mess->[$x];
        $l =~ s/\n/\t/g;
        $out .= $l . "\t";
     }
     return "$type\t$out". "\n";
     
  } else {
     $mess =~ s/\n/\t/g;
     return "$type\t$mess" . "\n";
  }
}

sub mess_deserialize {
  my($util, $mess) = @_;
  my($event_type, $cat, $out, $event) ;

  my($ix) = index($mess, "\t");
  $event = substr($mess, 0, $ix);
  ($cat,$event_type) = split(/:/, $event); 
  $out = substr($mess, $ix+1);
  $out =~ s/\t/\n/g;
  return ($event_type, $cat, $out);
}

sub mess_deserializeO {
  my($util, $categories, $mess) = @_;
  my($x,$ix, $info, $cat, $out);
  my($header);

  my(@cats) = split(/:/, $categories);

  my(@a) = split(/\n/, $mess) ;
  if ($categories eq "*") {           #remove categories
    for ($x = 0; $x <= $#a; $x++) {
      $ix = index($a[$x],"\004");
      $info = substr($a[$x],$ix+1);
      $info =~ s/\t/\n/g;
      $out .= $info . "\n";
    }
    return $out;
  }

  for ($x = 0; $x <= $#a; $x++) {
    $ix = index($a[$x],"\004");
    $cat =  substr($a[$x],0,$ix);
    $info = substr($a[$x],$ix+1);
    $info =~ s/\t/\n/g;
    if ($cat eq $cats[0] || $cat eq $cats[1]) {
       $out .= $info . "\n";
    }
  }
  return $out;

}

%LOG_EVENT = ();

#
# $data: pointer to array that represent one event.

sub log_event {
  my($util, $type, $data) = @_;
  my($del, $chmod, $today);
  my(@a)     = split(/:/, $type);
  $today = Util->today;
  
  my($y)     = substr($today, 0,4);
  my($mth)   = substr($today, 5,2);
  my($keep) = $util->{renv}{log_months};  # N/U

  my($file) = "$util->{data}/EVENTS/$a[1].log";

  if ($util->{renv}{local_event_log} eq "Y" && $data) {
     my($size) = (stat($file))[7];
     if ($size > 1 * 1000000) {
        rename $file, $file . ".2";
     }
     $chmod = 1 if (!-f $file);
     if (open(O,">>$file")) {
       $data =~ s/\n/\t/g;
       print O "$data\n";
       close(O);
     } else {
       Debug->err(CANNOT_WRITE => $file);
     }
     chmod 0666, $file if ($chmod);
  }
}

sub pprint {
  my($class, @args) = @_;
  print indentXML($class, @args);
}

#
#  pprint $string, $string2...;
sub indentXML {
    my($class, @args) = @_;
    my($o);
    foreach (@args) {
        s/></>\n</g;

        my $depth = -1;
        foreach $_ (split /\n/) {
            my ($up, $down) = (0, 0);

            if (/<.*>.*<\/.*>/) {  # both start and end tag
                $up = $down = 1;
            }
            if (/<\?xml /) {       # special tags with no indent
                $up = $down = 1;
            }
            elsif (/<\/.*/) {      # single end tag
                $down = 1;
            }
            elsif (/.*\/>/) {      # start and end tag as one, eg. '<VALUE/>'
                $up = $down = 1;
            }
            elsif (/<.*/) {        # single start tag
                $up = 1;
            }
            else {                 # simple text
                $up = $down = 1;
            }
            $depth++ if $up;
            $o .= "  " x ($depth) . $_ . "\n";
            $depth-- if $down;
        }
    }
    return $o;
}

sub wOpen {
  my($util) = @_;

  print <<EOF;
<script>
  var w=window.open("","Log","scrollbars,resizable,width=300,height=200");
  w.moveTo(10,10);
  w.focus();
  var d=w.document;
  d.clear();
  d.write('<head><title>Agent Log</title></head><body bgcolor=white><p>');
</script>
EOF
}

sub wPrint {
  my($util, $x) = @_;
  print "<script>d.write('$x');</script>";
}
sub wClose {
  my($util, $x) = @_;
  print "<script>d.write('<center><form><input type=submit value=Close onclick=window.close()></form>');</script>";
}

$CK_TIME = -1;

# 1 = success

sub checksum {
  my($class,  $file) = @_;
  my($found, @a, $text, @text, $l);
  return 1;  # off for now

  $CK_TIME = PDM->isXdays("checksum", 1) if ($CK_TIME == -1);
  return 1 if (!$CK_TIME);

  Debug->print3("Doing checksum on $file.");

  my($fname) = System->get_home() . "/DATA/ck_list";
  if (-f $fname) {
    if (open(O, $fname)) {
      while ($l = <O>) {
         @a = split(/=/, $l);
         if ($a[0] eq $file) {
            $found = $a[1];
         }
      }
    }
  }
  open(O, $file);
  <O>;
  @text = <O>; close(O);
  $text= "@text";
  my $newck = Util->_checksum($text);
  
  if ($found) {
     if ($newck != $found) {
        PDM->isXreset("checksum");
        return 0;
     }
  } else {
    open(O, ">>$fname");
    print O "$file=$newck\n";
    close(O);
  }
  return 1;
}


sub _checksum {
    my ($class,
        $msg            # The message to checksum
        ) = @_;
    my ($len_msg,       # Length of the message
        $num_short,     # The number of short words in the message
        $short,         # One short word
        $chk            # The checksum
        );

    $len_msg = length($msg);
    $num_short = $len_msg / 2;
    $chk = 0;
    foreach $short (unpack("S*", $msg))
    {
        $chk += $short;
    }                                           # Add the odd byte in
    $chk += unpack("C", substr($msg, $len_msg - 1, 1)) if $len_msg % 2;
    $chk = ($chk >> 16) + ($chk & 0xffff);      # Fold high into low
    return(~(($chk >> 16) + $chk) & 0xffff);    # Again and complement
}

# arg = {select => 0}
# default is no select option

sub makeSelect {
  my($class, $name, $l, $val, $arg) = @_;
  my($o, $ck);
#  $arg->{select} =1 means that you want a select option

  my @a = split(/\|/, $l);
  $o = "<select name=$name>";
  $o .= "<option value=\"\">[Select]</option>" if ($arg->{select});

  foreach my $x (@a) {
    my @b = split(/=/, $x);
    $b[1] = $b[0] if (!$b[1]);
    $ck = ($b[0] eq $val)? "selected":"";
    $o .= "<option $ck value=$b[0]>$b[1]</option>";
  }
  $o .= "</select>";
  return $o;
}

sub snmpType {
  my($class, $ip) = @_;

  $ENV{LD_LIBRARY_PATH} = System->get_home() . "/bin/lib";
  my($MIBS) = System->get_home() . "/snmp/mibs";

  my($com) = System->get_home() . "/bin/snmpget";

  open(O, "$com -t 10 -r 0 $ip public 1.1.0 2>/dev/null|");
  my $l = <O>;
  close(O);
  if ($l =~ /T3/) {
     return "t3";
  } elsif ($l =~ /Switch/) {
     return 'switch';
  }
  return undef;
}

sub switchWWN {
  my($class, $ip) = @_;

  my($err,$com) = Util->run_command(
         System->get_home() . "/bin/sanbox version $ip", "raidutil.txt", 10);
  my($com2) = "@$com";
  $com2 =~ /WWN:\s+([0-9a-f]+)/;
  my($wwn) = $1;
  return $wwn;
}



sub t3WWN {
  my($class, $ip, $host) = @_;
  my $rc;
  if ($host) {
     my $url = Util->makeUrl($host, "?GO=Util::snmpWWN_&ip=$ip&HTTP=1&type=t3");
     $rc = Util::Http->get($url, 10);
  } else {
     $rc = &snmpWWN_({ip => $ip, type => 't3'});
  }
  return substr(lc($rc),1,-1);
}

# host is optional

sub snmpWWN {
  my($class, $ip, $host) = @_;
   
  if ($host) {
     my $url = Util->makeUrl($host, "?GO=Util::snmpWWN_&ip=$ip&HTTP=1");
     my $rc = Util::Http->get($url, 10);
     return $rc;
  } else {
     return &snmpWWN_({ip => $ip});
  }
}

sub snmpWWN_ {
  my($q) = @_;

  my $ip = $q->{ip};

  $ENV{LD_LIBRARY_PATH} = System->get_home() . "/bin/lib";
  my($MIBS) = System->get_home() . "/snmp/mibs";

  my($com) = System->get_home() . "/bin/snmpget";
  my($mib) = ($q->{type} eq 't3')? '.iso.3.6.1.4.1.42.2.28.2.2.5.2.1.10.0.0': 
                 '2.2.1.6.1';

  open(O, "$com -t 10 -r 0 $ip public $mib 2>/dev/null|");
  my $l = <O>;
  close(O);
  my(@a) = split(/=/, $l);
  $l = $a[1];
  $l = lc($l);
  $l =~ s/hex: //;
  $l = Util->trim($l);
  return "" if ($l eq "\"\"");
  @a = split(/[\: ]/, $l);
  my($out) = "";
  foreach my $x (@a) {
     my $x0 = lc($x);
     if (length($x0) == 1) {
          $x0 = "0$x0";
     }
     $out .= $x0;
  }
  if ($q->{HTTP}) {
     print $out;
  } else {
    return $out;
  }

}

#
# $a = Util->findMethods("Agent","Agent", "isSelectable");
# $a->[0] = A5K=1
# $a->[1] = A35K=1

sub findMethods {
  my($class, $dir, $pat, $method) = @_;
  my(@a, @V, $l);

  opendir(O, System->get_home() . "/lib/$dir");
  @a = readdir(O); closedir(O);

  foreach my $f (@a) {
     next if (substr($f,0,1) eq ".");
     next if (substr($f,-3) ne ".pm");
     next if ($pat && $f !~ /$pat/) ;
     open(O, System->get_home() . "/lib/$dir/$f");
     my($cnt) = 0;
     while (defined($l = <O>) && ($cnt++ < 100)) {
          if ($l =~ /^sub $method (.*)/) {
             my($val) = eval $1;
             push(@V, substr($f,0,-3) . "=$val");
             last;
          }
     }
     close(O);
  }
  return \@V;
}

  
#  $XREF = Util->getXref();

sub getXref {
  my($class) = @_;

  my($f) = System->get_home() . "/DATA/CACHE/device_access";
  my($XREF);

  if (open(O, $f)) {
    my(@a) = <O>; close(O);
    eval "\$XREF " . substr("@a",5);
  } else {
    Debug->print2("Error: $!");
  }
  return $XREF;
}

  
sub get_remoteDataPath {
  my($q) = @_;
  my($lux)  = System->find_luxadm;
  my($wwn) = $q->{wwn};

  my($TO) = 30;

  my($err,$com) = Util->run_command("$lux display $wwn 2>&1", "luxadm.txt" , $TO);
  if ($err) {
     print "ERR";
  } elsif ($#$com > 5) {
     print "OK";
  } else {
     print "BAD";
  }
  print "\n";
}



sub get_checkRasCrons {
  my($q) = @_;
  print Util->checkRasCrons();
}


sub checkRasCrons {
  my($q) = @_;
  my($out, @l);
  my($ps)   =  System->find_command("ps");
  my($grep) =  System->find_command("grep");

  open(O, "$grep rasagent /var/spool/cron/crontabs/root|");
  @l = <O>; close(O);
  my $cron = "@l";

  open(O, "$ps -ef | $grep \"/cron\" | $grep  -v grep|");
  @l = <O>; close(O);
  $ps = "@l";

  if ($cron  && $cron !~ /^\s*\#/) {
     $out .= "<b><font color=green>- OK: The Network Storage Agent cron exist.</font></b>";
  } else {
     $out .= "<b><font color=red>- ERROR: Network Storage Agent cron is missing:</font></b><br>
      Verify the installation, possibly run 'ras_install' again.
      A cron entry for SUNWrasag's rasagent should be present for the rasagent program to run properly.";
  }
  $out .= "<p>";
  my($testMode) = "<h2>*** Test Mode On ***</h2>" if (System->get_testMode());
  if ($ps) {
     $out .= "<b><font color=green>- OK: The cron daemon is running.</font></b>";
  } else {
     $out .= "<b><font color=red>- ERROR: The cron daemon is NOT running:</font></b>
      <br> The cron daemon should always be running, consult your system administrator.";
  }
  return $out;
}

#
#  desc : content of email
#  name : attachment name
#  content: attachment content
#
sub email_html {
  my($class, $from, $subject, $to, $desc, $name, $content, $mime) = @_;

  $mime = "plain" if (!$mime);
  my $out =<<EOF;
From: $from
Subject: $subject
To: $to
MIME-Version: 1.0
Content-Type: MULTIPART/mixed; BOUNDARY=Bale_of_Turtles_123_000

--Bale_of_Turtles_123_000
Content-Type: TEXT/plain; charset=us-ascii

$desc

--Bale_of_Turtles_123_000
Content-Type: TEXT/$mime; name="$name"; charset=us-ascii; x-unix-mode=0600
Content-Description: $name

$content

--Bale_of_Turtles_123_000--

EOF

  return $out;
}



1;
