package html;


$SCR1 = "1234567890qwertyuiopasdfghjklzxcvbnm ZXCVBNMLKJHGFDSAQWERTYUIOP".
        "!\@#\$%^&*()-_=+[]{}\\|;':\",.<>/?";
$SCR2 = "mnbvcxzasdfghjklpPLOKMNJIUHBYGVTFCRDXESZWAQoiuytrewq1234567890 ".
        "<>?,./:\";'{}|[]\\+_)(*&^%\$#\@!-=";

for ($x=0; $x < length($SCR1); $x++) {
   $c2 = substr($SCR2,$x,1);
   if ($c2 =~ /\W/) {
      $SCR1[ord(substr($SCR1,$x,1))] = sprintf("%%%X",ord($c2));
   } else {
      $SCR1[ord(substr($SCR1,$x,1))] = $c2;
   }
   $SCR2[ord(substr($SCR2,$x,1))] = substr($SCR1,$x,1);
}


sub scramble {
 my($url) = @_;
 $url =~ s/(.)/$SCR1[ord($1)]/eg;
 return $url;

}
sub unscramble {
 my($url) = @_;
 $url =~ s/(.)/$SCR2[ord($1)]/eg;
 return $url;
}


sub encode {
  local($s) = @_;

  $s =~ s/\%/%25/g;
  $s =~ s/\#/%23/g;
  $s =~ s/\+/%2B/g;
  $s =~ s/ /\+/g;
  $s =~ s/\?/%3F/g;
  $s =~ s/\&/%26/g;
  $s =~ s/\//%2F/g;
  $s;
}

sub encode2 {
  my($s) = @_;
   
  $s =~ s/(\W)/sprintf("%%%x",ord($1))/eg;
  $s;
}

sub decode {
  local($s) = @_;
  $s =~ s/\+/ /g;
  $s =~ s/%([0-9|A-Fa-f]{2})/pack(C,hex($1))/eg;
  $s;
}

sub htmldecode2 {
  local($s) = @_;

  $s =~ s/%23/#/g;
  $s =~ s/%28/\(/g;
  $s =~ s/%29/\)/g;
  $s =~ s/%5B/\[/g;
  $s =~ s/%5D/\]/g;
  $s =~ s/%26/&/g;
  $s =~ s/%2B/+/g;
  $s =~ s/%7C/|/g;
  $s =~ s/%2C/,/g;
  $s =~ s/%3A/:/g;
  $s =~ s/%3F/?/g;
  $s =~ s/%21/\!/g;
  $s =~ s/%2F/\//g;
  $s =~ s/%25/%/g;
  $s =~ s/%24/\$/g;
  $s =~ s/%0D/\015/g;
  $s =~ s/%0A/\012/g;
  $s;
}

sub read_parms {
  my(%q);
  my($agent, $req, $length, $type, $error, $file_name, $file_content, $bound);
  my($query_s, $l);

  $agent =  $ENV{HTTP_USER_AGENT};
  $req   =  $ENV{REQUEST_METHOD};
  $length=  $ENV{CONTENT_LENGTH};
  $type  =  $ENV{CONTENT_TYPE};
  $error =  0;
  if ($req eq "GET") {
      $query_s = $ENV{QUERY_STRING};
      %q = parse($query_s);
  } elsif ($req eq "POST") {
       if ($length =~ /[0-9]+/) {
              $l= read(STDIN, $query_s, $length);
              %q = parse($query_s);  
        } else {
              $error = 1;
        }
  } else {
     $error = 1;
  }
  return ($error, \%q, $query_s);
}

sub read_parms2 {
  my(%q);
  my($agent, $req, $length, $type, $error, $file_name, $file_content, $bound);
  my($query_s);

# select(STDIN) ; $| = 1; select(STDOUT)
  $agent =  $ENV{HTTP_USER_AGENT};
  $req   =  $ENV{REQUEST_METHOD};
  $length=  $ENV{CONTENT_LENGTH};
  $type  =  $ENV{CONTENT_TYPE};
  $error =  0;
  if ($req eq "GET") {
      $query_s = $ENV{QUERY_STRING};
      %q = parse($query_s);
  } else {
      if  ($type =~ /multipart\/form-data/) {
          ($bound) = $type =~ /boundary=(\S+)$/;
          $query_s = read_multipart(\%q,$length, $bound);

      } elsif ($length =~ /[0-9]+/) {
         read(STDIN, $query_s, $length);
         %q = parse($query_s);  
      } else {
         $error = 1;
      }
  }
  return ($error, \%q, $query_s);
}

sub log {
  my($f) = @_;
  open(O,">>LOG"); print O "$f";
  print O "\n############################\n";
  close(O);
}
           

  

sub parse_cookies {
  my($query_s) = @_;
  my(%cks);
  
  foreach (split(/; */,$query_s)) {
     ($NAME,$VALUE) = split(/=/, $_);
     $cks{$NAME} = $VALUE;
  }
  return %cks;
}

sub clear_parse {
  my($query_s) = @_;
  my($cnt, %q);
  
   foreach (split(/&/,$query_s)) {
     ($NAME,$VALUE) = split(/=/, $_);
     $NAME =~ s/\+/ /g;
     $NAME =~ s/%([0-9\.|A-F|a-f]{2})/pack(C,hex($1))/eg;
     
     $VALUE =~ s/\+/ /g;
     $VALUE =~ s/%([0-9|A-F|a-f]{2})/pack(C,hex($1))/eg;
     $q{$NAME} = $VALUE;
  }
  return %q;
}

sub parse {
  my($query_s) = @_;
  my($cnt, %q);
  
   foreach (split(/&/,$query_s)) {
     ($NAME,$VALUE) = split(/=/, $_);
     $NAME =~ s/\+/ /g;
     $NAME =~ s/%([0-9\.|A-F|a-f]{2})/pack(C,hex($1))/eg;
     
     $VALUE =~ s/\+/ /g;
     $VALUE =~ s/%([0-9|A-F|a-f]{2})/pack(C,hex($1))/eg;
     if ($q{$NAME}) {
        $q{$NAME} .= "\t$VALUE";
     } else {
        $q{$NAME} = $VALUE;
     }
     
  }
  return %q;
}



sub main'uu_encode
{
    local(@in) = unpack("C*", $_[0]);
    local(@out);

    push(@in, 0, 0); ## in case we need to round off an odd byte or two
    while (@in >= 3) {
        ##
        ## From the next three input bytes,
        ## construct four encoded output bytes.
        ##
        push(@out, $in[0] >> 2);
        push(@out, (($in[0] << 4) & 060) | (($in[1] >> 4) & 017));
        push(@out, (($in[1] << 2) & 074) | (($in[2] >> 6) & 003));
        push(@out,   $in[2]       & 077);
        splice(@in, 0, 3); ## remove these three
    }

    ##
    ## @out elements are now indices to the string below. Convert to
    ## the appropriate actual text.
    ##
    foreach $new (@out) {
        $new = substr(
          "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
,
          $new, 1);
    }

    if (@in == 2) {
        ## the two left over are the two extra nulls, so we encoded the prop
er
        ## amount as-is.
    } elsif (@in == 1) {
        ## We encoded one extra null too many. Undo it.
        $out[$#out] = '=';
    } else {
        ## We must have encoded two nulls... Undo both.
        $out[$#out   ] = '=';
        $out[$#out -1] = '=';
    }

    join('', @out);
}

sub read_multipart {
 my($q,$total_bytes, $boundary) = @_;

 my($file_name, $file_content, $files_cnt, $query_s);
 my ($package, $boundary_length, $block_size, $previous_block, $byte_count,
        $time, @data_stream, $field_name, $file, $time, $bytes_left,
        $combination, $binary_status, $package, $handle, $eol_chars,$open,$fopen);
 
    $boundary_length = length ($boundary);
    $block_size = $boundary_length * 2;
    $previous_block = undef;
 
    $byte_count = 0;
    $time = time;
 
    while (<STDIN>) {
        $byte_count += length;
        $_ = join ("", $previous_block, $_);
        undef $previous_block;
        $query_s .= $_;
        if (/[Cc]ontent-[Dd]isposition: [^\r\n]+\r{0,1}\n{0,1}/) {
            undef @data_stream;
            $previous_block = $';
 
            ($field_name) = /name="([^"]+)"/;
 
            if ( ($file) = /filename="(\S+)"/) {
                $file_name = substr ($file, rindex ($file, "/") + 1);
            }
       
            unless ($previous_block) {
                while (<STDIN>) {
                    $byte_count += length;
                    last if (/^\s*$/);
                }
            }

            while ($byte_count < $total_bytes) {
                $bytes_left = $total_bytes - $byte_count;
                $block_size = $bytes_left if ($bytes_left < $block_size);
 
                read (STDIN, $_, $block_size);
                $byte_count += $block_size;
 
                $combination = join ("", $previous_block, $_);
 
                if ($combination =~ /\r{0,1}\n{0,1}$boundary/o) {
                    push (@data_stream, $`);
                    $previous_block = $';
                    last;
                } else {
                    push (@data_stream, $previous_block)
                        if (defined($previous_block));
 
                    $previous_block = $_;
                }
            }
            $data_stream[$[] =~ s/^\r{0,1}\n{0,1}//;
            $data_stream[$#data_stream] =~ s/\r{0,1}\n{0,1}--//;
 
            if (defined ($file)) {
                $q->{$field_name}[0] = $file;
                if (!$open) {
                   $open = 1;
                   $fopen = "/tmp/UPLOAD$field_name$$" . time;
                   $q->{$field_name}[1] = $fopen;
                   open(MULTI_O,">$fopen");
                }
                print MULTI_O join("", @data_stream);
            } else {
                $q->{$field_name} = join ("", @data_stream);
            }
        }
        last if ($byte_count >= $total_bytes);
    }
    close(MULTI_O) if ($open);
    return $query_s;
}


1;
